#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include "../include/complex.hpp"

void Abort(int line,char*format,...)
  {
  va_list arg_marker;
  va_start(arg_marker,format);
  fprintf(stderr,"\nerror %i: ",line);
  vfprintf(stderr,format,arg_marker);
  fprintf(stderr,"\n");
  _fcloseall();
  exit(1);
  }

void Surface(complex f(complex),int i,double x1,double x2,double y1,double y2,int nx,int ny,char*fname)
  {
  int x,y;
  complex w,z;
  FILE*fp;
  printf("creating surface: %s\n",fname);
  if((fp=fopen(fname,"wt"))==NULL)
    Abort(__LINE__,"can't create output file");
  fprintf(fp,"%i nx\n",nx);
  for(x=0;x<nx;x++)
    {
    z.re=x1+x*(x2-x1)/(nx-1);
    fprintf(fp,"%lG\n",z.re);
    }
  fprintf(fp,"%i ny\n",ny);
  for(y=0;y<ny;y++)
    {
    z.im=y1+y*(y2-y1)/(ny-1);
    fprintf(fp,"%lG\n",z.im);
    }
  fprintf(fp,"%i nz=nx*ny\n",nx*ny);
  for(y=0;y<ny;y++)
    {
    z.im=y1+y*(y2-y1)/(ny-1);
    for(x=0;x<nx;x++)
      {
      z.re=x1+x*(x2-x1)/(nx-1);
      w=f(z);
      fprintf(fp,"%lG\n",i?w.im:w.re);
      }
    }
  fclose(fp);
  }

int main(int argc,char**argv,char**envp)
  {
  Surface(LambertW,0,-5.,5.,-5.,5.,100,100,"Lambert-W_real.tb2");
  Surface(LambertW,1,-5.,5.,-5.,5.,100,100,"Lambert-W_imaginary.tb2");
  return(0);
  }
