/* Schwarz-Christoffel transformation examples
   dudley.benton@gmail.com */

/* case can be 1 or 2 */
#define case 2

#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include "../include/complex.hpp"

complex func(complex z)
  {
  static complex w;
#if(case==1)
  w=(sqrt(z*z-1.)+log(z+sqrt(z*z-1.)))/M_PI;
  if(z.re<0.)
    w=-w;
  w-=I;
  if(w.re<0.)
    if(w.im<0.)
      w.im=0.;
#elif(case==2)
  w=(3.-4.*z)*sqrt(4.*z)*I/2.;
#else
#error unexpected case
#endif
  return(w);
  }

void CreateP2D(char*fname,int m,int n)
  {
  int i,j;
  complex w,z;
  FILE*fp;
  fp=fopen(fname,"wt");
  for(i=0;i<m;i++)
    {
    fprintf(fp,"POLY rgb=0xFF0000\n");
    z.im=i*M_PI/(m-1);
    for(j=0;j<n;j++)
      {
      z.re=-2.*M_PI+j*4.*M_PI/(n-1);
      w=func(z);
      fprintf(fp,"%lG %lG\n",w.re,w.im);
      }
    fprintf(fp,"END\n");
    }
  for(j=0;j<n;j++)
    {
    fprintf(fp,"POLY rgb=0x0000FF\n");
    z.re=-2.*M_PI+j*4.*M_PI/(n-1);
    for(i=0;i<m;i++)
      {
      z.im=i*M_PI/(m-1);
      w=func(z);
      fprintf(fp,"%lG %lG\n",w.re,w.im);
      }
    fprintf(fp,"END\n");
    }
  fclose(fp);
  }

int main(int argc,char**argv,char**envp)
  {
  CreateP2D("schwarz.p2d",50,50);
  return(0);
  }
