#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <stdlib.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include "../include/complex.hpp"

double fmin(double x,double y)
  {
  if(x<y)
    return(x);
  return(y);
  }

double fmax(double x,double y)
  {
  if(x>y)
    return(x);
  return(y);
  }

double trunc(double f)
  {
  double x;
  f=modf(f,&x);
  return(x);
  }

complex wpl(complex z) /* lemniscatic Weierstrass elliptical function */
  {
  double dm,dn,zi,zr;
  complex xtmp,ytmp,z2,z4,ztmp;
  static complex w;
  zr=z.re+0.5;
  zi=z.im+0.5;
  dm=trunc(zr);
  dn=trunc(zi);
  if(zr<0.)
    dm-=1.;
  if(zi<0.)
    dn-=1.;
  z2.re=z.re-dm;
  z2.im=z.im-dn;
  if(z2.re!=0.||z2.im!=0.)
    {
    xtmp.re=z2.re*z2.re-z2.im*z2.im;
    xtmp.im=z2.re*z2.im+z2.re*z2.im;
    z2.re=xtmp.re;
    z2.im=xtmp.im;
    z4.re=z2.re*z2.re-z2.im*z2.im;
    z4.im=z2.re*z2.im+z2.re*z2.im;
    w.re=(1.*z2.re+0.*z2.im)/(z2.re*z2.re+z2.im*z2.im);
    w.im=(z2.re*0.-1.*z2.im)/(z2.re*z2.re+z2.im*z2.im);
    xtmp.re=1.-z4.re;
    xtmp.im=-z4.im;
    ztmp.re=xtmp.re*xtmp.re-xtmp.im*xtmp.im;
    ztmp.im=xtmp.re*xtmp.im+xtmp.re*xtmp.im;
    ytmp.re=3.+z4.re;
    ytmp.im=z4.im;
    xtmp.re=ytmp.re*z2.re-ytmp.im*z2.im;
    xtmp.im=ytmp.re*z2.im+z2.re*ytmp.im;
    ytmp.re=4.*xtmp.re;
    ytmp.im=4.*xtmp.im;
    xtmp.re=(ytmp.re*ztmp.re+ytmp.im*ztmp.im)/(ztmp.re*ztmp.re+ztmp.im*ztmp.im);
    xtmp.im=(ztmp.re*ytmp.im-ytmp.re*ztmp.im)/(ztmp.re*ztmp.re+ztmp.im*ztmp.im);
    w.re+=xtmp.re;
    w.im+=xtmp.im;
    ytmp.re=-7.233108E-11*z4.re+1.714197273E-8;
    ytmp.im=-7.233108E-11*z4.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)-2.5369036492E-7;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)-7.98710206868E-6;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)+6.4850606909737E-4;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+7.39624629362938E-3;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)+2.012382768497244E-2;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+7.117729754313660E-1;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)-2.546363993538307;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    xtmp.re=ztmp.re;
    xtmp.im=ztmp.im;
    ztmp.re=5.1161516E-10*z4.re+6.61289408E-9;
    ztmp.im=5.1161516E-10*z4.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+4.4618987048E-7;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)-8.42694918892E-6;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+4.42886829095E-6;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)-4.22629935217101E-3;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+2.577496871700433E-2;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)+4.235994048227707E-1;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+1.;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(xtmp.re*ytmp.re+xtmp.im*ytmp.im)/(ytmp.re*ytmp.re+ytmp.im*ytmp.im);
    ztmp.im=(ytmp.re*xtmp.im-xtmp.re*ytmp.im)/(ytmp.re*ytmp.re+ytmp.im*ytmp.im);
    ytmp.re=ztmp.re*z2.re-ztmp.im*z2.im;
    ytmp.im=ztmp.re*z2.im+z2.re*ztmp.im;
    w.re+=ytmp.re;
    w.im+=ytmp.im;
    }
  else
    w.re=w.im=FLT_MAX;
  return(w);
  }

complex dwpl(complex z) /* first derivative of the lemniscatic Weierstrass elliptical function */
  {
  double dm,dn,zi,zr;
  complex qtmp,xtmp,ytmp,z1,z3,z4,ztmp;
  static complex w;
  zr=z.re+0.5;
  zi=z.im+0.5;
  dm=trunc(zr);
  dn=trunc(zi);
  if(zr<0.)
    dm-=1.;
  if(zi<0.)
    dn-=1.;
  z1.re=z.re-dm;
  z1.im=z.im-dn;
  if(z1.re!=0.||z1.im!=0.)
    {
    z3.re=z1.re*z1.re-z1.im*z1.im;
    z3.im=z1.re*z1.im+z1.re*z1.im;
    ztmp.re=z3.re*z1.re-z3.im*z1.im;
    ztmp.im=z3.re*z1.im+z1.re*z3.im;
    z3.re=ztmp.re;
    z3.im=ztmp.im;
    z4.re=z3.re*z1.re-z3.im*z1.im;
    z4.im=z3.re*z1.im+z1.re*z3.im;
    w.re=10.*z4.re+90.;
    w.im=10.*z4.im;
    ztmp.re=w.re*z4.re-w.im*z4.im;
    ztmp.im=w.re*z4.im+z4.re*w.im;
    w.re=ztmp.re+30.;
    w.im=ztmp.im;
    ztmp.re=w.re*z4.re-w.im*z4.im;
    ztmp.im=w.re*z4.im+z4.re*w.im;
    w.re=ztmp.re-2.;
    w.im=ztmp.im;
    ztmp.re=1.-z4.re;
    ztmp.im=-z4.im;
    ytmp.re=ztmp.re*z1.re-ztmp.im*z1.im;
    ytmp.im=ztmp.re*z1.im+z1.re*ztmp.im;
    ztmp.re=ytmp.re*ytmp.re-ytmp.im*ytmp.im;
    ztmp.im=ytmp.re*ytmp.im+ytmp.re*ytmp.im;
    xtmp.re=ztmp.re*ytmp.re-ztmp.im*ytmp.im;
    xtmp.im=ztmp.re*ytmp.im+ytmp.re*ztmp.im;
    ztmp.re=-3.9046302E-9*z4.re-1.001487137E-8;
    ztmp.im=-3.9046302E-9*z4.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+5.9573043092E-7;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)-2.482518130524E-5;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+1.4557266595395E-4;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)+4.56633655643206E-3;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+6.224782572111135E-2;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)+1.038527937794269E-2;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+1.198046208026379;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)+6.427914396838117;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)-5.092727987076615;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    qtmp.re=ytmp.re*z1.re-ytmp.im*z1.im;
    qtmp.im=ytmp.re*z1.im+z1.re*ytmp.im;
    ztmp.re=4.726888E-11*z4.re-3.0667983E-9;
    ztmp.im=4.726888E-11*z4.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+1.0087596089E-7;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)-8.060683451E-8;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+1.184299251664E-5;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)-2.3096723361547E-4;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)-2.90730903142055E-3;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)+1.338392411135511E-2;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+2.309863932002143E-1;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(ytmp.re*z4.re-ytmp.im*z4.im)+8.471988096455415E-1;
    ztmp.im=ytmp.re*z4.im+z4.re*ytmp.im;
    ytmp.re=(ztmp.re*z4.re-ztmp.im*z4.im)+1.;
    ytmp.im=ztmp.re*z4.im+z4.re*ztmp.im;
    ztmp.re=(w.re*xtmp.re+w.im*xtmp.im)/(xtmp.re*xtmp.re+xtmp.im*xtmp.im);
    ztmp.im=(xtmp.re*w.im-w.re*xtmp.im)/(xtmp.re*xtmp.re+xtmp.im*xtmp.im);
    xtmp.re=(qtmp.re*ytmp.re+qtmp.im*ytmp.im)/(ytmp.re*ytmp.re+ytmp.im*ytmp.im);
    xtmp.im=(ytmp.re*qtmp.im-qtmp.re*ytmp.im)/(ytmp.re*ytmp.re+ytmp.im*ytmp.im);
    w.re=ztmp.re+xtmp.re;
    w.im=ztmp.im+xtmp.im;
    }
  else
    w.re=w.im=FLT_MAX;
  return(w);
  }

complex wpe(complex z) /* equianharmonic Weierstrass elliptical function */
  {
  double dm,dn,zi,zr;
  complex ptmp,xtmp,z2,z4,z6,ztmp;
  static complex w;
  zi=1.154700538379252*z.im+0.5;
  dm=trunc(zi);
  if(zi<0.)
    dm-=1.;
  zr=z.re-0.5*dm+0.5;
  dn=trunc(zr);
  if(zr<0.)
    dn-=1.;
  z2.re=z.re-dn-0.5*dm;
  z2.im=z.im-dm*0.8660254037844387;
  if(z2.re!=0.||z2.im!=0.)
    {
    xtmp.re=z2.re*z2.re-z2.im*z2.im;
    xtmp.im=z2.re*z2.im+z2.re*z2.im;
    z2.re=xtmp.re;
    z2.im=xtmp.im;
    xtmp.re=z2.re*z2.re-z2.im*z2.im;
    xtmp.im=z2.re*z2.im+z2.re*z2.im;
    z4.re=xtmp.re;
    z4.im=xtmp.im;
    z6.re=z4.re*z2.re-z4.im*z2.im;
    z6.im=z4.re*z2.im+z2.re*z4.im;
    xtmp.re=((-2.6427662E-10)*z6.re-0.*z6.im)+1.610954818E-8;
    xtmp.im=(-2.6427662E-10)*z6.im+z6.re*0.;
    ztmp.re=(xtmp.re*z6.re-xtmp.im*z6.im)+7.38610752879E-6;
    ztmp.im=xtmp.re*z6.im+z6.re*xtmp.im;
    xtmp.re=(ztmp.re*z6.re-ztmp.im*z6.im)+4.3991444671178E-4;
    xtmp.im=ztmp.re*z6.im+z6.re*ztmp.im;
    ztmp.re=(xtmp.re*z6.re-xtmp.im*z6.im)+7.477288220490697E-2;
    ztmp.im=xtmp.re*z6.im+z6.re*xtmp.im;
    xtmp.re=(ztmp.re*z6.re-ztmp.im*z6.im)-6.848415328729920E-1;
    xtmp.im=ztmp.re*z6.im+z6.re*ztmp.im;
    w.re=xtmp.re;
    w.im=xtmp.im;
    xtmp.re=((6.2252191E-10)*z6.re-0.*z6.im)+2.553314573E-7;
    xtmp.im=(6.2252191E-10)*z6.im+z6.re*0.;
    ztmp.re=(xtmp.re*z6.re-xtmp.im*z6.im)-2.619832920421E-5;
    ztmp.im=xtmp.re*z6.im+z6.re*xtmp.im;
    xtmp.re=(ztmp.re*z6.re-ztmp.im*z6.im)-5.6444801847646E-4;
    xtmp.im=ztmp.re*z6.im+z6.re*ztmp.im;
    ztmp.re=(xtmp.re*z6.re-xtmp.im*z6.im)+4.565553484820106E-2;
    ztmp.im=xtmp.re*z6.im+z6.re*xtmp.im;
    xtmp.re=(ztmp.re*z6.re-ztmp.im*z6.im)+1.;
    xtmp.im=ztmp.re*z6.im+z6.re*ztmp.im;
    ptmp.re=(w.re*xtmp.re+w.im*xtmp.im)/(xtmp.re*xtmp.re+xtmp.im*xtmp.im);
    ptmp.im=(xtmp.re*w.im-w.re*xtmp.im)/(xtmp.re*xtmp.re+xtmp.im*xtmp.im);
    w.re=ptmp.re*z4.re-ptmp.im*z4.im;
    w.im=ptmp.re*z4.im+z4.re*ptmp.im;
    ptmp.re=1.-z6.re;
    ptmp.im=-z6.im;
    xtmp.re=ptmp.re*ptmp.re-ptmp.im*ptmp.im;
    xtmp.im=ptmp.re*ptmp.im+ptmp.re*ptmp.im;
    ptmp.re=5.+z6.re;
    ptmp.im=z6.im;
    ztmp.re=ptmp.re*z4.re-ptmp.im*z4.im;
    ztmp.im=ptmp.re*z4.im+z4.re*ptmp.im;
    ztmp.re*=6.;
    ztmp.im*=6.;
    ptmp.re=(ztmp.re*xtmp.re+ztmp.im*xtmp.im)/(xtmp.re*xtmp.re+xtmp.im*xtmp.im);
    ptmp.im=(xtmp.re*ztmp.im-ztmp.re*xtmp.im)/(xtmp.re*xtmp.re+xtmp.im*xtmp.im);
    ztmp.re=(1.*z2.re+0.*z2.im)/(z2.re*z2.re+z2.im*z2.im);
    ztmp.im=(z2.re*0.-1.*z2.im)/(z2.re*z2.re+z2.im*z2.im);
    ztmp.re+=ptmp.re;
    ztmp.im+=ptmp.im;
    w.re+=ztmp.re;
    w.im+=ztmp.im;
    }
  else
    w.re=w.im=FLT_MAX;
  return(w);
  }

complex dwpe(complex z) /* first derivative of the equianharmonic Weierstrass elliptical function */
  {
  double dm,dn,zi,zr;
  complex ptmp,xtmp,ytmp,z3,z6,ztmp;
  static complex w;
  zi=1.154700538379252*z.im+0.5;
  dm=trunc(zi);
  if(zi<0.)
    dm-=1.;
  zr=z.re-0.5*dm+0.5;
  dn=trunc(zr);
  if(zr<0.)
    dn-=1.;
  z3.re=z.re-dn-0.5*dm;
  z3.im=z.im-dm*0.8660254037844387;
  if(z3.re!=0.||z3.im!=0.)
    {
    xtmp.re=z3.re*z3.re-z3.im*z3.im;
    xtmp.im=z3.re*z3.im+z3.re*z3.im;
    ztmp.re=xtmp.re*z3.re-xtmp.im*z3.im;
    ztmp.im=xtmp.re*z3.im+z3.re*xtmp.im;
    z3.re=ztmp.re;
    z3.im=ztmp.im;
    z6.re=z3.re*z3.re-z3.im*z3.im;
    z6.im=z3.re*z3.im+z3.re*z3.im;
    xtmp.re=((-2.95539175E-9)*z6.re-0.*z6.im)-2.6764693031E-7;
    xtmp.im=(-2.95539175E-9)*z6.im+z6.re*0.;
    ztmp.re=(xtmp.re*z6.re-xtmp.im*z6.im)+2.402192743346E-5;
    ztmp.im=xtmp.re*z6.im+z6.re*xtmp.im;
    xtmp.re=(ztmp.re*z6.re-ztmp.im*z6.im)+1.9656661451391E-4;
    xtmp.im=ztmp.re*z6.im+z6.re*ztmp.im;
    ztmp.re=(xtmp.re*z6.re-xtmp.im*z6.im)+1.760135529461036E-2;
    ztmp.im=xtmp.re*z6.im+z6.re*xtmp.im;
    xtmp.re=(ztmp.re*z6.re-ztmp.im*z6.im)+8.102624349882264E-1;
    xtmp.im=ztmp.re*z6.im+z6.re*ztmp.im;
    ztmp.re=(xtmp.re*z6.re-xtmp.im*z6.im)-2.739366131491968;
    ztmp.im=xtmp.re*z6.im+z6.re*xtmp.im;
    ptmp.re=ztmp.re;
    ptmp.im=ztmp.im;
    xtmp.re=((4.6397763E-10)*z6.re-0.*z6.im)+5.413482233E-8;
    xtmp.im=(4.6397763E-10)*z6.im+z6.re*0.;
    ztmp.re=(xtmp.re*z6.re-xtmp.im*z6.im)-1.56293298374E-6;
    ztmp.im=xtmp.re*z6.im+z6.re*xtmp.im;
    xtmp.re=(ztmp.re*z6.re-ztmp.im*z6.im)-1.0393701076352E-4;
    xtmp.im=ztmp.re*z6.im+z6.re*ztmp.im;
    ztmp.re=(xtmp.re*z6.re-xtmp.im*z6.im)+9.5553182532237E-4;
    ztmp.im=xtmp.re*z6.im+z6.re*xtmp.im;
    xtmp.re=(ztmp.re*z6.re-ztmp.im*z6.im)+9.131106969640212E-2;
    xtmp.im=ztmp.re*z6.im+z6.re*ztmp.im;
    ztmp.re=(xtmp.re*z6.re-xtmp.im*z6.im)+1.;
    ztmp.im=xtmp.re*z6.im+z6.re*xtmp.im;
    ytmp.re=(ptmp.re*ztmp.re+ptmp.im*ztmp.im)/(ztmp.re*ztmp.re+ztmp.im*ztmp.im);
    ytmp.im=(ztmp.re*ptmp.im-ptmp.re*ztmp.im)/(ztmp.re*ztmp.re+ztmp.im*ztmp.im);
    w.re=ytmp.re*z3.re-ytmp.im*z3.im;
    w.im=ytmp.re*z3.im+z3.re*ytmp.im;
    xtmp.re=1.-z6.re;
    xtmp.im=-z6.im;
    ytmp.re=xtmp.re*xtmp.re-xtmp.im*xtmp.im;
    ytmp.im=xtmp.re*xtmp.im+xtmp.re*xtmp.im;
    ztmp.re=xtmp.re*ytmp.re-xtmp.im*ytmp.im;
    ztmp.im=xtmp.re*ytmp.im+ytmp.re*xtmp.im;
    xtmp.re=ztmp.re*z3.re-ztmp.im*z3.im;
    xtmp.im=ztmp.re*z3.im+z3.re*ztmp.im;
    ytmp.re=(14.*z6.re-0.*z6.im)+294.;
    ytmp.im=14.*z6.im+z6.re*0.;
    ztmp.re=(ytmp.re*z6.re-ytmp.im*z6.im)+126.;
    ztmp.im=ytmp.re*z6.im+z6.re*ytmp.im;
    ytmp.re=(ztmp.re*z6.re-ztmp.im*z6.im)-2.;
    ytmp.im=ztmp.re*z6.im+z6.re*ztmp.im;
    ztmp.re=(ytmp.re*xtmp.re+ytmp.im*xtmp.im)/(xtmp.re*xtmp.re+xtmp.im*xtmp.im);
    ztmp.im=(xtmp.re*ytmp.im-ytmp.re*xtmp.im)/(xtmp.re*xtmp.re+xtmp.im*xtmp.im);
    w.re+=ztmp.re;
    w.im+=ztmp.im;
    }
  else
    w.re=w.im=FLT_MAX;
  return(w);
  }

double clamp=4.;
double Sm,Sx;

void CreateTB2(complex f(complex),char*rname,char*iname)
  {
  int i,j,m=64,n=64;
  complex w,z;
  FILE*fr,*fi;
  printf("creating: %s\n",rname);
  fr=fopen(rname,"wt");
  printf("creating: %s\n",iname);
  fi=fopen(iname,"wt");
  fprintf(fr,"%i\n",n);
  fprintf(fi,"%i\n",n);
  for(i=0;i<n;i++)
    {
    z.re=(i+1)*1./(n+1);
    fprintf(fr,"%lG\n",z.re);
    fprintf(fi,"%lG\n",z.re);
    }
  fprintf(fr,"%i\n",m);
  fprintf(fi,"%i\n",m);
  for(j=0;j<m;j++)
    {
    z.im=(j+1)*1./(m+1);
    fprintf(fr,"%lG\n",z.im);
    fprintf(fi,"%lG\n",z.im);
    }
  Sm=DBL_MAX;
  Sx=-DBL_MAX;
  fprintf(fr,"%i\n",n*m);
  fprintf(fi,"%i\n",n*m);
  for(j=0;j<m;j++)
    {
    z.im=(j+1)*1./(m+1);
    for(i=0;i<n;i++)
      {
      z.re=(i+1)*1./(n+1);
      w=f(z);
      if(w.re<-clamp)
        w.re=-clamp;
      if(w.re>clamp)
        w.re=clamp;
      if(w.im<-clamp)
        w.im=-clamp;
      if(w.im>clamp)
        w.im=clamp;
      Sm=fmin(Sm,fmin(w.re,w.im));
      Sx=fmax(Sx,fmin(w.re,w.im));
      fprintf(fr,"%lG\n",w.re);
      fprintf(fi,"%lG\n",w.im);
      }
    }
  fclose(fr);
  fclose(fi);
  }

void CreateTP2(char*title,char*name,char*rname,char*iname)
  {
  FILE*fp;
  printf("creating file: %s\n",name);
  fp=fopen(name,"wt");
  fprintf(fp,"TP2\n");
  fprintf(fp,"!ALTER\n");
  fprintf(fp,"!PLOT\n");
  fprintf(fp,"EQUAL\n");
  fprintf(fp,"TICKS\n");
  fprintf(fp,"LEGENDS\n");
  fprintf(fp,"-1 5 2\n");
  fprintf(fp,"RAINBOW\n");
  fprintf(fp,"CONTOUR\n");
  fprintf(fp,"%lG 0 %lG\n",Sm,Sx);
  fprintf(fp,"NOLEGEND 126\n");
  fprintf(fp,"ZTABLE\n");
  fprintf(fp,"CENTER\n");
  fprintf(fp,"ABOVE\n");
  fprintf(fp,"%s\n",title);
  fprintf(fp,"X\n");
  fprintf(fp,"0 1\n");
  fprintf(fp,"Y\n");
  fprintf(fp,"0 1\n");
  fprintf(fp,"%s\n",rname);
  fprintf(fp,"NEWFILE 2\n");
  fprintf(fp,"%s\n",iname);
  fprintf(fp,"!END\n");
  fclose(fp);
  }

int main(int argc,char**argv,char**envp)
  {
#ifdef csv
  int i,j,m=10,n=10;
  complex dp,dq,p,q,z;
  for(i=1;i<=n;i++)
    {
    z.im=i*1./(n+1);
    for(j=1;j<=m;j++)
      {
      z.re=j*1./(m+1);
      p=wpl(z);
      dp=dwpl(z);
      q=wpe(z);
      dq=wpe(z);
      printf("(%lG,%lG)",z.re,z.im);
      printf(",(%lG,%lG)",p.re,p.im);
      printf(",(%lG,%lG)",dp.re,dp.im);
      printf(",(%lG,%lG)",q.re,q.im);
      printf(",(%lG,%lG)\n",dq.re,dq.im);
      }
    }
#else
  CreateTB2(wpl,"wplr.tb2","wpli.tb2");
  CreateTP2("wpl(z)","wpl.tp2","wplr.tb2","wpli.tb2");
  CreateTB2(wpe,"wper.tb2","wpei.tb2");
  CreateTP2("wpe(z)","wpe.tp2","wper.tb2","wpei.tb2");
#endif
  return(0);
  }
