/* A/C circuit example 1 (series)
   dudley.benton@gmail.com */

#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include "../include/complex.hpp"

double omega=2.*M_PI*60.;
double R=100.;
double C=0.00002;
double L=0.5;
double b=1.;

double i(double t)
  {
  complex i=b*exp(I*omega*t);
  return(i.re);
  }

double vR(double t)
  {
  complex v=b*R*exp(I*omega*t);
  return(v.re);
  }

double vL(double t)
  {
  complex v=b*omega*L*exp(I*omega*t-I*M_PI/2.);
  return(v.re);
  }

double vC(double t)
  {
  complex v=b/omega/C*exp(I*omega*t+I*M_PI/2.);
  return(v.re);
  }

int main(int argc,char**argv,char**envp)
  {
  double t;
  for(t=0.;t<=1./30.;t+=0.0001)
    printf("%lG,%lG,%lG,%lG,%lG,%lG\n",t,i(t),vR(t),vC(t),vL(t),vR(t)+vC(t)+vL(t));
  return(0);
  }
