#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <malloc.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

void Abort(int line,char*format,...)
  {
  va_list arg_marker;
  va_start(arg_marker,format);
  fprintf(stderr,"\nerror %i: ",line);
  vfprintf(stderr,format,arg_marker);
  fprintf(stderr,"\n");
  _fcloseall();
  exit(1);
  }

DWORD Palette[]={
  0x000000,0x0000FF,0x0008FF,0x0010FF,0x0018FF,0x0020FF,0x0028FF,0x0030FF,
  0x0038FF,0x0040FF,0x0048FF,0x0050FF,0x0058FF,0x0060FF,0x0068FF,0x0070FF,
  0x0078FF,0x0080FF,0x0088FF,0x0090FF,0x0098FF,0x00A0FF,0x00A8FF,0x00B0FF,
  0x00B8FF,0x00C0FF,0x00C8FF,0x00D0FF,0x00D8FF,0x00E0FF,0x00E8FF,0x00F0FF,
  0x00F8FF,0x00FFFF,0x00FFF8,0x00FFF0,0x00FFE8,0x00FFE0,0x00FFD8,0x00FFD0,
  0x00FFC8,0x00FFC0,0x00FFB8,0x00FFB0,0x00FFA8,0x00FFA0,0x00FF98,0x00FF90,
  0x00FF88,0x00FF80,0x00FF78,0x00FF70,0x00FF68,0x00FF60,0x00FF58,0x00FF50,
  0x00FF48,0x00FF40,0x00FF38,0x00FF30,0x00FF28,0x00FF20,0x00FF18,0x00FF10,
  0x00FF08,0x00FF00,0x08FF00,0x10FF00,0x18FF00,0x20FF00,0x28FF00,0x30FF00,
  0x38FF00,0x40FF00,0x48FF00,0x50FF00,0x58FF00,0x60FF00,0x68FF00,0x70FF00,
  0x78FF00,0x80FF00,0x88FF00,0x90FF00,0x98FF00,0xA0FF00,0xA8FF00,0xB0FF00,
  0xB8FF00,0xC0FF00,0xC8FF00,0xD0FF00,0xD8FF00,0xE0FF00,0xE8FF00,0xF0FF00,
  0xF8FF00,0xFFFF00,0xFFF800,0xFFF000,0xFFE800,0xFFE000,0xFFD800,0xFFD000,
  0xFFC800,0xFFC000,0xFFB800,0xFFB000,0xFFA800,0xFFA000,0xFF9800,0xFF9000,
  0xFF8800,0xFF8000,0xFF7800,0xFF7000,0xFF6800,0xFF6000,0xFF5800,0xFF5000,
  0xFF4800,0xFF4000,0xFF3800,0xFF3000,0xFF2800,0xFF2000,0xFF1800,0xFF1000,
  0xFF0800,0xFF0000,0xFF0008,0xFF0010,0xFF0018,0xFF0020,0xFF0028,0xFF0030,
  0xFF0038,0xFF0040,0xFF0048,0xFF0050,0xFF0058,0xFF0060,0xFF0068,0xFF0070,
  0xFF0078,0xFF0080,0xFF0088,0xFF0090,0xFF0098,0xFF00A0,0xFF00A8,0xFF00B0,
  0xFF00B8,0xFF00C0,0xFF00C8,0xFF00D0,0xFF00D8,0xFF00E0,0xFF00E8,0xFF00F0,
  0xFF00F8,0xFF00FF,0xFFFFFF};
DWORD colors=sizeof(Palette)/sizeof(DWORD);

void Create(int f(int,int),int wide,int high,char*fname)
  {
  int a,b,h,r,w;
  BITMAPFILEHEADER bf;
  BITMAPINFOHEADER bi;
  BYTE*bits;
  FILE*fp;
  while(wide%8)
    wide++;
  a=wide/2;
  b=high/2;
  r=min(a,b);
  printf("creating map: %ix%i\n",wide,high);
  if((bits=(BYTE*)calloc(wide*high,1))==NULL)
    Abort(__LINE__,"can't allocate memory");
  for(h=0;h<high;h++)
    for(w=0;w<wide;w++)
      if((w-a)*(w-a)+(h-b)*(h-b)<=r*r)
        bits[wide*h+w]=(BYTE)(1+f(w-a,h-b)%(colors-2));
  printf("writing bitmap to file: %s\n",fname);
  memset(&bf,0,sizeof(bf));
  memset(&bi,0,sizeof(bi));
  bi.biWidth=wide;
  bi.biHeight=high;
  bi.biSize=sizeof(BITMAPINFOHEADER);
  bi.biPlanes=1;
  bi.biBitCount=8;
  bi.biSizeImage=bi.biHeight*bi.biWidth;
  bi.biClrUsed=bi.biClrImportant=colors;
  if((fp=fopen(fname,"wb"))==NULL)
    Abort(__LINE__,"can't create output file");
  bf.bfType=0x4D42;
  bf.bfOffBits=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+sizeof(Palette);
  bf.bfSize=bf.bfOffBits+bi.biSizeImage;
  fwrite(&bf,1,sizeof(bf),fp);
  fwrite(&bi,1,sizeof(bi),fp);
  fwrite(Palette,1,sizeof(Palette),fp);
  fwrite(bits,1,bi.biSizeImage,fp);
  fclose(fp);
  free(bits);
  }

int f1(int x,int y)
  {
  return((x*x+x*y+y*y)/2);
  }

int f2(int x,int y)
  {
  return((int)(x/exp(-abs(y)/128.)+y/exp(-abs(x)/128.)));
  }

int f3(int x,int y)
  {
  return((x*x*x-y*y*y)/65536);
  }

int f4(int x,int y)
  {
  return((x*x+4*x*y+y*y)/2048);
  }

int f5(int x,int y)
  {
  return((int)sqrt(fabs(x*x+y*y)/2));
  }

int f6(int x,int y)
  {
  return((int)sqrt(fabs(x*x-y*y)/3));
  }

int f7(int x,int y)
  {
  return((int)(64.*log(fabs((x+x*y+y)))));
  }

int f8(int x,int y)
  {
  return((int)((x+y)*cos((x+y)/256.)));
  }

int main(int argc,char**argv,char**envp)
  {
  Create(f1,800,800,"f1.bmp");
  Create(f2,800,800,"f2.bmp");
  Create(f3,800,800,"f3.bmp");
  Create(f4,800,800,"f4.bmp");
  Create(f5,800,800,"f5.bmp");
  Create(f6,800,800,"f6.bmp");
  Create(f7,800,800,"f7.bmp");
  Create(f8,800,800,"f8.bmp");
  return(0);
  }
    