/* second order polynomial
   dudley.benton@gmail.com */

#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include "../include/complex.hpp"

complex f(complex z)
  {
  return(z*z-2.*z+2.);
  }

double fn(complex z)
  {
  return(norm(f(z)));
  }

void CreateTB2(char*fname,int m,int n)
  {
  int i,j;
  complex z;
  FILE*fp;
  printf("transformation: %s\n",fname);
  fp=fopen(fname,"wt");
  fprintf(fp,"%i\n",n);
  for(i=0;i<n;i++)
    {
    z.re=-2.+i*6./(n-1);
    fprintf(fp,"%lG\n",z.re);
    }
  fprintf(fp,"%i\n",m);
  for(j=0;j<m;j++)
    {
    z.im=-2.+j*4./(m-1);
    fprintf(fp,"%lG\n",z.im);
    }
  fprintf(fp,"%i\n",n*m);
  for(j=0;j<m;j++)
    {
    z.im=-2.+j*4./(m-1);
    for(i=0;i<n;i++)
      {
      z.re=-2.+i*6./(n-1);
      fprintf(fp,"%lG\n",fn(z));
      }
    }
  fclose(fp);
  }

int Secant(complex guess,double convergence,int list)
  {
  int i;
  complex f1,f2,x1,x2,x3;
  i=1;
  x1=guess;
  f2=f(x1);
  if(list)
    printf("%i %lG%+lGi %lG%+lGi\n",i,x1.re,x1.im,f2.re,f2.im);
  x2=x1-f2;
  while(++i<=99)
    {
    f1=f2;
    f2=f(x2);
    if(list)
      printf("%i %lG%+lGi %lG%+lGi\n",i,x2.re,x2.im,f2.re,f2.im);
    if(abs(f2)<=convergence)
      break;
    x3=(x1*f2-x2*f1)/(f2-f1);
    x1=x2;
    x2=x3;
    }
  return(i);
  }

void SecantMap(char*fname,int m,int n)
  {
  int i,j;
  complex z;
  FILE*fp;
  fp=fopen(fname,"wt");
  fprintf(fp,"%i\n",m);
  for(j=0;j<m;j++)
    {
    z.re=-2.+j*4./(m-1);
    fprintf(fp,"%lG\n",z.re);
    }
  fprintf(fp,"%i\n",n);
  for(i=0;i<n;i++)
    {
    z.im=-2.+i*4./(n-1);
    fprintf(fp,"%lG\n",z.im);
    }
  fprintf(fp,"%i\n",m*n);
  for(i=0;i<n;i++)
    {
    z.im=-2.+i*4./(n-1);
    for(j=0;j<m;j++)
      {
      z.re=-2.+j*4./(m-1);
      fprintf(fp,"%i\n",Secant(z,DBL_EPSILON,0));
      }
    }
  fclose(fp);
  }

int main(int argc,char**argv,char**envp)
  {
  complex z;
  CreateTB2("root1a.tb2",64,64);
//z.re=z.im=0.5;
//Secant(z,DBL_EPSILON,1);
//SecantMap("root1.tb2",50,50);
  return(0);
  }
