/* fourth order polynomial
   dudley.benton@gmail.com */

#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include "../include/complex.hpp"

complex r1( 1., 1.);
complex r2(-1., 1.);
complex r3( 1.,-1.);
complex r4(-1.,-1.);

complex f(complex z)
  {
  return((z-r1)*(z-r2)*(z-r3)*(z-r4));
  }

double fn(complex z)
  {
  return(norm(f(z)));
  }

void CreateTB2(char*fname,int m,int n)
  {
  int i,j;
  complex w,z;
  FILE*fp;
  printf("transformation: %s\n",fname);
  fp=fopen(fname,"wt");
  fprintf(fp,"%i\n",n);
  for(i=0;i<n;i++)
    {
    z.re=-2.+i*4./(n-1);
    fprintf(fp,"%lG\n",z.re);
    }
  fprintf(fp,"%i\n",m);
  for(j=0;j<m;j++)
    {
    z.im=-2.+j*4./(m-1);
    fprintf(fp,"%lG\n",z.im);
    }
  fprintf(fp,"%i\n",n*m);
  for(j=0;j<m;j++)
    {
    z.im=-2.+j*4./(m-1);
    for(i=0;i<n;i++)
      {
      z.re=-2.+i*4./(n-1);
      w=f(z);
      fprintf(fp,"%lG\n",w.re);
      }
    }
  fclose(fp);
  }

int main(int argc,char**argv,char**envp)
  {
  CreateTB2("root4.tb2",64,64);
  return(0);
  }
