      PROGRAM TEST3
C COMPUTES THE CONFORMAL MAP FROM A POLYGON (1) ONTO A RECTANGLE (2)
C AND PLOTS A CORRESPONDING GRID OF SIZE NX BY NY.
C THE CORNERS OF THE RECTANGLE ARE (0,I), (0,0), (H,0), (H,I).
C NICK TREFETHEN, ICASE, JULY 1983
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION WGRID(0:241,0:241)
      DIMENSION Z1(12),W1(12),BETAM1(12),QWORK1(270),IBRK(4)
      DIMENSION Z2(4),W2(4),BETAM2(4),QWORK2(110)
      DATA ZERO/(0.,0.)/
C INPUT DATA
      PRINT 1000
 1000 FORMAT(' VERTICES? (TERMINATE WITH RE W(K) > 100 )')
      K=0
      DO WHILE(.TRUE.)
        K=K+1
        READ *,X,Y
        W1(K)=CMPLX(X,Y)
        IF(X.GE.100.)EXIT
      ENDDO
      N1=K-1
      PRINT 1010
 1010 FORMAT(' IMAGE OF ZERO IN THE POLYGON?')
      READ *,X,Y
      WC1=CMPLX(X,Y)
      PRINT 1020
 1020 FORMAT(' FOUR DISTINGUISHED VERTICES?')
      READ *,(IBRK(K),K=1,4)
      NQ1=3
      NQ2=NQ1
      TOL=10.**(-(NQ1+1))
      PRINT 1030
 1030 FORMAT(' NO. OF STREAMLINES, EQUIPOTENTIAL LINES?')
      READ *,NY,NX
      NXP=NX+1
      NYP=NY+1
C COMPUTE PARAMETERS FOR MAP FROM DISK TO POLYGON
      CALL ANGLES(N1,W1,BETAM1)
      CALL QINIT(N1,BETAM1,NQ1,QWORK1)
      CALL SCSOLV(0,0,TOL,EEST,N1,C1,Z1,WC1,W1,BETAM1,NQ1,QWORK1)
C COMPUTE PARAMETERS FOR MAP FROM DISK TO RECTANGLE
      N2=4
      C2=(1.,0.)
      DO K=1,4
        BETAM2(K)=-.5
        Z2(K)=Z1(IBRK(K))
      ENDDO
      CALL QINIT(N2,BETAM2,NQ2,QWORK2)
      DO K=1,4
        W2(K)=WSC(Z2(K),K,ZERO,ZERO,0,N2,C2,Z2,BETAM2,NQ2,QWORK2)
      ENDDO
      C2=(0.,1.)/(W2(1)-W2(2))
      WC2=-C2*W2(2)
      DO K=1,4
        W2(K)=C2*W2(K)+WC2
      ENDDO
      WRITE(6,1040)(W2(K),K=1,4)
 1040 FORMAT(' VERTICES OF IMAGE RECTANGLE: ',4(/'   (',E13.6,',',
     & E13.6,')')/)
      H=ABS(W2(3)-W2(2))
C COMPUTE GRID POINTS
      DO J=0,NYP
        I1=0
        I2=NXP
        IF(J.EQ.0.OR.J.EQ.NYP)I1=1
        IF(J.EQ.0.OR.J.EQ.NYP)I2=NX
        DO I=I1,I2
          WW2=CMPLX((I*H)/NXP,FLOAT(J)/NYP)
          CALL NEARW(WW2,ZN2,WN2,KN2,N2,Z2,WC2,W2,BETAM2)
          IER=0
          IGUESS=1
          IF(I.EQ.I1)IGUESS=0
          ZZ=ZSC(WW2,IGUESS,ZZ,ZN2,WN2,KN2,1.E-3,IER,N2,C2,Z2,WC2,W2,
     &     BETAM2,NQ2,QWORK2)
          CALL NEARZ(ZZ,ZN1,WN1,KN1,N1,Z1,WC1,W1,BETAM1)
          WGRID(I,J)=WSC(ZZ,0,ZN1,WN1,KN1,N1,C1,Z1,BETAM1,NQ1,QWORK1)
        ENDDO
        WRITE(6,1050)J,NYP
      ENDDO
 1050 FORMAT(' FINISHED ROW',I3,'/',I2,' OF GRID POINTS')
C DRAW PLOT
      OPEN(10,FILE='SCPACK.OUT',STATUS='UNKNOWN')
      DO K=1,N1
        WRITE(10,1060)W1(K)
      ENDDO
      WRITE(10,1070)W1(1)
 1060 FORMAT(2F10.5)
 1070 FORMAT(2F10.5,/)
      DO J=1,NY
        WRITE(10,1060)(WGRID(I,J),I=0,NX)
        WRITE(10,1070)WGRID(NXP,J)
      ENDDO
      DO I=1,NX
        WRITE(10,1060)(WGRID(I,J),J=0,NY)
        WRITE(10,1070)WGRID(I,NYP)
      ENDDO
      CLOSE(10)
      STOP
      END
      SUBROUTINE GAUSSJ(N,ALPHA,BETA,B,T,W)
C THIS ROUTINE COMPUTES THE NODES T(J) AND WEIGHTS
C W(J) FOR GAUSS-JACOBI QUADRATURE FORMULAS.
C THESE ARE USED WHEN ONE WISHES TO APPROXIMATE
C INTEGRAL (FROM A TO B)  F(X) W(X) DX
C N
C BY                   SUM W  F(T )
C J=1  J    J
C (W(X) AND W(J) HAVE NO CONNECTION WITH EACH OTHER)
C WHERE W(X) IS THE WEIGHT FUNCTION
C W(X)=(1-X)**ALPHA * (1+X)**BETA
C ON (-1, 1), ALPHA, BETA .GT. -1.
C INPUT:
C N        THE NUMBER OF POINTS USED FOR THE QUADRATURE RULE
C ALPHA    SEE ABOVE
C BETA     SEE ABOVE
C B        REAL SCRATCH ARRAY OF LENGTH N
C OUTPUT PARAMETERS (BOTH REAL ARRAYS OF LENGTH N)
C T        WILL CONTAIN THE DESIRED NODES.
C W        WILL CONTAIN THE DESIRED WEIGHTS W(J).
C SUBROUTINES REQUIRED: SOLVE, CLASS, IMTQL2, GAMMA
C REFERENCE:
C THE ROUTINE HAS BEEN ADAPTED FROM THE MORE GENERAL
C ROUTINE GAUSSQ BY GOLUB AND WELSCH.  SEE
C GOLUB, G. H., AND WELSCH, J. H., "CALCULATION OF GAUSSIAN
C QUADRATURE RULES," MATHEMATICS OF COMPUTATION 23 (APRIL,
C 1969), PP. 221-230.
      REAL B(N),T(N),W(N),MUZERO
      CALL CLASS(N,ALPHA,BETA,B,T,MUZERO)
      W(1)=1.
      DO I=2,N
        W(I)=0.0
      ENDDO
      CALL IMTQL2(N,T,B,W,IERR)
      DO I=1,N
        W(I)=MUZERO*W(I)*W(I)
      ENDDO
      RETURN
      END
      SUBROUTINE CLASS(N,ALPHA,BETA,B,A,MUZERO)
C THIS PROCEDURE SUPPLIES THE COEFFICIENTS A(J), B(J) OF THE
C RECURRENCE RELATION
C B P (X)=(X-A ) P   (X)-B   P   (X)
C J J            J   J-1       J-1 J-2
C FOR THE VARIOUS CLASSICAL (NORMALIZED) ORTHOGONAL POLYNOMIALS,
C AND THE ZERO-TH MOMENT
C MUZERO=INTEGRAL W(X) DX
C OF THE GIVEN POLYNOMIAL'S WEIGHT FUNCTION W(X).  SINCE THE
C POLYNOMIALS ARE ORTHONORMALIZED, THE TRIDIAGONAL MATRIX IS
C GUARANTEED TO BE SYMMETRIC.
      REAL A(N),B(N),MUZERO
      NM1=N-1
      AB=ALPHA+BETA
      ABI=2.+AB
      MUZERO=2.**(AB+1.)*GAMMA(ALPHA+1.)*GAMMA(BETA+1.)/GAMMA(ABI)
      A(1)=(BETA-ALPHA)/ABI
      B(1)=SQRT(4.*(1.+ALPHA)*(1.+BETA)/((ABI+1.)*ABI*ABI))
      A2B2=BETA*BETA-ALPHA*ALPHA
      DO I=2,NM1
        ABI=2.*I+AB
        A(I)=A2B2/((ABI-2.)*ABI)
        B(I)=SQRT(4.*I*(I+ALPHA)*(I+BETA)*(I+AB)/((ABI*ABI-1)*ABI*ABI))
      ENDDO
      ABI=2.*N+AB
      A(N)=A2B2/((ABI-2.)*ABI)
      RETURN
      END
      SUBROUTINE IMTQL2(N,D,E,Z,IERR)
C THIS IS A MODIFIED VERSION OF THE EISPACK ROUTINE IMTQL2.
C IT FINDS THE EIGENVALUES AND FIRST COMPONENTS OF THE
C EIGENVECTORS OF A SYMMETRIC TRIDIAGONAL MATRIX BY THE IMPLICIT QL
C METHOD.
      REAL D(N),E(N),Z(N),MACHEP
C MACHEP IS A MACHINE DEPENDENT PARAMETER SPECIFYING
C THE RELATIVE PRECISION OF FLOATING POINT ARITHMETIC.
      DATA MACHEP/1.E-7/
      IERR=0
      IF(N.NE.1)THEN
        E(N)=0.
        DO L=1,N
          J=0
C LOOK FOR SMALL SUB-DIAGONAL ELEMENT
          DO WHILE(.TRUE.)
            DO M=L,N
              IF(M.EQ.N)EXIT
              IF(ABS(E(M)).LE.MACHEP*(ABS(D(M))+ABS(D(M+1))))EXIT
            ENDDO
            P=D(L)
            IF(M.EQ.L)EXIT
            IF(J.EQ.30)GOTO 100
            J=J+1
C FORM SHIFT
            G=(D(L+1)-P)/(2.*E(L))
            R=SQRT(G*G+1.)
            G=D(M)-P+E(L)/(G+SIGN(R,G))
            S=1.
            C=1.
            P=0.
            MML=M-L
C FOR I=M-1 STEP -1 UNTIL L DO --
            DO II=1,MML
              I=M-II
              F=S*E(I)
              B=C*E(I)
              IF(ABS(F).LT.ABS(G))THEN
                S=F/G
                R=SQRT(S*S+1.)
                E(I+1)=G*R
                C=1./R
                S=S*C
              ELSE
                C=G/F
                R=SQRT(C*C+1.)
                E(I+1)=F*R
                S=1./R
                C=C*S
              ENDIF
              G=D(I+1)-P
              R=(D(I)-G)*S+2.*C*B
              P=S*R
              D(I+1)=G+P
              G=C*R-B
C FORM FIRST COMPONENT OF VECTOR
              F=Z(I+1)
              Z(I+1)=S*Z(I)+C*F
              Z(I)=C*Z(I)-S*F
            ENDDO
            D(L)=D(L)-P
            E(L)=G
            E(M)=0.
          ENDDO
        ENDDO
C ORDER EIGENVALUES AND EIGENVECTORS
        DO II=2,N
          I=II-1
          K=I
          P=D(I)
          DO J=II,N
            IF(D(J).LT.P)THEN
              K=J
              P=D(J)
            ENDIF
          ENDDO
          IF(K.NE.I)THEN
            D(K)=D(I)
            D(I)=P
            P=Z(I)
            Z(I)=Z(K)
            Z(K)=P
          ENDIF
        ENDDO
        RETURN
C SET ERROR -- NO CONVERGENCE TO AN
C EIGENVALUE AFTER 30 ITERATIONS
  100   IERR=L
      ENDIF
      RETURN
      END
      FUNCTION GAMMA(X)
C COMPUTES THE GAMMA FUNCTION. NEEDED BY GAUSSJ.
C THIS FUNCTION IS ADAPTED FROM AN IMSL ROUTINE BUT SHOULD
C BE REPLACED BY ANY LOCALLY AVAILABLE ALTERNATIVE.
      LOGICAL MFLAG
      DIMENSION P(5),Q(4),P4(3)
C COEFFICIENTS FOR MINIMAX
C APPROXIMATION TO GAMMA(X),
C 2.0 .LE. X .LE. 3.0
      DATA P(1)/-51.49952/,P(2)/80.05398/,P(3)/-201.4659/,P(4)/
     & -1.889439/,P(5)/9.895546/
      DATA Q(1)/130.5263/,Q(2)/-303.5898/,Q(3)/26.84174/,Q(4)/-19.52375
     & /
C APPROXIMATION TO LN(GAMMA(X)),
C 12.0 .LE. X
      DATA P4(1)/.9189385/,P4(2)/.8333332E-01/,P4(3)/-.2770927E-02/
      DATA IEND/5/,IEND1/4/,IEND2/3/
      DATA XINF/1.7014E38/
      DATA PI/3.141593/
C GAMMA(XMIN) .APPROX. XINF
C GAMMA(BIG1) .APPROX. XINF
      DATA XMIN/5.8775E-39/
      DATA BIG1/34.844/
C FIRST EXECUTABLE STATEMENT
      IER=0
      MFLAG=.FALSE.
      T=X
      IF(ABS(T).LE.XMIN)THEN
        IER=130
        GAMMA=XINF
        IF(T.LE.0.0)GAMMA=-XINF
      ELSEIF(ABS(T).LT.BIG1)THEN
        IF(T.LE.0.0)THEN
C ARGUMENT IS NEGATIVE
          MFLAG=.TRUE.
          T=-T
          R=AINT(T)
          SIGN=1.0
          IF(AMOD(R,2.0).EQ.0.0)SIGN=-1.
          R=T-R
          IF(R.EQ.0.0)THEN
            IER=130
            GAMMA=XINF
            IF(SIGN.EQ.-1.0)GAMMA=-XINF
            GOTO 100
          ELSE
C ARGUMENT IS NOT A NEGATIVE INTEGER
            R=PI/SIN(R*PI)*SIGN
            T=T+1.0
          ENDIF
        ENDIF
C EVALUATE APPROXIMATION FOR GAMMA(T)
C T .GT. XMIN
        IF(T.GT.12.0)THEN
C T .GT. 12.0
          TOP=ALOG(T)
          TOP=T*(TOP-1.0)-.5*TOP
          T=1.0/T
          B=T*T
          Y=(P4(3)*B+P4(2))*T+P4(1)+TOP
          Y=EXP(Y)
          IF(MFLAG)Y=R/Y
          GAMMA=Y
        ELSE
          I=T
          A=1.0
          IF(I.GT.2)THEN
C 3.0 .LE. T .LE. 12.0
            DO J=3,I
              T=T-1.0
              A=A*T
            ENDDO
          ELSE
            I=I+1
            IF(I.EQ.2)THEN
C 1.0 .LE. T .LT. 2.0
              A=A/T
              T=T+1.0
            ELSEIF(I.NE.3)THEN
C 0.0 .LT. T .LT. 1.0
              A=A/(T*(T+1.0))
              T=T+2.0
            ENDIF
          ENDIF
C 2.0 .LE. T .LE. 3.0
          TOP=P(IEND1)*T+P(IEND)
          DEN=T+Q(IEND1)
          DO J=1,IEND2
            TOP=TOP*T+P(J)
            DEN=DEN*T+Q(J)
          ENDDO
          Y=(TOP/DEN)*A
          IF(MFLAG)Y=R/Y
          GAMMA=Y
        ENDIF
        RETURN
      ELSE
        IER=129
        GAMMA=XINF
      ENDIF
  100 CONTINUE
      WRITE(6,1000)
 1000 FORMAT(' *** ERROR IN GAUSSJ GAMMA FUNCTION ROUTINE')
      RETURN
      END
      SUBROUTINE NS01A(N,X,F,AJINV,DSTEP,DMAX,ACC,MAXFUN,IPRINT,W,
     & CALFUN)
C THIS SUBROUTINE SOLVES A SYSTEM OF NONLINEAR ALGEBRAIC EQUATIONS OF
C THE FORM F(X)=0, WHERE F AND X ARE VECTORS OF LENGTH N.  THE
C FUNCTION F SHOULD HAVE CONTINUOUS FIRST DERIVATIVES, BUT THERE IS
C NO NEED TO CALCULATE THESE, BECAUSE THE ALGORITHM AUTOMATICALLY
C COMPUTES FINITE DIFFERENCE APPROXIMATIONS.  THE METHOD USED IN
C SEEKING A SOLUTION IS A COMPROMISE BETWEEN NEWTON'S METHOD AND
C STEEPEST DESCENT.  THE ITERATIVE NATURE OF THE ALGORITHM REQUIRES
C THAT AN INITIAL ESTIMATE OF THE SOLUTION BE SUPPLIED, BUT THIS CAN
C BE FAIRLY POOR AND THE PROCESS STILL WILL USUALLY CONVERGE.  THIS
C IS BECAUSE THE ALGORITHM TENDS TO TAKE STEEPEST DESCENT STEPS WHEN
C IT IS FAR FROM THE SOLUTION, SWITCHING TO THE NEWTON DIRECTION FOR
C RAPID CONVERGENCE AS IT NEARS THE SOLUTION.
C PROGRAM AUTHOR: M. J. D. POWELL
C DOCUMENTATION : TECHNICAL REPORT AERE-R.5947
C HARWELL, ENGLAND
C NOVEMBER, 1968
C THE VARIABLES IN THE CALLING SEQUENCE ARE DEFINED AS FOLLOWS:
C N        NUMBER OF VARIABLES (EQUATIONS).  MUST HAVE N>1.
C X        VECTOR OF LENGTH N CONTAINING THE VARIABLES OF THE
C EQUATIONS.  ON ENTRY THIS SHOULD CONTAIN THE INITIAL
C ESTIMATE OF THE SOLUTION.  ON RETURN IT WILL CONTAIN THE
C BEST ESTIMATE OF THE SOLUTION.
C F        VECTOR OF LENGTH N USED AS WORKING SPACE.  ON RETURN IT
C CONTAINS THE VALUES OF THE FUNCTIONS AT THE SOLUTION X.
C AJINV    TWO DIMENSIONAL ARRAY (20 BY 20) USED AS WORKING SPACE.
C ON RETURN IT CONTAINS AN APPROXIMATION TO THE INVERSE OF
C THE JACOBIAN MATRIX OF THE SYSTEM AT THE SOLUTION X.
C DSTEP    STEP LENGTH FOR USE IN APPROXIMATING FIRST DERIVATIVES OF
C THE FUNCTIONS BY DIFFERENCES BETWEEN FUNCTION VALUES.
C DMAX     GENEROUS ESTIMATE OF THE EUCLIDEAN DISTANCE OF THE
C SOLUTION FROM THE INITIAL ESTIMATE.  USED TO LIMIT MAXIMUM
C SIZE OF A SINGLE CORRECTION STEP.  MUST HAVE DMAX > DSTEP
C ACC      ACCURACY REQUIREMENT.  THE ITERATIVE PROCESS IS ASSUMED TO
C HAVE CONVERGED AND A NORMAL RETURN TAKES PLACE WHEN AN X
C IS FOUND FOR WHICH THE EUCLIDEAN NORM OF F(X) IS LESS THAN
C ACC.
C MAXFUN   MAXIMUM NUMBER OF FUNCTION EVALUATIONS (CALLS TO CALFUN)
C TO BE ALLOWED.  (GENERALLY 10*N IS A SUFFICIENT NUMBER OF
C EVALUATIONS, ALTHOUGH FOR SOME PROBLEMS MORE MAY BE
C NEEDED.)
C IPRINT   FLAG WHICH CONTROLS PRINTING:
C .LT.0-NO PRINTOUT EXCEPT ERROR MESSAGES
C .GE.0-SUM-OF-SQUARES ERROR AT EACH ITERATION
C .GT.0-X AND F AT EACH ITERATION
C W        VECTOR OF LENGTH N*(2*N+5) WHICH IS USED AS WORKING SPACE
C CALFUN   THE SUBROUTINE DEFINING THE SYSTEM OF NONLINEAR EQUATIONS
C IT MUST HAVE THE FORM
C SUBROUTINE CALFUN(N,X,F)
C WHERE N, X, AND F HAVE THE SAME MEANING AS GIVEN ABOVE.
C CALFUN SHOULD SET THE COMPONENTS OF F TO BE THE FUNCTION
C VALUES AT X.  MUST BE DECLARED EXTERNAL IN THE CALLING
C PROGRAM.
C NOTES:
C THERE ARE FOUR POSSIBLE ERROR EXITS, EACH OF WHICH IS ACCOMPANIED
C BY AN APPROPRIATE DIAGNOSTIC MESSAGE.  THESE OCCUR WHEN
C 1. THE GRADIENT OF F AT X BECOMES SO SMALL THAT IT IS
C PREDICTED THAT STEPS MUCH LARGER THAN DMAX ARE NEEDED.
C 2. THE NUMBER OF CALLS TO CALFUN EXCEEDS MAXFUN.
C 3. F(X) FAILS TO DECREASE FOR N+4 CONSECUTIVE ITERATIONS WHEN
C A DECREASE IS PREDICTED, AND X IS WITHIN DSTEP OF THE MOST
C SUCCESSFUL VECTOR OF VARIABLES.
C 4. F(X) FAILS TO DECREASE EVEN THOUGH A NEW (THEREFORE,
C PRESUMABLY RELIABLE) JACOBIAN MATRIX HAS JUST BEEN
C OBTAINED BY FINITE DIFFERENCES, AND X IS WITHIN DISTANCE
C DSTEP FROM THE POINT WHERE THE JACOBIAN WAS CALCULATED.
C THESE ERROR CONDITIONS CAN BE CAUSED BY A NUMBER OF FACTORS, SUCH
C AS TOO SMALL VALUES FOR MAXFUN OR DMAX, OR VERY POOR VALUES FOR
C DSTEP OR THE INITIAL GUESS FOR X.  IN ADDITION, THE PROBLEM ITSELF
C MAY BE SO BADLY CONDITIONED THAT ROUNDING ERRORS IN THE
C COMPUTATIONS MAKE FINDING A SOLUTION IMPOSSIBLE, OR THE EQUATIONS
C MAY BE INCONSISTENT SO THAT NO SOLUTION EXISTS.
C ANOTHER IMPORTANT FACT TO NOTE IS THAT ONLY ONE STEP SIZE, DSTEP,
C IS USED FOR ALL THE VARIABLES.  THIS IMPLIES THAT ALL THE VARIABLE
C ARE EXPECTED TO BE OF ROUGHLY THE SAME ORDER OF MAGNITUDE.  SCALING
C MAY BE REQUIRED TO ACCOMPLISH THIS, BUT THIS ENHANCES THE NUMERICAL
C STABILITY OF THE PROBLEM ANYWAY AND IS DEFINITELY ADVISABLE.
C NOTE THAT IF THE ORDER OF THE SYSTEM IS GREATER THAN 20, THEN AJIN
C (AS WELL AS SEVERAL OTHER ARRAYS NOT APPEARING IN THE CALLING
C SEQUENCE) MUST HAVE THEIR DIMENSIONS INCREASED.
C MATRIX INVERSION IS PERFORMED BY THE LINPACK ROUTINES
C SGEFA FOLLOWED BY SGEDI.  THESE REQUIRE IN ADDITION THE
C LINPACK BASIC LINEAR ALGEBRA SUBROUTINES SAXPY, SSCAL,
C ISAMAX, AND SSWAP.
      EXTERNAL CALFUN
      REAL X(1),F(1),LAWORK(20),AJINV(20,20),W(1),DET(2)
      INTEGER IPVT(20)
C SET VARIOUS PARAMETERS
      MAXC=0
C 'MAXC' COUNTS THE NUMBER OF CALLS OF CALFUN
      NT=N+4
      NTEST=NT
C 'NT' AND 'NTEST' CAUSE AN ERROR RETURN IF F(X) DOES NOT DECREASE
      DTEST=FLOAT(N+N)-0.5
C 'DTEST' IS USED TO MAINTAIN LINEAR INDEPENDENCE
      NX=N*N
      NF=NX+N
      NW=NF+N
      MW=NW+N
      NDC=MW+N
      ND=NDC+N
C THESE PARAMETERS SEPARATE THE WORKING SPACE ARRAY W
      FMIN=0.
C USUALLY 'FMIN' IS THE LEAST CALCULATED VALUE OF F(X),
C AND THE BEST X IS IN W(NX+1) TO W(NX+N)
      DD=0.
C USUALLY DD IS THE SQUARE OF THE CURRENT STEP LENGTH
      DSS=DSTEP*DSTEP
      DM=DMAX*DMAX
      DMM=4.*DM
      IS=5
C 'IS' CONTROLS A 'GO TO' STATEMENT FOLLOWING A CALL OF CALFUN
      TINC=1.
C 'TINC' IS USED IN THE CRITERION TO INCREASE THE STEP LENGTH
C START A NEW PAGE FOR PRINTING
      IF(IPRINT.GT.0)THEN
        PRINT 1000
 1000   FORMAT('1')
      ENDIF
C CALL THE SUBROUTINE CALFUN
      DO WHILE(.TRUE.)
        MAXC=MAXC+1
        CALL CALFUN(N,X,F)
C TEST FOR CONVERGENCE
        FSQ=0.
        DO I=1,N
          FSQ=FSQ+F(I)*F(I)
        ENDDO
        IF(FSQ.LE.ACC**2)GOTO 250
C TEST FOR ERROR RETURN BECAUSE F(X) DOES NOT DECREASE
        IF(.NOT.(IS.EQ.2.OR.IS.EQ.3.OR.IS.EQ.5))THEN
          IF(FSQ.LT.FMIN)THEN
            NTEST=NT
          ELSEIF(DD.LE.DSS)THEN
            NTEST=NTEST-1
            IF(NTEST.LT.0)EXIT
            IF(NTEST.LE.0)GOTO 230
          ENDIF
        ENDIF
C TEST WHETHER THERE HAVE BEEN MAXFUN CALLS OF CALFUN
        IF(MAXFUN.LE.MAXC)GOTO 220
C PROVIDE PRINTING IF REQUESTED
        IF(IPRINT.GE.0)THEN
          IF(IPRINT.NE.0)THEN
            PRINT 1010,MAXC
 1010       FORMAT(/5X,'AT THE',I5,' TH CALL OF CALFUN WE HAVE')
            PRINT 1070,(I,X(I),F(I),I=1,N)
          ENDIF
          PRINT 1080,MAXC,FSQ
        ENDIF
        IF(IS.EQ.1)THEN
C UPDATE THE STEP SIZE
          DMULT=0.9*FMIN+0.1*FNP-FSQ
          IF(DMULT.GE.0)THEN
C TRY THE TEST TO DECIDE WHETHER TO INCREASE THE STEP LENGTH
            SP=0.
            SS=0.
            DO I=1,N
              SP=SP+ABS(F(I)*(F(I)-W(NW+I)))
              SS=SS+(F(I)-W(NW+I))**2
            ENDDO
            PJ=1.+DMULT/(SP+SQRT(SP*SP+DMULT*SS))
            SP=MIN(4.,TINC,PJ)
            TINC=PJ/SP
            DD=MIN(DM,SP*DD)
          ELSE
            DD=MAX(DSS,0.25*DD)
            TINC=1.
            IF(FSQ.GE.FMIN)GOTO 100
          ENDIF
        ELSEIF(IS.EQ.2)THEN
          GOTO 100
        ELSEIF(IS.EQ.3)THEN
          K=IC
          DO I=1,N
            W(K)=(F(I)-W(NF+I))/DSTEP
            K=K+N
          ENDDO
          X(IC)=W(NX+IC)
          IF(IC.LT.N)GOTO 200
C CALCULATE THE INVERSE OF THE JACOBIAN AND SET THE DIRECTION MATRIX
          K=0
          DO I=1,N
            DO J=1,N
              K=K+1
              AJINV(I,J)=W(K)
              W(ND+K)=0.
            ENDDO
            W(NDC+K+I)=1.
            W(NDC+I)=1.+FLOAT(N-I)
          ENDDO
C INVERT MATRIX WITH LINPACK ROUTINES:
          LDA=20
          INFO=0
          CALL SGEFA(AJINV,LDA,N,IPVT,INFO)
          IF(INFO.NE.0)GOTO 210
          IJOB=1
          CALL SGEDI(AJINV,LDA,N,IPVT,DET,LAWORK,IJOB)
          GOTO 110
        ELSEIF(IS.NE.4)THEN
C STORE THE RESULT OF THE INITIAL CALL OF CALFUN
          FMIN=FSQ
          DO I=1,N
            W(NX+I)=X(I)
            W(NF+I)=F(I)
          ENDDO
          GOTO 190
C IF F(X) IMPROVES STORE THE NEW VALUE OF X
        ELSEIF(FSQ.GE.FMIN)THEN
          GOTO 170
        ENDIF
        FMIN=FSQ
        DO I=1,N
          SP=X(I)
          X(I)=W(NX+I)
          W(NX+I)=SP
          SP=F(I)
          F(I)=W(NF+I)
          W(NF+I)=SP
          W(NW+I)=-W(NW+I)
        ENDDO
        IF(IS.GT.1)GOTO 170
C CALCULATE THE CHANGES IN F AND IN X
  100   CONTINUE
        DO I=1,N
          X(I)=X(I)-W(NX+I)
          F(I)=F(I)-W(NF+I)
        ENDDO
C UPDATE THE APPROXIMATIONS TO J AND TO AJINV
        K=0
        DO I=1,N
          W(MW+I)=X(I)
          W(NW+I)=F(I)
          DO J=1,N
            W(MW+I)=W(MW+I)-AJINV(I,J)*F(J)
            K=K+1
            W(NW+I)=W(NW+I)-W(K)*X(J)
          ENDDO
        ENDDO
        SP=0.
        SS=0.
        DO I=1,N
          DS=0.
          DO J=1,N
            DS=DS+AJINV(J,I)*X(J)
          ENDDO
          SP=SP+DS*F(I)
          SS=SS+X(I)*X(I)
          F(I)=DS
        ENDDO
        DMULT=1.
        IF(ABS(SP)-0.1*SS.LT.0)DMULT=0.8
        PJ=DMULT/SS
        PA=DMULT/(DMULT*SP+(1.-DMULT)*SS)
        K=0
        DO I=1,N
          SP=PJ*W(NW+I)
          SS=PA*W(MW+I)
          DO J=1,N
            K=K+1
            W(K)=W(K)+SP*X(J)
            AJINV(I,J)=AJINV(I,J)+SS*F(J)
          ENDDO
        ENDDO
C START ITERATION BY PREDICTING THE DESCENT AND NEWTON MINIMA
  110   DS=0.
        DN=0.
        SP=0.
        DO I=1,N
          X(I)=0.
          F(I)=0.
          K=I
          DO J=1,N
            X(I)=X(I)-W(K)*W(NF+J)
            F(I)=F(I)-AJINV(I,J)*W(NF+J)
            K=K+N
          ENDDO
          DS=DS+X(I)*X(I)
          DN=DN+F(I)*F(I)
          SP=SP+X(I)*F(I)
        ENDDO
C TEST WHETHER A NEARBY STATIONARY POINT IS PREDICTED
        IF(FMIN*FMIN-DMM*DS.LE.0)THEN
C TEST WHETHER TO APPLY THE FULL NEWTON CORRECTION
          DO WHILE(.TRUE.)
            IS=2
            IF(DN.LE.DD)GOTO 140
C CALCULATE THE LENGTH OF THE STEEPEST DESCENT STEP
            K=0
            DMULT=0.
            DO I=1,N
              DW=0.
              DO J=1,N
                K=K+1
                DW=DW+W(K)*X(J)
              ENDDO
              DMULT=DMULT+DW*DW
            ENDDO
            DMULT=DS/DMULT
            DS=DS*DMULT*DMULT
C TEST WHETHER TO USE THE STEEPEST DESCENT DIRECTION
            IF(DS.LT.DD)EXIT
C TEST WHETHER THE INITIAL VALUE OF DD HAS BEEN SET
            IF(DD.GT.0)GOTO 120
            DD=MAX(DSS,MIN(DM,DS))
            DS=DS/(DMULT*DMULT)
          ENDDO
C INTERPOLATE BETWEEN THE STEEPEST DESCENT AND THE NEWTON DIRECTION
          SP=SP*DMULT
          ANMULT=(DD-DS)/((SP-DS)+SQRT((SP-DD)**2+(DN-DD)*(DD-DS)))
          DMULT=DMULT*(1.-ANMULT)
          GOTO 130
C SET THE MULTIPLIER OF THE STEEPEST DESCENT DIRECTION
  120     ANMULT=0.
          DMULT=DMULT*SQRT(DD/DS)
C CALCULATE THE CHANGE IN X AND ITS ANGLE WITH THE FIRST DIRECTION
  130     DN=0.
          SP=0.
          DO I=1,N
            F(I)=DMULT*X(I)+ANMULT*F(I)
            DN=DN+F(I)*F(I)
            SP=SP+F(I)*W(ND+I)
          ENDDO
          DS=0.25*DN
C TEST WHETHER AN EXTRA STEP IS NEEDED FOR INDEPENDENCE
          IF(W(NDC+1).LE.DTEST)GOTO 150
          IF(SP*SP-DS.LT.0)GOTO 180
          GOTO 150
  140     DD=MAX(DN,DSS)
          DS=0.25*DN
          TINC=1.
          IF(DN.LT.DSS)THEN
            IS=4
            GOTO 160
          ENDIF
C EXPRESS THE NEW DIRECTION IN TERMS OF THOSE OF THE DIRECTION
C MATRIX, AND UPDATE THE COUNTS IN W(NDC+1) ETC.
  150     SP=0.
          K=ND
          DO I=1,N
            X(I)=DW
            DW=0.
            DO J=1,N
              K=K+1
              DW=DW+F(J)*W(K)
            ENDDO
            IF(IS.EQ.1)THEN
              X(I)=DW
            ELSE
              W(NDC+I)=W(NDC+I)+1.
              SP=SP+DW*DW
              IF(SP.LE.DS)CYCLE
              IS=1
              KK=I
              X(1)=DW
            ENDIF
            W(NDC+I)=W(NDC+I+1)+1.
          ENDDO
          W(ND)=1.
C REORDER THE DIRECTIONS SO THAT KK IS FIRST
          IF(KK.GT.1)THEN
            KS=NDC+KK*N
            DO I=1,N
              K=KS+I
              SP=W(K)
              DO J=2,KK
                W(K)=W(K-N)
                K=K-N
              ENDDO
              W(K)=SP
            ENDDO
          ENDIF
C GENERATE THE NEW ORTHOGONAL DIRECTION MATRIX
          DO I=1,N
            W(NW+I)=0.
          ENDDO
          SP=X(1)*X(1)
          K=ND
          DO I=2,N
            DS=SQRT(SP*(SP+X(I)*X(I)))
            DW=SP/DS
            DS=X(I)/DS
            SP=SP+X(I)*X(I)
            DO J=1,N
              K=K+1
              W(NW+J)=W(NW+J)+X(I-1)*W(K)
              W(K)=DW*W(K+N)-DS*W(NW+J)
            ENDDO
          ENDDO
          SP=1./SQRT(DN)
          DO I=1,N
            K=K+1
            W(K)=SP*F(I)
          ENDDO
C CALCULATE THE NEXT VECTOR X, AND PREDICT THE RIGHT HAND SIDES
  160     FNP=0.
          K=0
          DO I=1,N
            X(I)=W(NX+I)+F(I)
            W(NW+I)=W(NF+I)
            DO J=1,N
              K=K+1
              W(NW+I)=W(NW+I)+W(K)*F(J)
            ENDDO
            FNP=FNP+W(NW+I)**2
C CALL CALFUN USING THE NEW VECTOR OF VARIABLES
          ENDDO
          CYCLE
C IF SO THEN RETURN OR REVISE JACOBIAN
        ELSEIF(IS.EQ.1.OR.IS.EQ.2)THEN
          NTEST=0
          DO I=1,N
            X(I)=W(NX+I)
          ENDDO
          GOTO 190
        ELSE
          GOTO 210
        ENDIF
C TAKE THE EXTRA STEP AND UPDATE THE DIRECTION MATRIX
  170   IS=2
  180   CONTINUE
        DO I=1,N
          X(I)=W(NX+I)+DSTEP*W(ND+I)
          W(NDC+I)=W(NDC+I+1)+1.
        ENDDO
        W(ND)=1.
        DO I=1,N
          K=ND+I
          SP=W(K)
          DO J=2,N
            W(K)=W(K+N)
            K=K+N
          ENDDO
          W(K)=SP
        ENDDO
        CYCLE
C CALCULATE A NEW JACOBIAN APPROXIMATION
  190   IC=0
        IS=3
  200   IC=IC+1
        X(IC)=X(IC)+DSTEP
      ENDDO
C ERROR RETURN BECAUSE A NEW JACOBIAN IS UNSUCCESSFUL
      PRINT 1020
 1020 FORMAT(//5X,'ERROR RETURN FROM NS01A BECAUSE F(X) ',
     & 'FAILED TO DECREASE USING A NEW JACOBIAN')
      GOTO 240
  210 PRINT 1030
 1030 FORMAT(//5X,'ERROR RETURN FROM NS01A BECAUSE A NEARBY ',
     & 'STATIONARY POINT OF F(X) IS PREDICTED')
      GOTO 240
  220 PRINT 1040,MAXC
 1040 FORMAT(//5X,'ERROR RETURN FROM NS01A BECAUSE THERE HAVE BEEN',
     & I5,' CALLS OF CALFUN')
      IF(FSQ.LT.FMIN)GOTO 250
      GOTO 240
  230 PRINT 1050,NT
 1050 FORMAT(//5X,'ERROR RETURN FROM NS01A BECAUSE',I5,
     & ' CALLS OF CALFUN FAILED TO IMPROVE THE RESIDUALS')
  240 CONTINUE
      DO I=1,N
        X(I)=W(NX+I)
        F(I)=W(NF+I)
      ENDDO
      FSQ=FMIN
C PROVIDE PRINTING OF FINAL SOLUTION IF REQUESTED
  250 IF(IPRINT.GE.0)THEN
        IF(IPRINT.NE.0)THEN
          PRINT 1060,MAXC
 1060     FORMAT(/5X,'THE FINAL NS01A SOLUTION REQUIRED',I5,
     &     ' CALLS OF CALFUN, AND IS')
          PRINT 1070,(I,X(I),F(I),I=1,N)
 1070     FORMAT(4X,'I',8X,'X(I)',13X,'F(I)'/(I5,2E17.8))
        ENDIF
        PRINT 1080,MAXC,FSQ
 1080   FORMAT('     THE SUM-OF-SQUARES ERROR AT STEP',I4,' IS',E11.4)
      ENDIF
      RETURN
      END
      SUBROUTINE SGEFA(A,LDA,N,IPVT,INFO)
      INTEGER IPVT(1)
      REAL A(LDA,1)
C LINPACK ROUTINE.
C SGEFA FACTORS A SINGLE PRECISION MATRIX BY GAUSSIAN ELIMINATION.
C REQUIRES BLAS SAXPY,SSCAL,ISAMAX
C GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING
      INFO=0
      NM1=N-1
      IF(NM1.GE.1)THEN
        DO K=1,NM1
          KP1=K+1
C FIND L=PIVOT INDEX
          L=ISAMAX(N-K+1,A(K,K),1)+K-1
          IPVT(K)=L
C ZERO PIVOT IMPLIES THIS COLUMN ALREADY TRIANGULARIZED
          IF(A(L,K).EQ.0.)THEN
            INFO=K
          ELSE
C INTERCHANGE IF NECESSARY
            IF(L.NE.K)THEN
              T=A(L,K)
              A(L,K)=A(K,K)
              A(K,K)=T
            ENDIF
C COMPUTE MULTIPLIERS
            T=-1./A(K,K)
            CALL SSCAL(N-K,T,A(K+1,K),1)
C ROW ELIMINATION WITH COLUMN INDEXING
            DO J=KP1,N
              T=A(L,J)
              IF(L.NE.K)THEN
                A(L,J)=A(K,J)
                A(K,J)=T
              ENDIF
              CALL SAXPY(N-K,T,A(K+1,K),1,A(K+1,J),1)
            ENDDO
          ENDIF
        ENDDO
      ENDIF
      IPVT(N)=N
      IF(A(N,N).EQ.0.)INFO=N
      RETURN
      END
      SUBROUTINE SGEDI(A,LDA,N,IPVT,DET,WORK,JOB)
      INTEGER IPVT(1)
      REAL A(LDA,1),DET(2),WORK(1)
C LINPACK ROUTINE.
C SGEDI COMPUTES THE DETERMINANT AND INVERSE OF A MATRIX
C USING THE FACTORS COMPUTED BY SGECO OR SGEFA.
C REQUIRES BLAS SAXPY,SSCAL,SSWAP
C COMPUTE DETERMINANT
      IF(JOB/10.NE.0)THEN
        DET(1)=1.
        DET(2)=0.
        TEN=10.
        DO I=1,N
          IF(IPVT(I).NE.I)DET(1)=-DET(1)
          DET(1)=A(I,I)*DET(1)
C ...EXIT
          IF(DET(1).EQ.0.)EXIT
          DO WHILE(ABS(DET(1)).LT.1.)
            DET(1)=TEN*DET(1)
            DET(2)=DET(2)-1.
          ENDDO
          DO WHILE(ABS(DET(1)).GE.TEN)
            DET(1)=DET(1)/TEN
            DET(2)=DET(2)+1.
          ENDDO
        ENDDO
      ENDIF
C COMPUTE INVERSE(U)
      IF(MOD(JOB,10).NE.0)THEN
        DO K=1,N
          A(K,K)=1./A(K,K)
          T=-A(K,K)
          CALL SSCAL(K-1,T,A(1,K),1)
          KP1=K+1
          IF(N.GE.KP1)THEN
            DO J=KP1,N
              T=A(K,J)
              A(K,J)=0.
              CALL SAXPY(K,T,A(1,K),1,A(1,J),1)
            ENDDO
          ENDIF
        ENDDO
C FORM INVERSE(U)*INVERSE(L)
        NM1=N-1
        IF(NM1.GE.1)THEN
          DO KB=1,NM1
            K=N-KB
            KP1=K+1
            DO I=KP1,N
              WORK(I)=A(I,K)
              A(I,K)=0.
            ENDDO
            DO J=KP1,N
              T=WORK(J)
              CALL SAXPY(N,T,A(1,J),1,A(1,K),1)
            ENDDO
            L=IPVT(K)
            IF(L.NE.K)CALL SSWAP(N,A(1,K),1,A(1,L),1)
          ENDDO
        ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE SAXPY(N,DA,DX,INCX,DY,INCY)
C CONSTANT TIMES A VECTOR PLUS A VECTOR.
C JACK DONGARRA, LINPACK, 3/11/78.
      REAL DX(1),DY(1)
      IF(N.GT.0)THEN
        IF(DA.NE.0.)THEN
          IF(INCX.EQ.1.AND.INCY.EQ.1)THEN
            M=MOD(N,4)
            IF(M.NE.0)THEN
              DO I=1,M
                DY(I)=DY(I)+DA*DX(I)
              ENDDO
              IF(N.LT.4)RETURN
            ENDIF
            MP1=M+1
            DO I=MP1,N,4
              DY(I)=DY(I)+DA*DX(I)
              DY(I+1)=DY(I+1)+DA*DX(I+1)
              DY(I+2)=DY(I+2)+DA*DX(I+2)
              DY(I+3)=DY(I+3)+DA*DX(I+3)
            ENDDO
          ELSE
            IX=1
            IY=1
            IF(INCX.LT.0)IX=(-N+1)*INCX+1
            IF(INCY.LT.0)IY=(-N+1)*INCY+1
            DO I=1,N
              DY(IY)=DY(IY)+DA*DX(IX)
              IX=IX+INCX
              IY=IY+INCY
            ENDDO
          ENDIF
        ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE SSCAL(N,DA,DX,INCX)
C SCALES A VECTOR BY A CONSTANT.
C JACK DONGARRA, LINPACK, 3/11/78.
      REAL DX(1)
      IF(N.GT.0)THEN
        IF(INCX.EQ.1)THEN
          M=MOD(N,5)
          IF(M.NE.0)THEN
            DO I=1,M
              DX(I)=DA*DX(I)
            ENDDO
            IF(N.LT.5)RETURN
          ENDIF
          MP1=M+1
          DO I=MP1,N,5
            DX(I)=DA*DX(I)
            DX(I+1)=DA*DX(I+1)
            DX(I+2)=DA*DX(I+2)
            DX(I+3)=DA*DX(I+3)
            DX(I+4)=DA*DX(I+4)
          ENDDO
        ELSE
          NINCX=N*INCX
          DO I=1,NINCX,INCX
            DX(I)=DA*DX(I)
          ENDDO
        ENDIF
      ENDIF
      RETURN
      END
      INTEGER FUNCTION ISAMAX(N,DX,INCX)
C FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.
C JACK DONGARRA, LINPACK, 3/11/78.
      REAL DX(1)
      ISAMAX=0
      IF(N.GE.1)THEN
        ISAMAX=1
        IF(N.NE.1)THEN
          IF(INCX.EQ.1)THEN
            DMAX=ABS(DX(1))
            DO I=2,N
              IF(ABS(DX(I)).GT.DMAX)THEN
                ISAMAX=I
                DMAX=ABS(DX(I))
              ENDIF
            ENDDO
          ELSE
            IX=1
            DMAX=ABS(DX(1))
            IX=IX+INCX
            DO I=2,N
              IF(ABS(DX(IX)).GT.DMAX)THEN
                ISAMAX=I
                DMAX=ABS(DX(IX))
              ENDIF
              IX=IX+INCX
            ENDDO
          ENDIF
        ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE SSWAP(N,DX,INCX,DY,INCY)
C INTERCHANGES TWO VECTORS.
C JACK DONGARRA, LINPACK, 3/11/78.
      REAL DX(1),DY(1)
      IF(N.GT.0)THEN
        IF(INCX.EQ.1.AND.INCY.EQ.1)THEN
          M=MOD(N,3)
          IF(M.NE.0)THEN
            DO I=1,M
              DTEMP=DX(I)
              DX(I)=DY(I)
              DY(I)=DTEMP
            ENDDO
            IF(N.LT.3)RETURN
          ENDIF
          MP1=M+1
          DO I=MP1,N,3
            DTEMP=DX(I)
            DX(I)=DY(I)
            DY(I)=DTEMP
            DTEMP=DX(I+1)
            DX(I+1)=DY(I+1)
            DY(I+1)=DTEMP
            DTEMP=DX(I+2)
            DX(I+2)=DY(I+2)
            DY(I+2)=DTEMP
          ENDDO
        ELSE
          IX=1
          IY=1
          IF(INCX.LT.0)IX=(-N+1)*INCX+1
          IF(INCY.LT.0)IY=(-N+1)*INCY+1
          DO I=1,N
            DTEMP=DX(IX)
            DX(IX)=DY(IY)
            DY(IY)=DTEMP
            IX=IX+INCX
            IY=IY+INCY
          ENDDO
        ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE ODE(F,NEQN,Y,T,TOUT,RELERR,ABSERR,IFLAG,WORK,IWORK)
C SUBROUTINE ODE INTEGRATES A SYSTEM OF NEQN
C FIRST ORDER ORDINARY DIFFERENTIAL EQUATIONS OF THE FORM:
C DY(I)/DT=F(T,Y(1),Y(2),...,Y(NEQN))
C Y(I) GIVEN AT  T .
C THE SUBROUTINE INTEGRATES FROM  T  TO  TOUT .  ON RETURN THE
C PARAMETERS IN THE CALL LIST ARE SET FOR CONTINUING THE INTEGRATION.
C THE USER HAS ONLY TO DEFINE A NEW VALUE  TOUT  AND CALL  ODE  AGAIN.
C THE DIFFERENTIAL EQUATIONS ARE ACTUALLY SOLVED BY A SUITE OF CODES
C DE ,  STEP , AND  INTRP .  ODE  ALLOCATES VIRTUAL STORAGE IN THE
C ARRAYS  WORK  AND  IWORK  AND CALLS  DE .  DE  IS A SUPERVISOR WHICH
C DIRECTS THE SOLUTION.  IT CALLS ON THE ROUTINES  STEP  AND  INTRP
C TO ADVANCE THE INTEGRATION AND TO INTERPOLATE AT OUTPUT POINTS.
C STEP  USES A MODIFIED DIVIDED DIFFERENCE FORM OF THE ADAMS PECE
C FORMULAS AND LOCAL EXTRAPOLATION.  IT ADJUSTS THE ORDER AND STEP
C SIZE TO CONTROL THE LOCAL ERROR PER UNIT STEP IN A GENERALIZED
C SENSE.  NORMALLY EACH CALL TO  STEP  ADVANCES THE SOLUTION ONE STEP
C IN THE DIRECTION OF  TOUT .  FOR REASONS OF EFFICIENCY  DE
C INTEGRATES BEYOND  TOUT  INTERNALLY, THOUGH NEVER BEYOND
C T+10*(TOUT-T), AND CALLS  INTRP  TO INTERPOLATE THE SOLUTION AT
C TOUT .  AN OPTION IS PROVIDED TO STOP THE INTEGRATION AT  TOUT  BUT
C IT SHOULD BE USED ONLY IF IT IS IMPOSSIBLE TO CONTINUE THE
C INTEGRATION BEYOND  TOUT .
C THIS CODE IS COMPLETELY EXPLAINED AND DOCUMENTED IN THE TEXT,
C COMPUTER SOLUTION OF ORDINARY DIFFERENTIAL EQUATIONS:  THE INITIAL
C VALUE PROBLEM  BY L. F. SHAMPINE AND M. K. GORDON.
C THE PARAMETERS REPRESENT:
C F -- SUBROUTINE F(T,Y,YP) TO EVALUATE
C DERIVATIVES YP(I)=DY(I)/DT
C NEQN -- NUMBER OF EQUATIONS TO BE INTEGRATED (INTEGER)
C Y(*) -- SOLUTION VECTOR AT T                 (REAL)
C T -- INDEPENDENT VARIABLE                    (REAL)
C TOUT -- POINT AT WHICH SOLUTION IS DESIRED   (REAL)
C RELERR,ABSERR -- RELATIVE AND ABSOLUTE ERROR TOLERANCES FOR LOCAL
C ERROR TEST (REAL).  AT EACH STEP THE CODE REQUIRES
C ABS(LOCAL ERROR) .LE. ABS(Y)*RELERR+ABSERR
C FOR EACH COMPONENT OF THE LOCAL ERROR AND SOLUTION VECTORS
C IFLAG -- INDICATES STATUS OF INTEGRATION     (INTEGER)
C WORK(*)  (REAL)  -- ARRAYS TO HOLD INFORMATION INTERNAL TO
C IWORK(*) (INTEGER)    WHICH IS NECESSARY FOR SUBSEQUENT CALLS
C FIRST CALL TO ODE --
C THE USER MUST PROVIDE STORAGE IN HIS CALLING PROGRAM FOR THE ARRAYS
C IN THE CALL LIST,
C Y(NEQN), WORK(100+21*NEQN), IWORK(5),
C DECLARE  F  IN AN EXTERNAL STATEMENT, SUPPLY THE
C SUBROUTINE F(T,Y,YP)  TO EVALUATE
C DY(I)/DT=YP(I)=F(T,Y(1),Y(2),...,Y(NEQN))
C AND INITIALIZE THE PARAMETERS:
C NEQN -- NUMBER OF EQUATIONS TO BE INTEGRATED
C Y(*) -- VECTOR OF INITIAL CONDITIONS
C T -- STARTING POINT OF INTEGRATION
C TOUT -- POINT AT WHICH SOLUTION IS DESIRED
C RELERR,ABSERR -- RELATIVE AND ABSOLUTE LOCAL ERROR TOLERANCES
C IFLAG -- +1,-1.  INDICATOR TO INITIALIZE THE CODE.  NORMAL INPUT
C IS +1.  THE USER SHOULD SET IFLAG=-1 ONLY IF IT IS
C IMPOSSIBLE TO CONTINUE THE INTEGRATION BEYOND  TOUT .
C ALL PARAMETERS EXCEPT  F ,  NEQN  AND  TOUT  MAY BE ALTERED BY THE
C CODE ON OUTPUT SO MUST BE VARIABLES IN THE CALLING PROGRAM.
C OUTPUT FROM  ODE  --
C NEQN -- UNCHANGED
C Y(*) -- SOLUTION AT  T
C T -- LAST POINT REACHED IN INTEGRATION.  NORMAL RETURN HAS
C T=TOUT .
C TOUT -- UNCHANGED
C RELERR,ABSERR -- NORMAL RETURN HAS TOLERANCES UNCHANGED.  IFLAG=
C SIGNALS TOLERANCES INCREASED
C IFLAG=2 -- NORMAL RETURN.  INTEGRATION REACHED  TOUT
C =3 -- INTEGRATION DID NOT REACH  TOUT  BECAUSE ERROR
C TOLERANCES TOO SMALL.  RELERR ,  ABSERR  INCREASED
C APPROPRIATELY FOR CONTINUING
C =4 -- INTEGRATION DID NOT REACH  TOUT  BECAUSE MORE THAN
C 500 STEPS NEEDED
C =5 -- INTEGRATION DID NOT REACH  TOUT  BECAUSE EQUATIONS
C APPEAR TO BE STIFF
C =6 -- INVALID INPUT PARAMETERS (FATAL ERROR)
C THE VALUE OF  IFLAG  IS RETURNED NEGATIVE WHEN THE INPUT
C VALUE IS NEGATIVE AND THE INTEGRATION DOES NOT REACH  TOUT ,
C I.E., -3, -4, -5.
C WORK(*),IWORK(*) -- INFORMATION GENERALLY OF NO INTEREST TO THE
C USER BUT NECESSARY FOR SUBSEQUENT CALLS.
C SUBSEQUENT CALLS TO  ODE --
C SUBROUTINE  ODE  RETURNS WITH ALL INFORMATION NEEDED TO CONTINUE
C THE INTEGRATION.  IF THE INTEGRATION REACHED  TOUT , THE USER NEED
C ONLY DEFINE A NEW  TOUT  AND CALL AGAIN.  IF THE INTEGRATION DID NOT
C REACH  TOUT  AND THE USER WANTS TO CONTINUE, HE JUST CALLS AGAIN.
C THE OUTPUT VALUE OF  IFLAG  IS THE APPROPRIATE INPUT VALUE FOR
C SUBSEQUENT CALLS.  THE ONLY SITUATION IN WHICH IT SHOULD BE ALTERED
C IS TO STOP THE INTEGRATION INTERNALLY AT THE NEW  TOUT , I.E.,
C CHANGE OUTPUT  IFLAG=2  TO INPUT  IFLAG=-2 .  ERROR TOLERANCES MAY
C BE CHANGED BY THE USER BEFORE CONTINUING.  ALL OTHER PARAMETERS MUST
C REMAIN UNCHANGED.
      LOGICAL START,PHASE1,NORND
      DIMENSION Y(NEQN),WORK(1),IWORK(5)
      EXTERNAL F
      DATA IALPHA,IBETA,ISIG,IV,IW,IG,IPHASE,IPSI,IX,IH,IHOLD,ISTART,
     & ITOLD,IDELSN/1,13,25,38,50,62,75,76,88,89,90,91,92,93/
      IYY=100
      IWT=IYY+NEQN
      IP=IWT+NEQN
      IYP=IP+NEQN
      IYPOUT=IYP+NEQN
      IPHI=IYPOUT+NEQN
      IF(ABS(IFLAG).NE.1)THEN
        START=WORK(ISTART).GT.0.
        PHASE1=WORK(IPHASE).GT.0.
        NORND=IWORK(2).NE.-1
      ENDIF
      CALL DE(F,NEQN,Y,T,TOUT,RELERR,ABSERR,IFLAG,WORK(IYY),WORK(IWT),
     & WORK(IP),WORK(IYP),WORK(IYPOUT),WORK(IPHI),WORK(IALPHA),WORK
     & (IBETA),WORK(ISIG),WORK(IV),WORK(IW),WORK(IG),PHASE1,WORK(IPSI),
     & WORK(IX),WORK(IH),WORK(IHOLD),START,WORK(ITOLD),WORK(IDELSN),
     & IWORK(1),NORND,IWORK(3),IWORK(4),IWORK(5))
      WORK(ISTART)=-1.
      IF(START)WORK(ISTART)=1.
      WORK(IPHASE)=-1.
      IF(PHASE1)WORK(IPHASE)=1.
      IWORK(2)=-1
      IF(NORND)IWORK(2)=1
      RETURN
      END
      SUBROUTINE DE(F,NEQN,Y,T,TOUT,RELERR,ABSERR,IFLAG,YY,WT,P,YP,
     & YPOUT,PHI,ALPHA,BETA,SIG,V,W,G,PHASE1,PSI,X,H,HOLD,START,TOLD,
     & DELSGN,NS,NORND,K,KOLD,ISNOLD)
C ODE  MERELY ALLOCATES STORAGE FOR  DE  TO RELIEVE THE USER OF THE
C INCONVENIENCE OF A LONG CALL LIST.  CONSEQUENTLY  DE  IS USED AS
C DESCRIBED IN THE COMMENTS FOR  ODE .
C THIS CODE IS COMPLETELY EXPLAINED AND DOCUMENTED IN THE TEXT,
C COMPUTER SOLUTION OF ORDINARY DIFFERENTIAL EQUATIONS:  THE INITIAL
C VALUE PROBLEM  BY L. F. SHAMPINE AND M. K. GORDON.
      LOGICAL STIFF,CRASH,START,PHASE1,NORND
      DIMENSION Y(NEQN),YY(NEQN),WT(NEQN),PHI(NEQN,16),P(NEQN),YP(NEQN)
     & ,YPOUT(NEQN),PSI(12),ALPHA(12),BETA(12),SIG(13),V(12),W(12),G
     & (13)
      EXTERNAL F
C***********************************************************************
C*  THE ONLY MACHINE DEPENDENT CONSTANT IS BASED ON THE MACHINE UNIT   *
C*  ROUNDOFF ERROR  U  WHICH IS THE SMALLEST POSITIVE NUMBER SUCH THAT *
C*  1.0+U .GT. 1.0 .  U  MUST BE CALCULATED AND  FOURU=4.0*U  INSERTED *
C*  IN THE FOLLOWING DATA STATEMENT BEFORE USING  DE .  THE ROUTINE    *
C*  MACHIN  CALCULATES  U .  FOURU  AND  TWOU=2.0*U  MUST ALSO BE      *
C*  INSERTED IN SUBROUTINE  STEP  BEFORE CALLING  DE .                 *
      DATA FOURU/.3E-6/
C***********************************************************************
C THE CONSTANT  MAXNUM  IS THE MAXIMUM NUMBER OF STEPS ALLOWED IN ONE
C CALL TO  DE .  THE USER MAY CHANGE THIS LIMIT BY ALTERING THE
C FOLLOWING STATEMENT
      DATA MAXNUM/500/
C ***            ***            ***
C TEST FOR IMPROPER PARAMETERS
      IF(NEQN.GE.1)THEN
        IF(T.NE.TOUT)THEN
          IF(.NOT.(RELERR.LT.0..OR.ABSERR.LT.0.))THEN
            EPS=MAX(RELERR,ABSERR)
            IF(EPS.GT.0.)THEN
              IF(IFLAG.NE.0)THEN
                ISN=SIGN(1,IFLAG)
                IFLAG=ABS(IFLAG)
                IF(IFLAG.NE.1)THEN
                IF(T.NE.TOLD)GOTO 150
                IF(.NOT.(IFLAG.GE.2.AND.IFLAG.LE.5))GOTO 150
                ENDIF
C ON EACH CALL SET INTERVAL OF INTEGRATION AND COUNTER FOR NUMBER OF
C STEPS.  ADJUST INPUT ERROR TOLERANCES TO DEFINE WEIGHT VECTOR FOR
C SUBROUTINE  STEP
                DEL=TOUT-T
                ABSDEL=ABS(DEL)
                TEND=T+10.*DEL
                IF(ISN.LT.0)TEND=TOUT
                NOSTEP=0
                KLE4=0
                STIFF=.FALSE.
                RELEPS=RELERR/EPS
                ABSEPS=ABSERR/EPS
                IF(IFLAG.NE.1)THEN
                IF(ISNOLD.GE.0)THEN
                IF(DELSGN*DEL.GT.0.)GOTO 100
                ENDIF
                ENDIF
C ON START AND RESTART ALSO SET WORK VARIABLES X AND YY(*), STORE THE
C DIRECTION OF INTEGRATION AND INITIALIZE THE STEP SIZE
                START=.TRUE.
                X=T
                DO L=1,NEQN
                YY(L)=Y(L)
                ENDDO
                DELSGN=SIGN(1.,DEL)
                H=SIGN(MAX(ABS(TOUT-X),FOURU*ABS(X)),TOUT-X)
C IF ALREADY PAST OUTPUT POINT, INTERPOLATE AND RETURN
  100           DO WHILE(ABS(X-T).LT.ABSDEL)
C IF CANNOT GO PAST OUTPUT POINT AND SUFFICIENTLY CLOSE,
C EXTRAPOLATE AND RETURN
                IF(.NOT.(ISN.GT.0.OR.ABS(TOUT-X).GE.FOURU*ABS(X)))
     &           GOTO 130
C TEST FOR TOO MANY STEPS
                IF(NOSTEP.GE.MAXNUM)GOTO 120
C LIMIT STEP SIZE, SET WEIGHT VECTOR AND TAKE A STEP
                H=SIGN(MIN(ABS(H),ABS(TEND-X)),H)
                DO L=1,NEQN
                WT(L)=RELEPS*ABS(YY(L))+ABSEPS
                ENDDO
                CALL STEP(X,YY,F,NEQN,H,EPS,WT,START,HOLD,K,KOLD,CRASH,
     &           PHI,P,YP,PSI,ALPHA,BETA,SIG,V,W,G,PHASE1,NS,NORND)
C TEST FOR TOLERANCES TOO SMALL
                IF(CRASH)GOTO 110
C AUGMENT COUNTER ON NUMBER OF STEPS AND TEST FOR STIFFNESS
                NOSTEP=NOSTEP+1
                KLE4=KLE4+1
                IF(KOLD.GT.4)KLE4=0
                IF(KLE4.GE.50)STIFF=.TRUE.
                ENDDO
                GOTO 140
  110           IFLAG=ISN*3
                RELERR=EPS*RELEPS
                ABSERR=EPS*ABSEPS
                DO L=1,NEQN
                Y(L)=YY(L)
                ENDDO
                T=X
                TOLD=T
                ISNOLD=1
                RETURN
  120           IFLAG=ISN*4
                IF(STIFF)IFLAG=ISN*5
                DO L=1,NEQN
                Y(L)=YY(L)
                ENDDO
                T=X
                TOLD=T
                ISNOLD=1
                RETURN
  130           H=TOUT-X
                CALL F(X,YY,YP)
                DO L=1,NEQN
                Y(L)=YY(L)+H*YP(L)
                ENDDO
                IFLAG=2
                T=TOUT
                TOLD=T
                ISNOLD=ISN
                RETURN
  140           CALL INTRP(X,YY,TOUT,Y,YPOUT,NEQN,KOLD,PHI,PSI)
                IFLAG=2
                T=TOUT
                TOLD=T
                ISNOLD=ISN
                RETURN
              ENDIF
            ENDIF
          ENDIF
        ENDIF
      ENDIF
  150 IFLAG=6
      RETURN
      END
      SUBROUTINE STEP(X,Y,F,NEQN,H,EPS,WT,START,HOLD,K,KOLD,CRASH,PHI,
     & P,YP,PSI,ALPHA,BETA,SIG,V,W,G,PHASE1,NS,NORND)
C 1  HOLD,K,KOLD,CRASH,PHI,P,YP,PSI)
C SUBROUTINE STEP
C INTEGRATES A SYSTEM OF FIRST ORDER ORDINARY
C DIFFERENTIAL EQUATIONS ONE STEP, NORMALLY FROM X TO X+H, USING A
C MODIFIED DIVIDED DIFFERENCE FORM OF THE ADAMS PECE FORMULAS.  LOCAL
C EXTRAPOLATION IS USED TO IMPROVE ABSOLUTE STABILITY AND ACCURACY.
C THE CODE ADJUSTS ITS ORDER AND STEP SIZE TO CONTROL THE LOCAL ERROR
C PER UNIT STEP IN A GENERALIZED SENSE.  SPECIAL DEVICES ARE INCLUDED
C TO CONTROL ROUNDOFF ERROR AND TO DETECT WHEN THE USER IS REQUESTING
C TOO MUCH ACCURACY.
C THIS CODE IS COMPLETELY EXPLAINED AND DOCUMENTED IN THE TEXT,
C COMPUTER SOLUTION OF ORDINARY DIFFERENTIAL EQUATIONS:  THE INITIAL
C VALUE PROBLEM  BY L. F. SHAMPINE AND M. K. GORDON.
C THE PARAMETERS REPRESENT:
C X -- INDEPENDENT VARIABLE             (REAL)
C Y(*) -- SOLUTION VECTOR AT X          (REAL)
C YP(*) -- DERIVATIVE OF SOLUTION VECTOR AT  X  AFTER SUCCESSFUL
C STEP                             (REAL)
C NEQN -- NUMBER OF EQUATIONS TO BE INTEGRATED (INTEGER)
C H -- APPROPRIATE STEP SIZE FOR NEXT STEP.  NORMALLY DETERMINED BY
C CODE                             (REAL)
C EPS -- LOCAL ERROR TOLERANCE.  MUST BE VARIABLE  (REAL)
C WT(*) -- VECTOR OF WEIGHTS FOR ERROR CRITERION   (REAL)
C START -- LOGICAL VARIABLE SET .TRUE. FOR FIRST STEP,  .FALSE.
C OTHERWISE                        (LOGICAL)
C HOLD -- STEP SIZE USED FOR LAST SUCCESSFUL STEP  (REAL)
C K -- APPROPRIATE ORDER FOR NEXT STEP (DETERMINED BY CODE)
C KOLD -- ORDER USED FOR LAST SUCCESSFUL STEP
C CRASH -- LOGICAL VARIABLE SET .TRUE. WHEN NO STEP CAN BE TAKEN,
C .FALSE. OTHERWISE.
C THE ARRAYS  PHI, PSI  ARE REQUIRED FOR THE INTERPOLATION SUBROUTINE
C INTRP.  THE ARRAY P IS INTERNAL TO THE CODE.  ALL ARE REAL
C INPUT TO  STEP
C FIRST CALL --
C THE USER MUST PROVIDE STORAGE IN HIS DRIVER PROGRAM FOR ALL ARRAYS
C IN THE CALL LIST, NAMELY
C DIMENSION Y(NEQN),WT(NEQN),PHI(NEQN,16),P(NEQN),YP(NEQN),PSI(12)
C THE USER MUST ALSO DECLARE  START  AND  CRASH  LOGICAL VARIABLES
C AND  F  AN EXTERNAL SUBROUTINE, SUPPLY THE SUBROUTINE  F(X,Y,YP)
C TO EVALUATE
C DY(I)/DX=YP(I)=F(X,Y(1),Y(2),...,Y(NEQN))
C AND INITIALIZE ONLY THE FOLLOWING PARAMETERS:
C X -- INITIAL VALUE OF THE INDEPENDENT VARIABLE
C Y(*) -- VECTOR OF INITIAL VALUES OF DEPENDENT VARIABLES
C NEQN -- NUMBER OF EQUATIONS TO BE INTEGRATED
C H -- NOMINAL STEP SIZE INDICATING DIRECTION OF INTEGRATION
C AND MAXIMUM SIZE OF STEP.  MUST BE VARIABLE
C EPS -- LOCAL ERROR TOLERANCE PER STEP.  MUST BE VARIABLE
C WT(*) -- VECTOR OF NON-ZERO WEIGHTS FOR ERROR CRITERION
C START -- .TRUE.
C STEP  REQUIRES THE L2 NORM OF THE VECTOR WITH COMPONENTS
C LOCAL ERROR(L)/WT(L)  BE LESS THAN  EPS  FOR A SUCCESSFUL STEP.  THE
C ARRAY  WT  ALLOWS THE USER TO SPECIFY AN ERROR TEST APPROPRIATE
C FOR HIS PROBLEM.  FOR EXAMPLE,
C WT(L)=1.0  SPECIFIES ABSOLUTE ERROR,
C =ABS(Y(L))  ERROR RELATIVE TO THE MOST RECENT VALUE OF
C THE L-TH COMPONENT OF THE SOLUTION,
C =ABS(YP(L))  ERROR RELATIVE TO THE MOST RECENT VALUE OF
C THE L-TH COMPONENT OF THE DERIVATIVE,
C =MAX(WT(L),ABS(Y(L)))  ERROR RELATIVE TO THE LARGEST
C MAGNITUDE OF L-TH COMPONENT OBTAINED SO FAR,
C =ABS(Y(L))*RELERR/EPS+ABSERR/EPS  SPECIFIES A MIXED
C RELATIVE-ABSOLUTE TEST WHERE  RELERR  IS RELATIVE
C ERROR,  ABSERR  IS ABSOLUTE ERROR AND  EPS =
C MAX(RELERR,ABSERR) .
C SUBSEQUENT CALLS --
C SUBROUTINE  STEP  IS DESIGNED SO THAT ALL INFORMATION NEEDED TO
C CONTINUE THE INTEGRATION, INCLUDING THE STEP SIZE  H  AND THE ORDER
C K , IS RETURNED WITH EACH STEP.  WITH THE EXCEPTION OF THE STEP
C SIZE, THE ERROR TOLERANCE, AND THE WEIGHTS, NONE OF THE PARAMETERS
C SHOULD BE ALTERED.  THE ARRAY  WT  MUST BE UPDATED AFTER EACH STEP
C TO MAINTAIN RELATIVE ERROR TESTS LIKE THOSE ABOVE.  NORMALLY THE
C INTEGRATION IS CONTINUED JUST BEYOND THE DESIRED ENDPOINT AND THE
C SOLUTION INTERPOLATED THERE WITH SUBROUTINE  INTRP .  IF IT IS
C IMPOSSIBLE TO INTEGRATE BEYOND THE ENDPOINT, THE STEP SIZE MAY BE
C REDUCED TO HIT THE ENDPOINT SINCE THE CODE WILL NOT TAKE A STEP
C LARGER THAN THE  H  INPUT.  CHANGING THE DIRECTION OF INTEGRATION,
C I.E., THE SIGN OF  H , REQUIRES THE USER SET  START=.TRUE. BEFORE
C CALLING  STEP  AGAIN.  THIS IS THE ONLY SITUATION IN WHICH  START
C SHOULD BE ALTERED.
C OUTPUT FROM  STEP
C SUCCESSFUL STEP --
C THE SUBROUTINE RETURNS AFTER EACH SUCCESSFUL STEP WITH  START  AND
C CRASH  SET .FALSE. .  X  REPRESENTS THE INDEPENDENT VARIABLE
C ADVANCED ONE STEP OF LENGTH  HOLD  FROM ITS VALUE ON INPUT AND  Y
C THE SOLUTION VECTOR AT THE NEW VALUE OF  X .  ALL OTHER PARAMETERS
C REPRESENT INFORMATION CORRESPONDING TO THE NEW  X  NEEDED TO
C CONTINUE THE INTEGRATION.
C UNSUCCESSFUL STEP --
C WHEN THE ERROR TOLERANCE IS TOO SMALL FOR THE MACHINE PRECISION,
C THE SUBROUTINE RETURNS WITHOUT TAKING A STEP AND  CRASH=.TRUE. .
C AN APPROPRIATE STEP SIZE AND ERROR TOLERANCE FOR CONTINUING ARE
C ESTIMATED AND ALL OTHER INFORMATION IS RESTORED AS UPON INPUT
C BEFORE RETURNING.  TO CONTINUE WITH THE LARGER TOLERANCE, THE USER
C JUST CALLS THE CODE AGAIN.  A RESTART IS NEITHER REQUIRED NOR
C DESIRABLE.
      LOGICAL START,CRASH,PHASE1,NORND
      DIMENSION Y(NEQN),WT(NEQN),PHI(NEQN,16),P(NEQN),YP(NEQN),PSI(12)
      DIMENSION ALPHA(12),BETA(12),SIG(13),W(12),V(12),G(13),GSTR(13),
     & TWO(13)
      EXTERNAL F
C***********************************************************************
C*  THE ONLY MACHINE DEPENDENT CONSTANTS ARE BASED ON THE MACHINE UNIT *
C*  ROUNDOFF ERROR  U  WHICH IS THE SMALLEST POSITIVE NUMBER SUCH THAT *
C*  1.0+U .GT. 1.0  .  THE USER MUST CALCULATE  U  AND INSERT          *
C*  TWOU=2.0*U  AND  FOURU=4.0*U  IN THE DATA STATEMENT BEFORE CALLING *
C*  THE CODE.  THE ROUTINE  MACHIN  CALCULATES  U .                    *
      DATA TWOU,FOURU/.15E-6,.3E-6/
C***********************************************************************
      DATA TWO/2.,4.,8.,16.,32.,64.,128.,256.,512.,1024.,2048.,4096.,
     & 8192./
      DATA GSTR/0.50,0.0833,0.0417,0.0264,0.0188,0.0143,0.0114,0.00936,
     & 0.00789,0.00679,0.00592,0.00524,0.00468/
C DATA G(1),G(2)/1.0,0.5/,SIG(1)/1.0/
C ***     BEGIN BLOCK 0     ***
C CHECK IF STEP SIZE OR ERROR TOLERANCE IS TOO SMALL FOR MACHINE
C PRECISION.  IF FIRST STEP, INITIALIZE PHI ARRAY AND ESTIMATE A
C STARTING STEP SIZE.
C ***
C IF STEP SIZE IS TOO SMALL, DETERMINE AN ACCEPTABLE ONE
      CRASH=.TRUE.
      IF(ABS(H).GE.FOURU*ABS(X))THEN
        P5EPS=0.5*EPS
C IF ERROR TOLERANCE IS TOO SMALL, INCREASE IT TO AN ACCEPTABLE VALUE
        ROUND=0.
        DO L=1,NEQN
          ROUND=ROUND+(Y(L)/WT(L))**2
        ENDDO
        ROUND=TWOU*SQRT(ROUND)
        IF(P5EPS.GE.ROUND)THEN
          CRASH=.FALSE.
          G(1)=1.
          G(2)=0.5
          SIG(1)=1.
          IF(START)THEN
C INITIALIZE.  COMPUTE APPROPRIATE STEP SIZE FOR FIRST STEP
            CALL F(X,Y,YP)
            SUM=0.
            DO L=1,NEQN
              PHI(L,1)=YP(L)
              PHI(L,2)=0.
              SUM=SUM+(YP(L)/WT(L))**2
            ENDDO
            SUM=SQRT(SUM)
            ABSH=ABS(H)
            IF(EPS.LT.16.*SUM*H*H)ABSH=0.25*SQRT(EPS/SUM)
            H=SIGN(MAX(ABSH,FOURU*ABS(X)),H)
            HOLD=0.
            K=1
            KOLD=0
            START=.FALSE.
            PHASE1=.TRUE.
            NORND=.TRUE.
            IF(P5EPS.LE.100.*ROUND)THEN
              NORND=.FALSE.
              DO L=1,NEQN
                PHI(L,15)=0.
              ENDDO
            ENDIF
          ENDIF
          IFAIL=0
C ***     END BLOCK 0     ***
C ***     BEGIN BLOCK 1     ***
C COMPUTE COEFFICIENTS OF FORMULAS FOR THIS STEP.  AVOID COMPUTING
C THOSE QUANTITIES NOT CHANGED WHEN STEP SIZE IS NOT CHANGED.
C ***
          DO WHILE(.TRUE.)
            KP1=K+1
            KP2=K+2
            KM1=K-1
            KM2=K-2
C NS IS THE NUMBER OF STEPS TAKEN WITH SIZE H, INCLUDING THE CURRENT
C ONE.  WHEN K.LT.NS, NO COEFFICIENTS CHANGE
            IF(H.NE.HOLD)NS=0
            IF(NS.LE.KOLD)NS=NS+1
            NSP1=NS+1
            IF(K.GE.NS)THEN
C COMPUTE THOSE COMPONENTS OF ALPHA(*),BETA(*),PSI(*),SIG(*) WHICH
C ARE CHANGED
              BETA(NS)=1.
              REALNS=NS
              ALPHA(NS)=1./REALNS
              TEMP1=H*REALNS
              SIG(NSP1)=1.
              IF(K.GE.NSP1)THEN
                DO I=NSP1,K
                IM1=I-1
                TEMP2=PSI(IM1)
                PSI(IM1)=TEMP1
                BETA(I)=BETA(IM1)*PSI(IM1)/TEMP2
                TEMP1=TEMP2+H
                ALPHA(I)=H/TEMP1
                REALI=I
                SIG(I+1)=REALI*ALPHA(I)*SIG(I)
                ENDDO
              ENDIF
              PSI(K)=TEMP1
C COMPUTE COEFFICIENTS G(*)
C INITIALIZE V(*) AND SET W(*).  G(2) IS SET IN DATA STATEMENT
              IF(NS.GT.1)THEN
C IF ORDER WAS RAISED, UPDATE DIAGONAL PART OF V(*)
                IF(K.GT.KOLD)THEN
                TEMP4=K*KP1
                V(K)=1./TEMP4
                NSM2=NS-2
                IF(NSM2.GE.1)THEN
                DO J=1,NSM2
                I=K-J
                V(I)=V(I)-ALPHA(J+1)*V(I+1)
                ENDDO
                ENDIF
                ENDIF
C UPDATE V(*) AND SET W(*)
                LIMIT1=KP1-NS
                TEMP5=ALPHA(NS)
                DO IQ=1,LIMIT1
                V(IQ)=V(IQ)-TEMP5*V(IQ+1)
                W(IQ)=V(IQ)
                ENDDO
                G(NSP1)=W(1)
              ELSE
                DO IQ=1,K
                TEMP3=IQ*(IQ+1)
                V(IQ)=1./TEMP3
                W(IQ)=V(IQ)
                ENDDO
              ENDIF
C COMPUTE THE G(*) IN THE WORK VECTOR W(*)
              NSP2=NS+2
              IF(KP1.GE.NSP2)THEN
                DO I=NSP2,KP1
                LIMIT2=KP2-I
                TEMP6=ALPHA(I-1)
                DO IQ=1,LIMIT2
                W(IQ)=W(IQ)-TEMP6*W(IQ+1)
                ENDDO
                G(I)=W(1)
                ENDDO
              ENDIF
            ENDIF
C ***     END BLOCK 1     ***
C ***     BEGIN BLOCK 2     ***
C PREDICT A SOLUTION P(*), EVALUATE DERIVATIVES USING PREDICTED
C SOLUTION, ESTIMATE LOCAL ERROR AT ORDER K AND ERRORS AT ORDERS K,
C K-1, K-2 AS IF CONSTANT STEP SIZE WERE USED.
C ***
C CHANGE PHI TO PHI STAR
            IF(K.GE.NSP1)THEN
              DO I=NSP1,K
                TEMP1=BETA(I)
                DO L=1,NEQN
                PHI(L,I)=TEMP1*PHI(L,I)
                ENDDO
              ENDDO
            ENDIF
C PREDICT SOLUTION AND DIFFERENCES
            DO L=1,NEQN
              PHI(L,KP2)=PHI(L,KP1)
              PHI(L,KP1)=0.
              P(L)=0.
            ENDDO
            DO J=1,K
              I=KP1-J
              IP1=I+1
              TEMP2=G(I)
              DO L=1,NEQN
                P(L)=P(L)+TEMP2*PHI(L,I)
                PHI(L,I)=PHI(L,I)+PHI(L,IP1)
              ENDDO
            ENDDO
            IF(NORND)THEN
              DO L=1,NEQN
                P(L)=Y(L)+H*P(L)
              ENDDO
            ELSE
              DO L=1,NEQN
                TAU=H*P(L)-PHI(L,15)
                P(L)=Y(L)+TAU
                PHI(L,16)=(P(L)-Y(L))-TAU
              ENDDO
            ENDIF
            XOLD=X
            X=X+H
            ABSH=ABS(H)
            CALL F(X,P,YP)
C ESTIMATE ERRORS AT ORDERS K,K-1,K-2
            ERKM2=0.
            ERKM1=0.
            ERK=0.
            DO L=1,NEQN
              TEMP3=1./WT(L)
              TEMP4=YP(L)-PHI(L,1)
              IF(KM2.GE.0)THEN
                IF(KM2.NE.0)ERKM2=ERKM2+((PHI(L,KM1)+TEMP4)*TEMP3)**2
                ERKM1=ERKM1+((PHI(L,K)+TEMP4)*TEMP3)**2
              ENDIF
              ERK=ERK+(TEMP4*TEMP3)**2
            ENDDO
            IF(KM2.GE.0)THEN
              IF(KM2.NE.0)ERKM2=ABSH*SIG(KM1)*GSTR(KM2)*SQRT(ERKM2)
              ERKM1=ABSH*SIG(K)*GSTR(KM1)*SQRT(ERKM1)
            ENDIF
            TEMP5=ABSH*SQRT(ERK)
            ERR=TEMP5*(G(K)-G(KP1))
            ERK=TEMP5*SIG(KP1)*GSTR(K)
            KNEW=K
C TEST IF ORDER SHOULD BE LOWERED
            IF(KM2.GE.0)THEN
              IF(KM2.EQ.0)THEN
                IF(ERKM1.LE.0.5*ERK)KNEW=KM1
              ELSE
                IF(MAX(ERKM1,ERKM2).LE.ERK)KNEW=KM1
              ENDIF
            ENDIF
C TEST IF STEP SUCCESSFUL
            IF(ERR.LE.EPS)EXIT
C ***     END BLOCK 2     ***
C ***     BEGIN BLOCK 3     ***
C THE STEP IS UNSUCCESSFUL.  RESTORE  X, PHI(*,*), PSI(*) .
C IF THIRD CONSECUTIVE FAILURE, SET ORDER TO ONE.  IF STEP FAILS MORE
C THAN THREE TIMES, CONSIDER AN OPTIMAL STEP SIZE.  DOUBLE ERROR
C TOLERANCE AND RETURN IF ESTIMATED STEP SIZE IS TOO SMALL FOR MACHINE
C PRECISION.
C ***
C RESTORE X, PHI(*,*) AND PSI(*)
            PHASE1=.FALSE.
            X=XOLD
            DO I=1,K
              TEMP1=1./BETA(I)
              IP1=I+1
              DO L=1,NEQN
                PHI(L,I)=TEMP1*(PHI(L,I)-PHI(L,IP1))
              ENDDO
            ENDDO
            IF(K.GE.2)THEN
              DO I=2,K
                PSI(I-1)=PSI(I)-H
              ENDDO
            ENDIF
C ON THIRD FAILURE, SET ORDER TO ONE.  THEREAFTER, USE OPTIMAL STEP
C SIZE
            IFAIL=IFAIL+1
            TEMP2=0.5
            IF(IFAIL.GE.3)THEN
              IF(IFAIL.NE.3)THEN
                IF(P5EPS.LT.0.25*ERK)TEMP2=SQRT(P5EPS/ERK)
              ENDIF
              KNEW=1
            ENDIF
            H=TEMP2*H
            K=KNEW
            IF(ABS(H).LT.FOURU*ABS(X))GOTO 120
          ENDDO
C ***     END BLOCK 3     ***
C ***     BEGIN BLOCK 4     ***
C THE STEP IS SUCCESSFUL.  CORRECT THE PREDICTED SOLUTION, EVALUATE
C THE DERIVATIVES USING THE CORRECTED SOLUTION AND UPDATE THE
C DIFFERENCES.  DETERMINE BEST ORDER AND STEP SIZE FOR NEXT STEP.
C ***
          KOLD=K
          HOLD=H
C CORRECT AND EVALUATE
          TEMP1=H*G(KP1)
          IF(NORND)THEN
            DO L=1,NEQN
              Y(L)=P(L)+TEMP1*(YP(L)-PHI(L,1))
            ENDDO
          ELSE
            DO L=1,NEQN
              RHO=TEMP1*(YP(L)-PHI(L,1))-PHI(L,16)
              Y(L)=P(L)+RHO
              PHI(L,15)=(Y(L)-P(L))-RHO
            ENDDO
          ENDIF
          CALL F(X,Y,YP)
C UPDATE DIFFERENCES FOR NEXT STEP
          DO L=1,NEQN
            PHI(L,KP1)=YP(L)-PHI(L,1)
            PHI(L,KP2)=PHI(L,KP1)-PHI(L,KP2)
          ENDDO
          DO I=1,K
            DO L=1,NEQN
              PHI(L,I)=PHI(L,I)+PHI(L,KP1)
            ENDDO
          ENDDO
C ESTIMATE ERROR AT ORDER K+1 UNLESS:
C IN FIRST PHASE WHEN ALWAYS RAISE ORDER,
C ALREADY DECIDED TO LOWER ORDER,
C STEP SIZE NOT CONSTANT SO ESTIMATE UNRELIABLE
          ERKP1=0.
          IF(KNEW.EQ.KM1.OR.K.EQ.12)PHASE1=.FALSE.
          IF(.NOT.PHASE1)THEN
            IF(KNEW.NE.KM1)THEN
              IF(KP1.GT.NS)GOTO 110
              DO L=1,NEQN
                ERKP1=ERKP1+(PHI(L,KP2)/WT(L))**2
              ENDDO
              ERKP1=ABSH*GSTR(KP1)*SQRT(ERKP1)
C USING ESTIMATED ERROR AT ORDER K+1, DETERMINE APPROPRIATE ORDER
C FOR NEXT STEP
              IF(K.GT.1)THEN
                IF(ERKM1.GT.MIN(ERK,ERKP1))THEN
                IF(ERKP1.GE.ERK.OR.K.EQ.12)GOTO 110
                GOTO 100
                ENDIF
              ELSEIF(ERKP1.GE.0.5*ERK)THEN
                GOTO 110
              ELSE
                GOTO 100
              ENDIF
            ENDIF
C LOWER ORDER
            K=KM1
            ERK=ERKM1
            GOTO 110
          ENDIF
C HERE ERKP1 .LT. ERK .LT. MAX(ERKM1,ERKM2) ELSE ORDER WOULD HAVE
C BEEN LOWERED IN BLOCK 2.  THUS ORDER IS TO BE RAISED
C RAISE ORDER
  100     K=KP1
          ERK=ERKP1
C WITH NEW ORDER DETERMINE APPROPRIATE STEP SIZE FOR NEXT STEP
  110     HNEW=H+H
          IF(.NOT.PHASE1)THEN
            IF(P5EPS.LT.ERK*TWO(K+1))THEN
              HNEW=H
              IF(P5EPS.LT.ERK)THEN
                TEMP2=K+1
                R=(P5EPS/ERK)**(1./TEMP2)
                HNEW=ABSH*MAX(0.5,MIN(0.9,R))
                HNEW=SIGN(MAX(HNEW,FOURU*ABS(X)),H)
              ENDIF
            ENDIF
          ENDIF
          H=HNEW
          RETURN
  120     CRASH=.TRUE.
          H=SIGN(FOURU*ABS(X),H)
          EPS=EPS+EPS
        ELSE
          EPS=2.0*ROUND*(1.+FOURU)
        ENDIF
      ELSE
        H=SIGN(FOURU*ABS(X),H)
      ENDIF
      RETURN
C ***     END BLOCK 4     ***
      END
      SUBROUTINE INTRP(X,Y,XOUT,YOUT,YPOUT,NEQN,KOLD,PHI,PSI)
C THE METHODS IN SUBROUTINE  STEP  APPROXIMATE THE SOLUTION NEAR  X
C BY A POLYNOMIAL.  SUBROUTINE  INTRP  APPROXIMATES THE SOLUTION AT
C XOUT  BY EVALUATING THE POLYNOMIAL THERE.  INFORMATION DEFINING THIS
C POLYNOMIAL IS PASSED FROM  STEP  SO  INTRP  CANNOT BE USED ALONE.
C THIS CODE IS COMPLETELY EXPLAINED AND DOCUMENTED IN THE TEXT,
C COMPUTER SOLUTION OF ORDINARY DIFFERENTIAL EQUATIONS:  THE INITIAL
C VALUE PROBLEM  BY L. F. SHAMPINE AND M. K. GORDON.
C INPUT TO INTRP --
C ALL FLOATING POINT VARIABLES ARE SINGLE PRECISION
C THE USER PROVIDES STORAGE IN THE CALLING PROGRAM FOR THE ARRAYS IN
C THE CALL LIST
      DIMENSION Y(NEQN),YOUT(NEQN),YPOUT(NEQN),PHI(NEQN,16),PSI(12)
C AND DEFINES
C XOUT -- POINT AT WHICH SOLUTION IS DESIRED.
C THE REMAINING PARAMETERS ARE DEFINED IN  STEP  AND PASSED TO  INTRP
C FROM THAT SUBROUTINE
C OUTPUT FROM  INTRP --
C YOUT(*) -- SOLUTION AT  XOUT
C YPOUT(*) -- DERIVATIVE OF SOLUTION AT  XOUT
C THE REMAINING PARAMETERS ARE RETURNED UNALTERED FROM THEIR INPUT
C VALUES.  INTEGRATION WITH  STEP  MAY BE CONTINUED.
      DIMENSION G(13),W(13),RHO(13)
      DATA G(1)/1./,RHO(1)/1./
      HI=XOUT-X
      KI=KOLD+1
      KIP1=KI+1
C INITIALIZE W(*) FOR COMPUTING G(*)
      DO I=1,KI
        TEMP1=I
        W(I)=1./TEMP1
      ENDDO
      TERM=0.
C COMPUTE G(*)
      DO J=2,KI
        JM1=J-1
        PSIJM1=PSI(JM1)
        GAMMA=(HI+TERM)/PSIJM1
        ETA=HI/PSIJM1
        LIMIT1=KIP1-J
        DO I=1,LIMIT1
          W(I)=GAMMA*W(I)-ETA*W(I+1)
        ENDDO
        G(J)=W(1)
        RHO(J)=GAMMA*RHO(JM1)
        TERM=PSIJM1
      ENDDO
C INTERPOLATE
      DO L=1,NEQN
        YPOUT(L)=0.
        YOUT(L)=0.
      ENDDO
      DO J=1,KI
        I=KIP1-J
        TEMP2=G(I)
        TEMP3=RHO(I)
        DO L=1,NEQN
          YOUT(L)=YOUT(L)+TEMP2*PHI(L,I)
          YPOUT(L)=YPOUT(L)+TEMP3*PHI(L,I)
        ENDDO
      ENDDO
      DO L=1,NEQN
        YOUT(L)=Y(L)+HI*YOUT(L)
      ENDDO
      RETURN
      END
      SUBROUTINE QINIT(N,BETAM,NPTSQ,QWORK)
C COMPUTES NODES AND WEIGHTS FOR GAUSS-JACOBI QUADRATURE
C CALLING SEQUENCE PARAMETERS: SEE COMMENTS IN SCSOLV
C THE WORK ARRAY QWORK MUST BE DIMENSIONED AT LEAST NPTSQ * (2N+3).
C IT IS DIVIDED UP INTO 2N+3 VECTORS OF LENGTH NPTSQ: THE FIRST
C N+1 CONTAIN QUADRATURE NODES ON OUTPUT, THE NEXT N+1 CONTAIN
C QUADRATURE WEIGHTS ON OUTPUT, AND THE FINAL ONE IS A
C SCRATCH VECTOR NEEDED BY GAUSSJ.
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION QWORK(1),BETAM(N)
C FOR EACH FINITE VERTEX W(K), COMPUTE NODES AND WEIGHTS FOR
C ONE-SIDED GAUSS-JACOBI QUADRATURE ALONG A CURVE BEGINNING AT Z(K):
      ISCR=NPTSQ*(2*N+2)+1
      DO K=1,N
        INODES=NPTSQ*(K-1)+1
        IWTS=NPTSQ*(N+K)+1
        IF(BETAM(K).GT.-1.)CALL GAUSSJ(NPTSQ,0.,BETAM(K),QWORK(ISCR),
     &   QWORK(INODES),QWORK(IWTS))
      ENDDO
C COMPUTE NODES AND WEIGHTS FOR PURE GAUSSIAN QUADRATURE:
      INODES=NPTSQ*N+1
      IWTS=NPTSQ*(2*N+1)+1
      CALL GAUSSJ(NPTSQ,0.,0.,QWORK(ISCR),QWORK(INODES),QWORK(IWTS))
      RETURN
      END
      SUBROUTINE SCSOLV(IPRINT,IGUESS,TOL,ERREST,N,C,Z,WC,W,BETAM,
     & NPTSQ,QWORK)
C THIS SUBROUTINE COMPUTES THE ACCESSORY PARAMETERS C AND
C Z(K) FOR THE SCHWARZ-CHRISTOFFEL TRANSFORMATION
C WHICH SENDS THE UNIT DISK TO THE INTERIOR OF THE POLYGON
C W(1),...,W(N).  THIS MAPPING IS OF THE FORM:
C Z    N
C W  =  WC +  C * INT PROD (1-Z/Z(K))**BETAM(K) DZ .    (1.2)
C 0   K=1
C THE IMAGE POLYGON MAY BE UNBOUNDED; PERMITTED ANGLES LIE IN THE
C RANGE -3.LE.BETAM(K).LE.1.  W(N) AND W(1) MUST BE FINITE.
C WE NORMALIZE BY THE CONDITIONS:
C Z(N)=1                                                  (2.1)
C W(0.0)=WC  (A POINT IN THE INTERIOR OF THE POLYGON)     (2.1)
C CALLING SEQUENCE:
C IPRINT  -2,-1,0, OR 1 FOR INCREASING AMOUNTS OF OUTPUT (INPUT)
C IGUESS  1 IF AN INITIAL GUESS FOR Z IS SUPPLIED, OTHERWISE 0
C (INPUT)
C TOL     DESIRED ACCURACY IN SOLUTION OF NONLINEAR SYSTEM
C (INPUT).  RECOMMENDED VALUE: 10.**(-NPTSQ-1) * TYPICAL
C SIZE OF VERTICES W(K)
C ERREST  ESTIMTATED ERROR IN SOLUTION (OUTPUT).  MORE
C PRECISELY, ERREST IS AN APPROXIMATE BOUND FOR HOW FAR
C THE TRUE VERTICES OF THE IMAGE POLYGON MAY BE FROM THOSE
C COMPUTED BY NUMERICAL INTEGRATION USING THE
C NUMERICALLY DETERMINED PREVERTICES Z(K).
C N       NUMBER OF VERTICES OF THE IMAGE POLYGON (INPUT).
C MUST BE .LE. 20
C C       COMPLEX SCALE FACTOR IN FORMULA ABOVE (OUTPUT)
C Z       COMPLEX ARRAY OF PREVERTICES ON THE UNIT CIRCLE.
C DIMENSION AT LEAST N.  IF AN INITIAL GUESS IS
C BEING SUPPLIED IT SHOULD BE IN Z ON INPUT, WITH Z(N)=1.
C IN ANY CASE THE CORRECT PREVERTICES WILL BE IN Z ON OUTPUT.
C WC      COMPLEX IMAGE OF 0 IN THE POLYGON, AS IN ABOVE FORMULA
C (INPUT).  IT IS SAFEST TO PICK WC TO BE AS CENTRAL AS
C POSSIBLE IN THE POLYGON IN THE SENSE THAT AS FEW PARTS
C OF THE POLYGON AS POSSIBLE ARE SHIELDED FROM WC BY
C REENTRANT EDGES.
C W       COMPLEX ARRAY OF VERTICES OF THE IMAGE POLYGON
C (INPUT).  DIMENSION AT LEAST N.  IT IS A GOOD IDEA
C TO KEEP THE W(K) ROUGHLY ON THE SCALE OF UNITY.
C W(K) WILL BE IGNORED WHEN THE VERTEX LIES AT INFINITY;
C SEE BETAM, BELOW.  EACH CONNECTED BOUNDARY COMPONENT
C MUST INCLUDE AT LEAST ONE VERTEX W(K), EVEN IF IT
C HAS TO BE A DEGENERATE VERTEX WITH BETAM(K)=0.
C W(N) AND W(1) MUST BE FINITE.
C BETAM   REAL ARRAY WITH BETAM(K) THE EXTERNAL ANGLE IN THE
C POLYGON AT VERTEX K DIVIDED BY MINUS PI (INPUT).
C DIMENSION AT LEAST N.  PERMITTED VALUES LIE IN
C THE RANGE -3.LE.BETAM(K).LE.1.  (EXAMPLES: EACH
C BETAM(K) IS -1/2 FOR A RECTANGLE, -2/3 FOR AN EQUI-
C LATERAL TRIANGLE, +1 AT THE END OF A SLIT.)  THE
C SUM OF THE BETAM(K) WILL BE -2 IF THEY HAVE BEEN
C SET CORRECTLY.  BETAM(N-1) SHOULD NOT BE 0 OR 1.
C W(K) LIES AT INFINITY IF AND ONLY IF BETAM(K).LE.-1.
C NPTSQ   THE NUMBER OF POINTS TO BE USED PER SUBINTERVAL
C IN GAUSS-JACOBI QUADRATURE (INPUT).  RECOMMENDED
C VALUE: EQUAL TO ONE MORE THAN THE NUMBER OF DIGITS
C OF ACCURACY DESIRED IN THE ANSWER.  MUST BE THE SAME
C AS IN THE CALL TO QINIT WHICH FILLED THE VECTOR QWORK.
C QWORK   REAL QUADRATURE WORK ARRAY (INPUT).  DIMENSION
C AT LEAST NPTSQ * (2N+3) BUT NO GREATER THAN 460.
C BEFORE CALLING SCSOLV QWORK MUST HAVE BEEN FILLED
C BY SUBROUTINE QINIT.
C THE PROBLEM IS SOLVED BY FINDING THE
C SOLUTION TO A SYSTEM OF N-1 NONLINEAR EQUATIONS IN THE N-1
C UNKNOWNS Y(1),...,Y(N-1), WHICH ARE RELATED TO THE POINTS
C Z(K) BY THE FORMULA:
C Y(K)=LOG ((TH(K)-TH(K-1))/(TH(K+1)-TH(K)))            (2.7)
C WHERE TH(K) DENOTES THE ARGUMENT OF Z(K).
C SUBROUTINE SCFUN DEFINES THIS SYSTEM OF EQUATIONS.
C THE ORIGINAL PROBLEM IS SUBJECT TO THE CONTRAINTS TH(K) < TH(K+1),
C BUT THESE VANISH IN THE TRANSFORMATION FROM Z TO Y.
C REFERENCE:  L. N. TREFETHEN, "NUMERICAL COMPUTATION OF THE
C SCHWARZ-CHRISTOFFEL TRANSFORMATION," SIAM J. SCI. STAT. COMP. 1
C (1980), 82-102.  EQUATION NOS. ABOVE ARE TAKEN FROM THIS PAPER.
C LLOYD N. TREFETHEN
C COURANT INSTITUTE OF MATHEMATICAL SCIENCES, NEW YORK UNIVERSITY
C 251 MERCER ST.,   NEW YORK, NY 10012
C (212) 460-7224
C OCTOBER 1979 (VERSION 1); JULY 1983 (VERSION 2)
      IMPLICIT COMPLEX(C,W,Z)
      COMMON /PARAM1/KFIX(20),KRAT(20),NCOMP,NPTSQ2,C2,QWORK2(460),
     & BETAM2(20),Z2(20),WC2,W2(20)
      DIMENSION Z(N),W(N),BETAM(N),QWORK(1)
      DIMENSION AJINV(20,20),SCR(900),FVAL(19),Y(19)
      EXTERNAL SCFUN
      NM=N-1
C CHECK INPUT DATA:
      CALL CHECK(TOL,N,W,BETAM)
C DETERMINE NUMBER OF BOUNDARY COMPONENTS, ETC.:
C PASS 1: ONE FIXED POINT FOR EACH INFINITE VERTEX:
      NCOMP=0
      DO K=2,NM
        IF(BETAM(K).LE.-1.)THEN
          NCOMP=NCOMP+1
          KFIX(NCOMP)=K-1
          IF(NCOMP.EQ.1)KFIX(NCOMP)=1
        ENDIF
      ENDDO
      IF(NCOMP.LE.0)THEN
        NCOMP=1
        KFIX(NCOMP)=1
      ENDIF
C PASS 2: ONE RATIO FOR EACH LINE SEGMENT:
      NEQ=2*NCOMP
      DO K=1,NM
        IF(NEQ.EQ.N-1)EXIT
        IF(.NOT.(BETAM(K).LE.-1..OR.BETAM(K+1).LE.-1.))THEN
          NEQ=NEQ+1
          KRAT(NEQ)=K
        ENDIF
      ENDDO
      Z(N)=(1.,0.)
C INITIAL GUESS, CASE IGUESS.EQ.0:
C (VERTICES EQUALLY SPACED AROUND CIRCLE):
      IF(IGUESS.EQ.0)THEN
        DO K=1,NM
          Y(K)=0.
        ENDDO
      ELSE
C INITIAL GUESS, CASE IGUESS.NE.0:
C (VERTICES SUPPLIED ON INPUT):
        DO K=1,NM
          KM=K-1
          IF(KM.EQ.0)KM=N
          TMP1=AIMAG(LOG(Z(K+1)/Z(K)))
          IF(TMP1.LT.0.)TMP1=TMP1+2.*ACOS(-1.)
          TMP2=AIMAG(LOG(Z(K)/Z(KM)))
          IF(TMP2.LT.0.)TMP2=TMP2+2.*ACOS(-1.)
          Y(K)=LOG(TMP2)-LOG(TMP1)
        ENDDO
      ENDIF
C NS01A CONTROL PARAMETERS:
      DSTEP=.005
      DMAX=20.
      MAXFUN=(N-1)*15
C COPY INPUT DATA TO /PARAM1/ FOR SCFUN:
C (THIS IS NECESSARY BECAUSE NS01A REQUIRES A FIXED CALLING
C SEQUENCE IN SUBROUTINE SCFUN.)
      NPTSQ2=NPTSQ
      WC2=WC
      DO K=1,N
        Z2(K)=Z(K)
        BETAM2(K)=BETAM(K)
        W2(K)=W(K)
      ENDDO
      NWDIM=NPTSQ*(2*N+3)
      DO I=1,NWDIM
        QWORK2(I)=QWORK(I)
      ENDDO
C SOLVE NONLINEAR SYSTEM WITH NS01A:
      CALL NS01A(NM,Y,FVAL,AJINV,DSTEP,DMAX,TOL,MAXFUN,IPRINT,SCR,
     & SCFUN)
C COPY OUTPUT DATA FROM /PARAM1/:
      C=C2
      DO K=1,NM
        Z(K)=Z2(K)
      ENDDO
C PRINT RESULTS AND TEST ACCURACY:
      IF(IPRINT.GE.0)CALL SCOUTP(N,C,Z,WC,W,BETAM,NPTSQ)
      CALL SCTEST(ERREST,N,C,Z,WC,W,BETAM,NPTSQ,QWORK)
      IF(IPRINT.GE.-1)WRITE(6,1000)ERREST
 1000 FORMAT(' ERREST:',E12.4/)
      RETURN
      END
      FUNCTION WSC(ZZ,KZZ,Z0,W0,K0,N,C,Z,BETAM,NPTSQ,QWORK)
C COMPUTES FORWARD MAP W(ZZ)
C CALLING SEQUENCE:
C ZZ     POINT IN THE DISK AT WHICH W(ZZ) IS DESIRED (INPUT)
C KZZ    K IF ZZ=Z(K) FOR SOME K, OTHERWISE 0 (INPUT)
C Z0     NEARBY POINT IN THE DISK AT WHICH W(Z0) IS KNOWN AND
C FINITE (INPUT)
C W0     W(Z0)  (INPUT)
C K0     K IF Z0=Z(K) FOR SOME K, OTHERWISE 0 (INPUT)
C N,C,Z,BETAM,NPTSQ,QWORK     AS IN SCSOLV (INPUT)
C CONVENIENT VALUES OF Z0, W0, AND K0 FOR MOST APPLICATIONS CAN BE
C SUPPLIED BY SUBROUTINE NEARZ.
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION Z(N),BETAM(N),QWORK(1)
      WSC=W0+C*ZQUAD(Z0,K0,ZZ,KZZ,N,Z,BETAM,NPTSQ,QWORK)
      RETURN
      END
      FUNCTION ZSC(WW,IGUESS,ZINIT,Z0,W0,K0,EPS,IER,N,C,Z,WC,W,BETAM,
     & NPTSQ,QWORK)
C COMPUTES INVERSE MAP Z(WW) BY NEWTON ITERATION
C CALLING SEQUENCE:
C WW     POINT IN THE POLYGON AT WHICH Z(WW) IS DESIRED (INPUT)
C IGUESS (INPUT)
C .EQ.1-INITIAL GUESS IS SUPPLIED AS PARAMETER ZINIT
C .NE.1-GET INITIAL GUESS FROM PROGRAM ODE (SLOWER).
C FOR THIS THE SEGMENT WC-WW MUST LIE WITHIN
C THE POLYGON.
C ZINIT  INITIAL GUESS IF IGUESS.EQ.1, OTHERWISE IGNORED (INPUT).
C MAY NOT BE A PREVERTEX Z(K)
C Z0     POINT IN THE DISK NEAR Z(WW) AT WHICH W(Z0) IS KNOWN AND
C FINITE (INPUT).
C W0     W(Z0)  (INPUT).  THE LINE SEGMENT FROM W0 TO WW MUST
C LIE ENTIRELY WITHIN THE CLOSED POLYGON.
C K0     K IF Z0=Z(K) FOR SOME K, OTHERWISE 0 (INPUT)
C EPS    DESIRED ACCURACY IN ANSWER Z(WW)  (INPUT)
C IER    ERROR FLAG (INPUT AND OUTPUT).
C ON INPUT, GIVE IER.NE.0 TO SUPPRESS ERROR MESSAGES.
C ON OUTPUT, IER.NE.0 INDICATES UNSUCCESSFUL COMPUTATION --
C TRY AGAIN WITH A BETTER INITIAL GUESS.
C N,C,Z,WC,W,BETAM,NPTSQ,QWORK     AS IN SCSOLV (INPUT)
C CONVENIENT VALUES OF Z0, W0, AND K0 FOR SOME APPLICATIONS CAN BE
C SUPPLIED BY SUBROUTINE NEARW.
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION SCR(142),ISCR(5)
      DIMENSION Z(N),W(N),BETAM(N),QWORK(1)
      EXTERNAL ZFODE
      LOGICAL ODECAL
      COMMON /PARAM2/CDWDT,Z2(20),BETAM2(20),N2
      ODECAL=.FALSE.
      IF(IGUESS.NE.1)GOTO 110
      ZI=ZINIT
C REFINE ANSWER BY NEWTON ITERATION:
  100 CONTINUE
      DO ITER=1,10
        ZFNWT=WW-WSC(ZI,0,Z0,W0,K0,N,C,Z,BETAM,NPTSQ,QWORK)
        ZI=ZI+ZFNWT/(C*ZPROD(ZI,0,N,Z,BETAM))
        IF(ABS(ZI).GE.1.1)ZI=.5*ZI/ABS(ZI)
        IF(ABS(ZFNWT).LT.EPS)GOTO 130
      ENDDO
      IF(ODECAL)GOTO 120
C GET INITIAL GUESS ZI FROM PROGRAM ODE:
  110 N2=N
      DO K=1,N
        Z2(K)=Z(K)
        BETAM2(K)=BETAM(K)
      ENDDO
      ZI=(0.,0.)
      T=0.
      IFLAG=-1
      RELERR=0.
      ABSERR=1.E-4
      CDWDT=(WW-WC)/C
      CALL ODE(ZFODE,2,ZI,T,1.,RELERR,ABSERR,IFLAG,SCR,ISCR)
      IF(IFLAG.NE.2.AND.IER.EQ.0)WRITE(6,1000)IFLAG
      ODECAL=.TRUE.
      GOTO 100
  120 IF(IER.EQ.0)WRITE(6,1010)
      IER=1
  130 ZSC=ZI
 1000 FORMAT(/' *** NONSTANDARD RETURN FROM ODE IN ZSC: IFLAG =',I2/)
 1010 FORMAT(/' *** POSSIBLE ERROR IN ZSC: NO CONVERGENCE IN 10'/
     & '     ITERATIONS.  MAY NEED A BETTER INITIAL GUESS ZINIT')
      RETURN
      END
      SUBROUTINE ZFODE(T,ZZ,ZDZDT)
C COMPUTES THE FUNCTION ZDZDT NEEDED BY ODE IN ZSC.
      IMPLICIT COMPLEX(C,W,Z)
      COMMON /PARAM2/CDWDT,Z(20),BETAM(20),N
      ZDZDT=CDWDT/ZPROD(ZZ,0,N,Z,BETAM)
      RETURN
      END
      SUBROUTINE CHECK(EPS,N,W,BETAM)
C CHECKS GEOMETRY OF THE PROBLEM TO MAKE SURE IT IS A FORM USABLE
C BY SCSOLV.
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION W(N),BETAM(N)
      SUM=0.
      DO K=1,N
        SUM=SUM+BETAM(K)
      ENDDO
      IF(ABS(SUM+2.).GE.EPS)WRITE(6,1000)
      IF(BETAM(1).LE.-1.)THEN
        WRITE(6,1010)
      ELSEIF(BETAM(N).GT.-1.)THEN
        IF(ABS(BETAM(N-1)).LE.EPS)THEN
          WRITE(6,1030)
          WRITE(6,1050)
        ENDIF
        IF(ABS(BETAM(N-1)-1.).GT.EPS)THEN
          DO K=2,N
            IF(.NOT.(BETAM(K).LE.-1..OR.BETAM(K-1).LE.-1.))THEN
              IF(ABS(W(K)-W(K-1)).LE.EPS)GOTO 100
            ENDIF
          ENDDO
          IF(ABS(W(1)-W(N)).GT.EPS)THEN
            IF(N.LT.3)THEN
              WRITE(6,1070)
            ELSEIF(N.LE.20)THEN
              RETURN
            ELSE
              WRITE(6,1080)
            ENDIF
            STOP
          ENDIF
  100     WRITE(6,1060)
        ELSE
          WRITE(6,1040)
          WRITE(6,1050)
        ENDIF
      ELSE
        WRITE(6,1020)
      ENDIF
      STOP
 1000 FORMAT(/' *** ERROR IN CHECK: ANGLES DO NOT ADD UP TO 2'/)
 1010 FORMAT(/' *** ERROR IN CHECK: W(1) MUST BE FINITE'/)
 1020 FORMAT(/' *** ERROR IN CHECK: W(N) MUST BE FINITE'/)
 1030 FORMAT(/' *** WARNING IN CHECK: W(N-1) NOT DETERMINED'/)
 1040 FORMAT(/' *** ERROR IN CHECK: W(N-1) NOT DETERMINED')
 1050 FORMAT(/'   RENUMBER VERTICES SO THAT BETAM(N-1) IS NOT 0 OR 1')
 1060 FORMAT(/' *** ERROR IN CHECK: TWO ADJACENT VERTICES ARE EQUAL'/)
 1070 FORMAT(/' *** ERROR IN CHECK: N MUST BE NO LESS THAN 3'/)
 1080 FORMAT(/' *** ERROR IN CHECK: N MUST BE NO MORE THAN 20'/)
      END
      SUBROUTINE YZTRAN(N,Y,Z)
C TRANSFORMS Y(K) TO Z(K).  SEE COMMENTS IN SUBROUTINE SCSOLV.
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION Y(N),Z(N)
      NM=N-1
      PI=ACOS(-1.)
      DTH=1.
      THSUM=DTH
      DO K=1,NM
        DTH=DTH/EXP(Y(K))
        THSUM=THSUM+DTH
      ENDDO
      DTH=2.*PI/THSUM
      THSUM=DTH
      Z(1)=CMPLX(COS(DTH),SIN(DTH))
      DO K=2,NM
        DTH=DTH/EXP(Y(K-1))
        THSUM=THSUM+DTH
        Z(K)=CMPLX(COS(THSUM),SIN(THSUM))
      ENDDO
      RETURN
      END
      SUBROUTINE SCFUN(NDIM,Y,FVAL)
C THIS IS THE FUNCTION WHOSE ZERO MUST BE FOUND IN SCSOLV.
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION FVAL(NDIM),Y(NDIM)
      COMMON /PARAM1/KFIX(20),KRAT(20),NCOMP,NPTSQ,C,QWORK(460),BETAM
     & (20),Z(20),WC,W(20)
      N=NDIM+1
C TRANSFORM Y(K) TO Z(K):
      CALL YZTRAN(N,Y,Z)
C SET UP: COMPUTE INTEGRAL FROM 0 TO Z(N):
      WDENOM=ZQUAD((0.,0.),0,Z(N),N,N,Z,BETAM,NPTSQ,QWORK)
      C=(W(N)-WC)/WDENOM
C CASE 1: W(K) AND W(K+1) FINITE:
C (COMPUTE INTEGRAL ALONG CHORD Z(K)-Z(K+1)):
      NFIRST=2*NCOMP+1
      IF(NFIRST.LE.N-1)THEN
        DO NEQ=NFIRST,NDIM
          KL=KRAT(NEQ)
          KR=KL+1
          ZINT=ZQUAD(Z(KL),KL,Z(KR),KR,N,Z,BETAM,NPTSQ,QWORK)
          FVAL(NEQ)=ABS(W(KR)-W(KL))-ABS(C*ZINT)
        ENDDO
      ENDIF
C CASE 2: W(K+1) INFINITE:
C (COMPUTE CONTOUR INTEGRAL ALONG RADIUS 0-Z(K)):
      DO NVERT=1,NCOMP
        KR=KFIX(NVERT)
        ZINT=ZQUAD((0.,0.),0,Z(KR),KR,N,Z,BETAM,NPTSQ,QWORK)
        ZFVAL=W(KR)-WC-C*ZINT
        FVAL(2*NVERT-1)=REAL(ZFVAL)
        FVAL(2*NVERT)=AIMAG(ZFVAL)
      ENDDO
      RETURN
      END
      SUBROUTINE SCOUTP(N,C,Z,WC,W,BETAM,NPTSQ)
C PRINTS A TABLE OF K, W(K), TH(K), BETAM(K), AND Z(K).
C ALSO PRINTS THE CONSTANTS N, NPTSQ, WC, C.
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION Z(N),W(N),BETAM(N)
      WRITE(6,1000)N,NPTSQ
      PI=ACOS(-1.)
      DO K=1,N
        THDPI=AIMAG(LOG(Z(K)))/PI
        IF(THDPI.LE.0.)THDPI=THDPI+2.
        IF(BETAM(K).GT.-1.)WRITE(6,1010)K,W(K),THDPI,BETAM(K),Z(K)
        IF(BETAM(K).LE.-1.)WRITE(6,1020)K,THDPI,BETAM(K),Z(K)
      ENDDO
      WRITE(6,1030)WC,C
      RETURN
 1000 FORMAT(/' PARAMETERS DEFINING MAP:',15X,'(N =',I3,')',6X,
     & '(NPTSQ =',I3,')'//'  K',10X,'W(K)',10X,'TH(K)/PI',5X,'BETAM(K)'
     & ,13X,'Z(K)'/' ---',9X,'----',10X,'--------',5X,'--------',13X,
     & '----'/)
 1010 FORMAT(I3,'    (',F6.3,',',F6.3,')',F14.8,F12.5,3X,'(',F11.8,','
     & ,F11.8,')')
 1020 FORMAT(I3,'        INFINITY   ',F14.8,F12.5,3X,'(',F11.8,',',
     & F11.8,')')
 1030 FORMAT(/' WC=(',E15.8,',',E15.8,')'/'  C=(',E15.8,',',E15.8,')'
     & /)
      END
      SUBROUTINE SCTEST(ERREST,N,C,Z,WC,W,BETAM,NPTSQ,QWORK)
C TESTS THE COMPUTED MAP FOR ACCURACY.
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION Z(N),W(N),BETAM(N),QWORK(1)
C TEST LENGTH OF RADII:
      ERREST=0.
      DO K=2,N
        IF(BETAM(K).GT.-1.)RADE=ABS(WC-WSC((0.,0.),0,Z(K),W(K),K,N,C,
     &   Z,BETAM,NPTSQ,QWORK))
        IF(BETAM(K).LE.-1.)RADE=ABS(WSC((.1,.1),0,Z(K-1),W(K-1),K-1,
     &   N,C,Z,BETAM,NPTSQ,QWORK)-WSC((.1,.1),0,Z(K+1),W(K+1),K+1,N,C,
     &   Z,BETAM,NPTSQ,QWORK))
        ERREST=MAX(ERREST,RADE)
      ENDDO
      RETURN
      END
      FUNCTION ZQUAD(ZA,KA,ZB,KB,N,Z,BETAM,NPTSQ,QWORK)
C COMPUTES THE COMPLEX LINE INTEGRAL OF ZPROD FROM ZA TO ZB ALONG A
C STRAIGHT LINE SEGMENT WITHIN THE UNIT DISK.  FUNCTION ZQUAD1 IS
C CALLED TWICE, ONCE FOR EACH HALF OF THIS INTEGRAL.
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION Z(N),BETAM(N),QWORK(1)
      IF(ABS(ZA).GT.1.1.OR.ABS(ZB).GT.1.1)WRITE(6,1000)
 1000 FORMAT(/' *** WARNING IN ZQUAD: Z OUTSIDE THE DISK')
      ZMID=(ZA+ZB)/2.
      ZQUAD=ZQUAD1(ZA,ZMID,KA,N,Z,BETAM,NPTSQ,QWORK)-ZQUAD1(ZB,ZMID,KB,
     & N,Z,BETAM,NPTSQ,QWORK)
      RETURN
      END
      FUNCTION ZQUAD1(ZA,ZB,KA,N,Z,BETAM,NPTSQ,QWORK)
C COMPUTES THE COMPLEX LINE INTEGRAL OF ZPROD FROM ZA TO ZB ALONG A
C STRAIGHT LINE SEGMENT WITHIN THE UNIT DISK.  COMPOUND ONE-SIDED
C GAUSS-JACOBI QUADRATURE IS USED, USING FUNCTION DIST TO DETERMINE
C THE DISTANCE TO THE NEAREST SINGULARITY Z(K).
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION Z(N),BETAM(N),QWORK(1)
      DATA RESPRM/2./
C CHECK FOR ZERO-LENGTH INTEGRAND:
      IF(ABS(ZA-ZB).GT.0.)THEN
C STEP 1: ONE-SIDED GAUSS-JACOBI QUADRATURE FOR LEFT ENDPOINT:
        R=MIN(1.,DIST(ZA,KA,N,Z)*RESPRM/ABS(ZA-ZB))
        ZAA=ZA+R*(ZB-ZA)
        ZQUAD1=ZQSUM(ZA,ZAA,KA,N,Z,BETAM,NPTSQ,QWORK)
C STEP 2: ADJOIN INTERVALS OF PURE GAUSSIAN QUADRATURE IF NECESSARY:
        DO WHILE(R.NE.1.)
          R=MIN(1.,DIST(ZAA,0,N,Z)*RESPRM/ABS(ZAA-ZB))
          ZBB=ZAA+R*(ZB-ZAA)
          ZQUAD1=ZQUAD1+ZQSUM(ZAA,ZBB,0,N,Z,BETAM,NPTSQ,QWORK)
          ZAA=ZBB
        ENDDO
      ELSE
        ZQUAD1=(0.,0.)
      ENDIF
      RETURN
      END
      FUNCTION DIST(ZZ,KS,N,Z)
C DETERMINES THE DISTANCE FROM ZZ TO THE NEAREST SINGULARITY Z(K)
C OTHER THAN Z(KS).
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION Z(N)
      DIST=99.
      DO K=1,N
        IF(K.NE.KS)DIST=MIN(DIST,ABS(ZZ-Z(K)))
      ENDDO
      RETURN
      END
      FUNCTION ZQSUM(ZA,ZB,KA,N,Z,BETAM,NPTSQ,QWORK)
C COMPUTES THE INTEGRAL OF ZPROD FROM ZA TO ZB BY APPLYING A
C ONE-SIDED GAUSS-JACOBI FORMULA WITH POSSIBLE SINGULARITY AT ZA.
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION Z(N),BETAM(N),QWORK(1)
      ZS=(0.,0.)
      ZH=(ZB-ZA)/2.
      ZC=(ZA+ZB)/2.
      K=KA
      IF(K.EQ.0)K=N+1
      IWT1=NPTSQ*(K-1)+1
      IWT2=IWT1+NPTSQ-1
      IOFFST=NPTSQ*(N+1)
      DO I=IWT1,IWT2
        ZS=ZS+QWORK(IOFFST+I)*ZPROD(ZC+ZH*QWORK(I),KA,N,Z,BETAM)
      ENDDO
      ZQSUM=ZS*ZH
      IF(ABS(ZH).NE.0..AND.K.NE.N+1)ZQSUM=ZQSUM*ABS(ZH)**BETAM(K)
      RETURN
      END
      FUNCTION ZPROD(ZZ,KS,N,Z,BETAM)
C COMPUTES THE INTEGRAND
C N
C PROD  (1-ZZ/Z(K))**BETAM(K)  ,
C K=1
C TAKING ARGUMENT ONLY (NOT MODULUS) FOR TERM K=KS.
C *** NOTE -- IN PRACTICE THIS IS THE INNERMOST SUBROUTINE
C *** IN SCPACK CALCULATIONS.  THE COMPLEX LOG CALCULATION BELOW
C *** MAY ACCOUNT FOR AS MUCH AS HALF OF THE TOTAL EXECUTION TIME.
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION Z(N),BETAM(N)
      ZSUM=(0.,0.)
      DO K=1,N
        ZTMP=(1.,0.)-ZZ/Z(K)
        IF(K.EQ.KS)ZTMP=ZTMP/ABS(ZTMP)
        ZSUM=ZSUM+BETAM(K)*LOG(ZTMP)
      ENDDO
      ZPROD=EXP(ZSUM)
      RETURN
      END
      FUNCTION RPROD(ZZ,N,Z,BETAM)
C COMPUTES THE ABSOLUTE VALUE OF THE INTEGRAND
C N
C PROD  (1-ZZ/Z(K))**BETAM(K)
C K=1
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION Z(N),BETAM(N)
      SUM=0.
      DO K=1,N
        ZTMP=(1.,0.)-ZZ/Z(K)
        SUM=SUM+BETAM(K)*LOG(ABS(ZTMP))
      ENDDO
      RPROD=EXP(SUM)
      RETURN
      END
      SUBROUTINE NEARZ(ZZ,ZN,WN,KN,N,Z,WC,W,BETAM)
C RETURNS INFORMATION ASSOCIATED WITH THE NEAREST PREVERTEX Z(K)
C TO THE POINT ZZ, OR WITH 0 IF 0 IS CLOSER THAN ANY Z(K).
C ZN=PREVERTEX POSITION, WN=W(ZN), KN=PREVERTEX NO. (0 TO N)
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION Z(N),W(N),BETAM(N)
      DIST=ABS(ZZ)
      KN=0
      ZN=(0.,0.)
      WN=WC
      IF(DIST.GT..5)THEN
        DO K=1,N
          IF(BETAM(K).GT.-1.)THEN
            DISTZK=ABS(ZZ-Z(K))
            IF(DISTZK.LT.DIST)THEN
              DIST=DISTZK
              KN=K
            ENDIF
          ENDIF
        ENDDO
        IF(KN.NE.0)THEN
          ZN=Z(KN)
          WN=W(KN)
        ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE NEARW(WW,ZN,WN,KN,N,Z,WC,W,BETAM)
C RETURNS INFORMATION ASSOCIATED WITH THE NEAREST VERTEX W(K)
C TO THE POINT WW, OR WITH WC IF WC IS CLOSER THAN ANY W(K).
C ZN=PREVERTEX POSITION, WN=W(ZN), KN=VERTEX NO. (0 TO N)
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION Z(N),W(N),BETAM(N)
      DIST=ABS(WW-WC)
      KN=0
      ZN=(0.,0.)
      WN=WC
      DO K=1,N
        IF(BETAM(K).GT.-1.)THEN
          DISTWK=ABS(WW-W(K))
          IF(DISTWK.LT.DIST)THEN
            DIST=DISTWK
            KN=K
          ENDIF
        ENDIF
      ENDDO
      IF(KN.NE.0)THEN
        ZN=Z(KN)
        WN=W(KN)
      ENDIF
      RETURN
      END
      SUBROUTINE ANGLES(N,W,BETAM)
C COMPUTES EXTERNAL ANGLES -PI*BETAM(K) FROM KNOWLEDGE OF
C THE VERTICES W(K).  AN ANGLE BETAM(K) IS COMPUTED FOR EACH
C K FOR WHICH W(K-1), W(K), AND W(K+1) ARE FINITE.
C TO GET THIS INFORMATION ACROSS ANY VERTICES AT INFINITY
C SHOULD BE SIGNALED BY THE VALUE W(K)=(99.,99.) ON INPUT.
      IMPLICIT COMPLEX(C,W,Z)
      DIMENSION W(N),BETAM(N)
      C9=(99.,99.)
      PI=ACOS(-1.)
      DO K=1,N
        KM=MOD(K+N-2,N)+1
        KP=MOD(K,N)+1
        IF(.NOT.(W(KM).EQ.C9.OR.W(K).EQ.C9.OR.W(KP).EQ.C9))THEN
          BETAM(K)=AIMAG(LOG((W(KM)-W(K))/(W(KP)-W(K))))/PI-1.
          IF(BETAM(K).LE.-1.)BETAM(K)=BETAM(K)+2.
        ENDIF
      ENDDO
      RETURN
      END
