#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <stdlib.h>
#include <float.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include "../include/complex.hpp"

double fmin(double x,double y)
  {
  if(x<y)
    return(x);
  return(y);
  }

double fmax(double x,double y)
  {
  if(x>y)
    return(x);
  return(y);
  }

complex c0sh(complex z)
  {
  return(cosh(z));
  }

double Sm,Sx;

void CreateTB2(complex f(complex),char*rname,char*iname)
  {
  int i,j,m=64,n=64;
  complex w,z;
  FILE*fr,*fi;
  printf("creating: %s\n",rname);
  fr=fopen(rname,"wt");
  printf("creating: %s\n",iname);
  fi=fopen(iname,"wt");
  fprintf(fr,"%i\n",n);
  fprintf(fi,"%i\n",n);
  for(i=0;i<n;i++)
    {
    z.re=-2.+i*4./(n-1);
    fprintf(fr,"%lG\n",z.re);
    fprintf(fi,"%lG\n",z.re);
    }
  fprintf(fr,"%i\n",m);
  fprintf(fi,"%i\n",m);
  for(j=0;j<m;j++)
    {
    z.im=-2.+j*4./(m-1);
    fprintf(fr,"%lG\n",z.im);
    fprintf(fi,"%lG\n",z.im);
    }
  Sm=DBL_MAX;
  Sx=-DBL_MAX;
  fprintf(fr,"%i\n",n*m);
  fprintf(fi,"%i\n",n*m);
  for(j=0;j<m;j++)
    {
    z.im=-2.+j*4./(m-1);
    for(i=0;i<n;i++)
      {
      z.re=-2.+i*4./(n-1);
      w=f(z);
      Sm=fmin(Sm,fmin(w.re,w.im));
      Sx=fmax(Sx,fmin(w.re,w.im));
      fprintf(fr,"%lG\n",w.re);
      fprintf(fi,"%lG\n",w.im);
      }
    }
  fclose(fr);
  fclose(fi);
  }

void CreateTP2(char*title,char*name,char*rname,char*iname)
  {
  FILE*fp;
  printf("creating file: %s\n",name);
  fp=fopen(name,"wt");
  fprintf(fp,"TP2\n");
  fprintf(fp,"!ALTER\n");
  fprintf(fp,"!PLOT\n");
  fprintf(fp,"EQUAL\n");
  fprintf(fp,"TICKS\n");
  fprintf(fp,"LEGENDS\n");
  fprintf(fp,"-1 5 2\n");
  fprintf(fp,"RAINBOW\n");
  fprintf(fp,"CONTOUR\n");
  fprintf(fp,"%lG 0 %lG\n",Sm,Sx);
  fprintf(fp,"NOLEGEND 126\n");
  fprintf(fp,"ZTABLE\n");
  fprintf(fp,"CENTER\n");
  fprintf(fp,"ABOVE\n");
  fprintf(fp,"%s\n",title);
  fprintf(fp,"X\n");
  fprintf(fp,"-2 2\n");
  fprintf(fp,"Y\n");
  fprintf(fp,"-2 2\n");
  fprintf(fp,"%s\n",rname);
  fprintf(fp,"NEWFILE 2\n");
  fprintf(fp,"%s\n",iname);
  fprintf(fp,"!END\n");
  fclose(fp);
  }

int main(int argc,char**argv,char**envp)
  {
  CreateTB2(c0sh,"coshr.tb2","coshi.tb2");
  CreateTP2("cosh(z)","cosh.tp2","coshr.tb2","coshi.tb2");
  return(0);
  }
