      PROGRAM MAIN
      CHARACTER*256 FILENM
      IF(NARGS().LT.2)STOP'NO INPUT FILE'
      IF(NARGS().GT.2)STOP'TOO MANY PARAMETERS'
      CALL GETARG(1,FILENM,LEN)
      IF(LEN.LT.5)STOP'NULL FILE NAME'
      CALL POLYGON(FILENM)
      CALL ZIPPER
      CALL ORIGPRE
      CALL CGRIDS
      CALL CORDERS(1)
      CALL FORWARD
      CALL CORDERS(2)
      CALL CLEANUP(FILENM)
      STOP'OUTPUT IN ZIPPER.P2D'
      END
      SUBROUTINE CLEANUP(NAME)
      CHARACTER*(*)NAME
      OPEN(1,FILE=NAME,STATUS='OLD')
      OPEN(2,FILE='zipper.p2d',STATUS='UNKNOWN')
      WRITE(2,'(A)')'POLY RGB=0xFF0000'
      READ(1,*)X0,Y0
      X2=X0
      Y2=Y0
      DO
        X1=X2
        Y1=Y2
        READ(1,*,ERR=100)X2,Y2
        WRITE(2,*)X1,Y1
      ENDDO
  100 WRITE(2,*)X0,Y0
      WRITE(2,'(A)')'END'
      WRITE(2,'(A)')'POINT RGB=0x00FF00'
      WRITE(2,*)X1,Y1
      WRITE(2,'(A)')'END'
      CLOSE(1,STATUS='KEEP')
      OPEN(1,FILE='POLY.GRIDI',STATUS='OLD')
      WRITE(2,'(A)')'POLY RGB=0x0000FF'
      DO
        READ(1,*,ERR=110)X,Y
        WRITE(2,*)X,Y
      ENDDO
  110 WRITE(2,'(A)')'END'
      CLOSE(2,STATUS='KEEP')
      CLOSE(1,STATUS='KEEP')
      CALL REMOVE('CGRID.DAT')
      CALL REMOVE('CGRID.IMG')
      CALL REMOVE('INDEX.DAT')
      CALL REMOVE('ORIG.PRE')
      CALL REMOVE('POLY.DAT')
      CALL REMOVE('POLY.GRID')
      CALL REMOVE('POLY.GRIDI')
      CALL REMOVE('POLY.IMG')
      CALL REMOVE('POLY.INT')
      CALL REMOVE('POLY.PAR')
      CALL REMOVE('POLY.PRE')
      RETURN
      END
      SUBROUTINE REMOVE(NAME)
      CHARACTER*(*)NAME
      OPEN(1,FILE=NAME,ERR=999)
      CLOSE(1,STATUS='DELETE')
  999 RETURN
      END
C
C     Copyright (C) 1996  University of Washington, U.S.A.
C
C     Author: Donald E. Marshall
C
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 1, or (at your option)
C    any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C
C THIS COMPUTES THE CARLESON GRID WITH REFINED SQUARES IN THE TOP HALF
C OF EACH BOX. POINTS ARE NOT IN CORRECT ORDER FOR PLOTTING.
      SUBROUTINE CGRIDS
      IMPLICIT DOUBLE PRECISION(A-H,O-Y),COMPLEX*16(Z)
      DIMENSION X(100000),Y(100000)
      CHARACTER*55 FILENM
      WRITE(*,*)'NUMBER OF GENERATIONS?'
      NGEN=6
      WRITE(*,*)'NUMBER OF SUBLEVELS?'
      NSL=1
      NNSL=NSL
      WRITE(*,*)'NAME OF FILE FOR DATA?'
      FILENM='CGRID.DAT'
      WRITE(*,*)'>>>CREATING ',FILENM
      OPEN(2,FILE=FILENM,STATUS='UNKNOWN')
      PI=3.1415926535898D0
      RAD=1D0-PI/4D0
      I=0
      NGEN1=NGEN-1
      DO J=1,NGEN1
        RAD=(1D0+RAD)/2D0
        LEND=16*(2**J)*NSL
        KEND=NSL
        IF(NNSL.EQ.0)THEN
          NSL=1
          LEND=8*(2**J)
          KEND=1
        ENDIF
        DRAD=(1D0-RAD)/(2D0*NSL)
        DTHETA=2D0*PI/LEND
        RAD1=RAD-DRAD
        IF((J.EQ.NGEN1).AND.(NNSL.NE.0))KEND=2*NSL
        DO K=1,KEND
          RAD1=RAD1+DRAD
          DO L=1,LEND
            I=I+1
            X(I)=RAD1*DCOS(DTHETA*L)
            Y(I)=RAD1*DSIN(DTHETA*L)
          ENDDO
        ENDDO
      ENDDO
      RAD1=.999999999D0
      DO L=1,LEND
        I=I+1
        X(I)=RAD1*DCOS(DTHETA*L)
        Y(I)=RAD1*DSIN(DTHETA*L)
      ENDDO
      NNN=I
      WRITE(*,*)'NUMBER OF POINTS =',NNN
      WRITE(2,'(2F25.15)')(X(I),Y(I),I=1,NNN)
      CLOSE(2,STATUS='KEEP')
      RETURN
      END
C THIS SUBROUTINE ORDERS POINTS FROM CGRIDS.F FOR PLOTTING (CAN BE APPLIED
C TO IMAGES VIA A CONFORMAL MAP.)
      SUBROUTINE CORDERS(IOPT)
      IMPLICIT DOUBLE PRECISION(A-H,O-Y),COMPLEX*16(Z)
      DIMENSION X(200000),Y(200000),X1(200000),Y1(200000)
      CHARACTER*55 FILENM
      WRITE(*,*)'NUMBER OF GENERATIONS?'
      IF(IOPT.EQ.1)THEN
        NGEN=6
      ELSE
        NGEN=6
      ENDIF
      WRITE(*,*)'NUMBER OF SUBLEVELS?'
      IF(IOPT.EQ.1)THEN
        NSL=1
      ELSE
        NSL=1
      ENDIF
      WRITE(*,*)'NAME OF FILE WITH DATA?'
      IF(IOPT.EQ.1)THEN
        FILENM='CGRID.DAT'
      ELSE
        FILENM='CGRID.IMG'
      ENDIF
      WRITE(*,*)'<<<READING ',FILENM
      OPEN(2,FILE=FILENM,STATUS='OLD')
      WRITE(*,*)'NAME OF FILE FOR ORDERED DATA?'
      IF(IOPT.EQ.1)THEN
        FILENM='POLY.GRID'
      ELSE
        FILENM='POLY.GRIDI'
      ENDIF
      DO I=1,200000
        READ(2,*,ERR=100)X(I),Y(I)
      ENDDO
  100 NNN=I-1
      WRITE(*,*)'NO. DATA POINTS',NNN
      I=0
      NGEN1=NGEN-1
      LEND=32*NSL
      KEND=NSL
      NNSL=NSL
      IF(NNSL.EQ.0)THEN
        KEND=1
        LEND=16
        NSL=1
      ENDIF
      LP=0
      DO J=1,NGEN1
        IF((J.EQ.NGEN1).AND.(NNSL.NE.0))KEND=2*NSL
        DO K=1,KEND
          LNXT=LEND
          I=I+1
          X1(I)=X(LP+LEND)
          Y1(I)=Y(LP+LEND)
          DO L=1,LEND
            I=I+1
            LP=LP+1
            X1(I)=X(LP)
            Y1(I)=Y(LP)
            I=I+1
            IF((K.EQ.KEND).AND.(J.LT.NGEN1))LNXT=LNXT+1
            IF(NSL.EQ.0)LNXT=LEND
            X1(I)=X(LP+LNXT)
            Y1(I)=Y(LP+LNXT)
            I=I+1
            X1(I)=X(LP)
            Y1(I)=Y(LP)
          ENDDO
        ENDDO
        LEND=LEND*2
      ENDDO
      NNN=I
      WRITE(*,*)'NO. PTS. =',NNN
      WRITE(*,*)'>>>CREATING ',FILENM
      OPEN(3,FILE=FILENM,STATUS='UNKNOWN')
      WRITE(3,'(2F25.15)')(X1(I),Y1(I),I=1,NNN)
      CLOSE(2,STATUS='KEEP')
      CLOSE(3,STATUS='KEEP')
      RETURN
      END
C SLIT MAP SUBROUTINE WITH ANGLES AND BENDS.
C THE SUBROUTINE WILL COMPUTE VALUES OF THE CONFORMAL MAP (AT PREVERTICES
C AND AT INTERMEDIATE POINTS OR AT INTERIOR POINTS) WHICH MAPS THE DISK
C TO A JORDAN REGION WITH THE PRESCRIBED POINTS ON ITS BOUNDARY.
      SUBROUTINE FORWARD
      IMPLICIT DOUBLE PRECISION(A-H,O-Y),INTEGER*4(I-N),COMPLEX*16(Z)
      CHARACTER*55 FILENM
      COMMON Z(120001),A(120001),B(120001),C(120001),Z1,Z2,Z3,ZROT1,
     & ZTO0,ZTO1,ANGLER,ZROT2,M,N
C FILE WITH MAPPING PARAMETERS IS CALLED POLY.PAR
      WRITE(*,*)'<<<READING POLY.PAR'
      OPEN(4,FILE='POLY.PAR',STATUS='OLD')
      READ(4,*)Z1,Z2,Z3,ZROT1,ZTO0,ZTO1,ANGLER,ZROT2
      DO J=1,120000
        JJ=J*2+2
        READ(4,'(3F25.15)',ERR=100)A(JJ),B(JJ),C(JJ)
      ENDDO
  100 N=JJ
      WRITE(*,*)'NUMBER OF VERTICES =',N
      WRITE(*,*)'TYPE 1 FOR PREVERTICES AND INTERMEDIATE POINTS'
C FILE WITH PREIMAGES OF VERTICES IS CALLED POLY.PRE
      WRITE(*,*)'<<<READING POLY.PRE'
      OPEN(1,FILE='POLY.PRE',STATUS='OLD')
      ZM=DCMPLX(0D0,0D0)
      DO J=1,120000
        READ(1,'(2F25.15)',ERR=110)X,Y
        Z(J)=DCMPLX(X,Y)
        IF(Z(J).EQ.ZM)THEN
          JM=J-1
          WRITE(*,*)'WARNING: PREVERTICES',J,' AND',JM,' ARE EQUAL'
          WRITE(*,*)'ELIMINATE TWO VERTICES AND REDO ZIPPER SUBROUTINE'
        ENDIF
        ZM=Z(J)
      ENDDO
  110 N=J-1
      WRITE(*,*)'NUMBER OF DATA POINTS=',N
      WRITE(*,*)'ENTER M. THE MAP WILL BE EVALUATED AT N*M POINTS'
      M=4
      CALL INTMED
      MN=N*M
      WRITE(*,*)'>>>CREATING POLY.INT'
      OPEN(8,FILE='POLY.INT',STATUS='UNKNOWN')
      DO J=1,MN
        X=DREAL(Z(J))
        Y=DIMAG(Z(J))
        WRITE(8,'(2F25.15)')X,Y
      ENDDO
      WRITE(*,*)'POLY.INT HAS PREVERT. AND INTERM. PTS.'
      CALL BNDRY
C FILE WITH IMAGE OF UNIT CIRCLE IS POLY.IMG
      WRITE(*,*)'>>>CREATING POLY.IMG'
      OPEN(7,FILE='POLY.IMG',STATUS='UNKNOWN')
      DO J=1,MN
        X=DREAL(Z(J))
        Y=DIMAG(Z(J))
        WRITE(7,'(2F25.15)')X,Y
      ENDDO
      X=DREAL(Z(1))
      Y=DIMAG(Z(1))
      WRITE(7,'(2F25.15)')X,Y
      WRITE(*,*)'FILE WITH IMAGE OF CIRCLE IS POLY.IMG'
      WRITE(*,*)'NAME OF FILE WITH POINTS IN THE OPEN DISK?  '
      FILENM='CGRID.DAT'
      WRITE(*,*)'<<<READING ',FILENM
      OPEN(2,FILE=FILENM,STATUS='OLD')
      WRITE(*,*)'NAME OF FILE FOR IMAGE OF THESE POINTS?  '
      FILENM='CGRID.IMG'
      WRITE(*,*)'>>>CREATING ',FILENM
      OPEN(3,FILE=FILENM,STATUS='UNKNOWN')
      DO J=1,120000
        READ(2,*,ERR=120)X,Y
        Z(J)=DCMPLX(X,Y)
      ENDDO
      STOP'TOO MANY POINTS'
  120 MM=J-1
      WRITE(*,*)'NUMBER OF DATA POINTS=',MM
      CALL EVAL(MM)
      DO J=1,MM
        X=DREAL(Z(J))
        Y=DIMAG(Z(J))
        WRITE(3,'(2F25.15)')X,Y
      ENDDO
      CLOSE(1,STATUS='KEEP')
      CLOSE(2,STATUS='KEEP')
      CLOSE(3,STATUS='KEEP')
      CLOSE(4,STATUS='KEEP')
      CLOSE(7,STATUS='KEEP')
      CLOSE(8,STATUS='KEEP')
      RETURN
      END
C POLYGON.F ADDS ADDITIONAL DATA POINTS BETWEEN THE VERTICES. THIS
C SUBROUTINE IS TO BE RUN *AFTER* ZIPPER. IT OUTPUTS ONLY THOSE
C PREVERTICES CORRESPONDING TO THE ORIGINAL DATA POINTS, ELIMINATING
C THOSE CORRESPONDING TO POINTS GENERATED BY POLYGON.F.
C
C INPUT:  INDEX.DAT  FILE WITH INDICES OF ORIGINAL DATA POINTS
C (INPUT TO POLYGON.F)
C POLY.PRE   PREIMAGE OF POLY.DAT
C OUTPUT: ORIG.PRE   PREIMAGE OF ORIGINAL DATA POITNS
C
      SUBROUTINE ORIGPRE
      IMPLICIT DOUBLE PRECISION(A-H,O-Y),INTEGER*4(I-N),COMPLEX*16(Z)
C AS WRITTEN, THIS SUBROUTINE IS LIMITED TO 10000 (ORIGINAL) VERTICES
      DIMENSION X(100002),Y(100002),JINDEX(10002)
      CHARACTER*55 FILENM
      WRITE(*,*)'<<<READING POLY.PRE'
      OPEN(1,FILE='POLY.PRE',STATUS='OLD')
      DO J=1,100001
        READ(1,*,ERR=100)X(J),Y(J)
      ENDDO
      STOP'TOO MANY PREVERTICES'
  100 WRITE(*,*)'<<<READING INDEX.DAT'
      OPEN(2,FILE='INDEX.DAT',STATUS='OLD')
      DO K=1,10001
        READ(2,*,ERR=110)JINDEX(K)
      ENDDO
      STOP'TOO MANY PREVERTICES'
  110 N=K-1
      WRITE(*,*)'>>>CREATING ORIG.PRE'
      OPEN(3,FILE='ORIG.PRE',STATUS='UNKNOWN')
      DO M=1,N
        WRITE(3,'(2G25.15)')X(JINDEX(M)),Y(JINDEX(M))
      ENDDO
      CLOSE(1,STATUS='KEEP')
      CLOSE(2,STATUS='KEEP')
      CLOSE(3,STATUS='KEEP')
      RETURN
      END
C THIS SUBROUTINE MAKES SURE THAT THE DATA IS IN THE CORRECT FORM
C FOR ZIPPER.
C THE CURVE NEEDS TO BE A JORDAN CURVE.
C IF YOU HAVE A SMOOTH CURVE,
C OR A CURVE WHICH IS PIECEWISE SMOOTH (RELATIVELY FEW BENDS),
C IT MIGHT BE WISE TO CREATE YOUR OWN DATA FILE SATISFYING THE
C REQUIREMENTS OF ZIPPER AND AVOID USING THIS SUBROUTINE, RESULTING IN
C FAR FEWER DATA POINTS AND HENCE GREATER SPEED WITH ZIPPER.
C
      SUBROUTINE POLYGON(FILENM)
      IMPLICIT DOUBLE PRECISION(A-H,O-Y),INTEGER*4(I-N),COMPLEX*16(Z)
C AS WRITTEN, THIS SUBROUTINE IS LIMITED TO 90000 VERTICES
      DIMENSION Z(90002),ZN(90002),XL(90002),ZZ(90002),JINDEX(90002)
      CHARACTER*(*)FILENM
      WRITE(*,*)'NAME OF FILE WITH VERTICES THEN INTERIOR POINT?  '
      WRITE(*,*)'>>>READING ',FILENM
      OPEN(1,FILE=FILENM,STATUS='OLD')
      DO J=1,90001
        READ(1,*,ERR=100)X,Y
        Z(J)=DCMPLX(X,Y)
      ENDDO
      STOP'TOO MANY VERTICES.'
  100 N=J-2
C REMOVE LAST POINT IF THE CURVE IS CLOSED
      ZINT=Z(N+1)
      IF(CDABS(Z(1)-Z(N)).LT.1D-14)N=N-1
      NORG=N
      NP=N+1
      WRITE(*,*)'THE SUBROUTINE WILL PUT AT LEAST 5 POINTS PER EDGE'
      WRITE(*,*)'(COUNTING ENDPOINTS) WITH VERTICES AT ODD POINTS.'
      WRITE(*,*)'APPROX. LOWER BOUND ON NUMBER OF BOUNDARY POINTS?'
      MAPPROX=200
      Z(NP)=Z(1)
      ZM=(Z(2)+Z(1))/2D0
      DISTM=CDABS(ZM-ZINT)
      JCLOSE=1
      DO J=2,N
        ZC=(Z(J+1)+Z(J))/2D0
        DD=CDABS(ZC-ZINT)
        IF(DD.LT.DISTM)THEN
          DISTM=DD
          JCLOSE=J
          ZM=ZC
        ENDIF
      ENDDO
      ZN(1)=ZM
      DO J=2,N-JCLOSE+1
        ZN(J)=Z(JCLOSE+J-1)
      ENDDO
      DO J=N-JCLOSE+2,N+1
        ZN(J)=Z(J-N+JCLOSE-1)
      ENDDO
      NPP=N+2
      ZN(NPP)=ZM
      PERIM=0D0
      DO J=1,NP
        XL(J)=CDABS(ZN(J+1)-ZN(J))
        PERIM=PERIM+XL(J)
      ENDDO
      WRITE(*,*)'NAME OF FILE FOR POINTS?'
      FILENM='POLY.DAT'
      CLOSE(1,STATUS='KEEP')
      WRITE(*,*)'>>>CREATING ',FILENM
      OPEN(2,FILE=FILENM,STATUS='UNKNOWN')
C FIX FOR G77 IN VISTA
      CLOSE(2,STATUS='DELETE')
      OPEN(2,FILE=FILENM,STATUS='NEW')
      NJS=0
      DO J=1,NP
        NJ=MAPPROX*XL(J)/PERIM
        IF(NJ.LT.4)NJ=4
        ITEST=NJ/2
        ITEST=2*ITEST
        IF(ITEST.LT.NJ)NJ=NJ+1
        ZD=(ZN(J+1)-ZN(J))/FLOAT(NJ)
        IF(CDABS(ZD).GE.1D-16)THEN
          NJS=NJS+1
          IF(J.LE.N-JCLOSE+1)THEN
            M=JCLOSE-1+J
          ELSE
            M=JCLOSE-1-N+J
          ENDIF
          JINDEX(M)=NJS
          ZZ(NJS)=ZN(J)
          DO K=1,NJ-1
            NJS=NJS+1
            ZZ(NJS)=ZZ(NJS-1)+ZD
          ENDDO
        ENDIF
      ENDDO
      WRITE(*,*)'NUMBER OF BOUNDARY POINTS =',NJS
      N=NJS
      NP=N+1
C HERE WE TEST THAT THE INTERIOR POINT CORRESPONDS TO THE REGION
C COMPLEMENTARY TO THE CURVE (CORRECT BOUNDARY ORIENTATION).
      ZZ(NP)=ZZ(1)
      NCROSS=0
      ZROT1=(ZZ(1)-ZZ(2))/(ZZ(2)-ZZ(3))
      ZT=(ZINT-ZZ(3))/(ZINT-ZZ(1))*ZROT1
      ATEST=DIMAG(ZT)
      IF(ATEST.GE.0D0)THEN
C A POINT IN THE REGION BOUNDED BY THE CURVE:
        Z0=DCMPLX(-1D0,1D-3)
      ELSE
C A POINT NOT IN THE REGION BOUNDED BY THE CURVE:
        Z0=DCMPLX(-1D0,-1D-3)
      ENDIF
C COUNT SIGNED CROSSINGS OF [Z0,F(ZINT)] WHERE F IS AN LFT.
      ZT=ZT-Z0
      ROTA=DIMAG(CDLOG(ZT))
      ZROT2=CDEXP(DCMPLX(0D0,-ROTA))
      ZOLD=-Z0*ZROT2
      XF=DREAL(ZT*ZROT2)
      DO J=4,NJS
        ZNEW=(((ZZ(J)-ZZ(3))/(ZZ(J)-ZZ(1)))*ZROT1-Z0)*ZROT2
        AIMG=DIMAG(ZOLD)
        BIMG=DIMAG(ZNEW)
        IF(AIMG*BIMG.LE.0D0)THEN
          T=AIMG/(AIMG-BIMG)
          X=(1D0-T)*DREAL(ZOLD)+T*DREAL(ZNEW)
          IF((X.GT.0D0).AND.(X.LT.XF))THEN
            IF(AIMG.LT.0D0)THEN
              NCROSS=NCROSS+1
            ELSE
              NCROSS=NCROSS-1
            ENDIF
          ENDIF
        ENDIF
        ZOLD=ZNEW
      ENDDO
      IF(.NOT.((ATEST.GE.0D0).AND.(NCROSS.EQ.0)))THEN
        IF(.NOT.((ATEST.LT.0D0).AND.(NCROSS.EQ.-1)))THEN
          WRITE(*,*)'ATEST=',ATEST,' NCROSS=',NCROSS
          WRITE(*,*)'CURVE IS TRACED IN WRONG DIRECTION.'
          WRITE(*,*)'SUBROUTINE WILL REVERSE THE ORDER.'
          NT=N/2
          DO J=1,NT
            ZTEMP=ZZ(J)
            ZZ(J)=ZZ(N-J)
            ZZ(N-J)=ZTEMP
          ENDDO
          DO JJ=1,NORG
            JINDEX(JJ)=N-JINDEX(JJ)
          ENDDO
        ENDIF
      ENDIF
      ZZ(NP)=ZINT
      DO J=1,NJS
        X=DREAL(ZZ(J))
        Y=DIMAG(ZZ(J))
        WRITE(2,'(2G25.15)')X,Y
      ENDDO
      WRITE(2,*)
      X=DREAL(ZINT)
      Y=DIMAG(ZINT)
      WRITE(2,'(2G25.15)')X,Y
      CLOSE(2,STATUS='KEEP')
      WRITE(*,*)'INDEX.DAT=FILE WITH INDEX FOR ORIGINAL DATA PTS.'
      WRITE(*,*)'>>>CREATING INDEX.DAT'
      OPEN(3,FILE='INDEX.DAT',STATUS='UNKNOWN')
C FIX FOR G77 IN VISTA
      CLOSE(3,STATUS='DELETE')
      OPEN(3,FILE='INDEX.DAT',STATUS='NEW')
      DO J=1,NORG
        WRITE(3,'(I5)')JINDEX(J)
      ENDDO
      CLOSE(3,STATUS='KEEP')
      RETURN
      END
C SLIT MAP SUBROUTINE WITH ANGLES AND BENDS.
C THE SUBROUTINE WILL COMPUTE PARAMETERS AND PREVERTICES OF THE CONFORMAL M
C AND ITS INVERSE, WHICH MAPS A JORDAN REGION WITH THE PRESCRIBED POINTS
C ITS BOUNDARY TO THE UNIT DISK.
C
C INPUT:  POLY.DAT  DATA FILE WHICH CONTAINS:
C THE BOUNDARY POINTS IN COUNTERCLOCKWISE ORDER,
C THEN THE POINT IN YOUR REGION TO BE MAPPED TO 0.
C (THE FIRST POINT WILL BE MAPPED TO 1 ON THE
C CIRCLE- FOR BEST ACCURACY, THERE SHOULD BE A
C TANGENT TO THE CURVE AT THE FIRST 3 POINTS),
C THERE SHOULD BE AN EVEN NUMBER OF BOUNDARY POINTS,
C WITH BENDS OCCURRING AT ODD NUMBERED POINTS.
C FORMAT: EACH LINE CONSISTS OF TWO FLOATING
C POINT NUMBERS, THE X AND Y COORDINATES OF A POINT.
C
C IT IS POSSIBLE TO HAVE INFINITY AS AN INTERIOR
C POINT OF THE REGION, BUT THE ORIENTATION OF
C THE BOUNDARY MUST BE POSITIVE: IN THIS CASE
C THE BOUNDARY POINTS WILL BE IN CLOCKWISE ORDER.
C THIS SUBROUTINE DOES NOT TEST FOR CORRECT
C INPUT. TESTING IS DONE IN POLYGON.F - USE
C POLYGON IF YOU ARE TRYING THESE SUBROUTINES FOR
C THE FIRST TIME AND EXPERIENCING
C DIFFICULTIES.
C
C OUTPUT:POLY.PRE   PREVERTICES (INVERSE IMAGES OF VERTICES)
C POLY.PAR   PARAMETERS (DATA USED TO EVALUATE THE MAP)
      SUBROUTINE ZIPPER
      IMPLICIT DOUBLE PRECISION(A-H,O-Y),INTEGER*4(I-N),COMPLEX*16(Z)
      COMMON Z(120001),A(120001),B(120001),C(120001),Z1,Z2,Z3,ZROT1,
     & ZTO0,ZTO1,ANGLER,ZROT2,N
C FILE CONTAINING DATA IS CALLED POLY.DAT
      WRITE(*,*)'<<<READING POLY.DAT'
      OPEN(1,FILE='POLY.DAT',STATUS='OLD')
C FILE CONTAINING MAPPING PARAMETERS IS CALLED POLY.PAR
      WRITE(*,*)'>>>CREATING POLY.PAR'
      OPEN(4,FILE='POLY.PAR',STATUS='UNKNOWN')
C FILE CONTAINING PREIMAGES OF DATA ON THE UNIT CIRCLE IS POLY.PRE
      WRITE(*,*)'<<<CREATING POLY.PRE'
      OPEN(3,FILE='POLY.PRE',STATUS='UNKNOWN')
      DO J=1,120000
        READ(1,*,ERR=100)X,Y
        Z(J)=DCMPLX(X,Y)
      ENDDO
      STOP'TOO MANY POINTS'
  100 N=J-2
      CALL INVERS
      WRITE(4,*)Z1,Z2,Z3,ZROT1,ZTO0,ZTO1,ANGLER,ZROT2
      DO J=4,N-2,2
        WRITE(4,'(3F25.15)')A(J),B(J),C(J)
      ENDDO
      ZM=DCMPLX(0D0,0D0)
      DO J=1,N
        IF(CDABS(ZM-Z(J)).LT.1D-16)THEN
          JM=J-1
          WRITE(*,*)'WARNING: PREVERTICES',J,' AND',JM,' ARE EQUAL'
          STOP'BOUNDARY POINTS TOO CLOSE'
        ENDIF
        ZM=Z(J)
        X=DREAL(Z(J))
        Y=DIMAG(Z(J))
        WRITE(3,'(2F25.15)')X,Y
      ENDDO
      CLOSE(1,STATUS='KEEP')
      CLOSE(3,STATUS='KEEP')
      CLOSE(4,STATUS='KEEP')
      RETURN
      END
      SUBROUTINE INTMED
      IMPLICIT DOUBLE PRECISION(A-H,O-Y),INTEGER*4(I-N),COMPLEX*16(Z)
      COMMON Z(120001),A(120001),B(120001),C(120001),Z1,Z2,Z3,ZROT1,
     & ZTO0,ZTO1,ANGLER,ZROT2,M,N
      DIMENSION ZT(120001)
      PI=3.14159265358979324D0
      TPI=2D0*PI
      IF(M.GT.1)THEN
        IF(M*N.GT.120000)THEN
          STOP'M IS TOO BIG'
        ELSE
          DO J=1,N
            ZT(J)=Z(J)
          ENDDO
          NP=N+1
          ZT(NP)=Z(1)
          J=0
          XP=1D0/DFLOAT(M)
          DO KK=1,N
            THET=DIMAG(CDLOG(ZT(KK+1)/ZT(KK)))
            IF(THET.LT.0D0)THET=THET+TPI
            DT=THET/DFLOAT(M)
            ZD=CDEXP(DCMPLX(0D0,DT))
            J=J+1
            Z(J)=ZT(KK)
            DO K=1,M-1
              J=J+1
              Z(J)=Z(J-1)*ZD
            ENDDO
          ENDDO
        ENDIF
      ENDIF
      RETURN
      END
C COMPUTES MAP FROM CIRCLE TO BOUNDARY OF REGION AT VERTICES AND
C INTERMEDIATE POINTS.
      SUBROUTINE BNDRY
      IMPLICIT DOUBLE PRECISION(A-H,O-Y),INTEGER*4(I-N),COMPLEX*16(Z)
      COMMON Z(120001),A(120001),B(120001),C(120001),Z1,Z2,Z3,ZROT1,
     & ZTO0,ZTO1,ANGLER,ZROT2,M,N
      PI=3.14159265358979324D0
      ZI=DCMPLX(0D0,1D0)
      ZTO0C=DCONJG(ZTO0)
      ANGLE=1D0/ANGLER
      Z1ROT=ZI**ANGLE
      MN=M*N
      DO J=2,MN
        ZT=ZI*(ZTO0-Z(J)*ZTO0C)/(Z(J)-1D0)
        IF(CDABS(ZT).GT.1D-14)THEN
          ZT=Z1ROT*(ZT**ANGLE)
        ELSE
          ZT=DCMPLX(0D0,0D0)
        ENDIF
        Z(J)=ZT/(ZROT2+ZT/ZTO1)
      ENDDO
      Z(1)=ZTO1
C---PUSH UP CURVE-----------------------------------------------------
      DO K=N-2,4,-2
        AA=A(K)
        BB=1D0/B(K)
        CC=C(K)*BB
C----USE REAL ARITHMETIC ON POINTS THAT REMAIN ON REAL LINE----------
        MEND1=M*(K-2)
        MEND2=MEND1+M+M
        PIA=PI*AA
        DO J=1,MEND1
          XMA=DREAL(Z(J))-AA
          XMAP=XMA+1D0
          XRATIO=XMA/XMAP
          IF(XRATIO.LT.1D-20)XRATIO=DABS(XRATIO)
          XFRACT=(XRATIO)**AA
          X=XMAP*XFRACT
          Z(J)=X/(BB-CC*X)
        ENDDO
        Z(MEND1+1)=DCMPLX(0D0,0D0)
C----FORCE CORRECT BRANCH FOR POINTS TO BE MAPPED TO SLIT--------------
        ZDIREC=DCMPLX(DCOS(PIA),DSIN(PIA))
        DO J=MEND1+2,MEND2+1
          XZJ=DREAL(Z(J))
          IF((XZJ.GT.-1D-20).AND.(J.LE.MEND2))XZJ=-1D-20
          XMA=XZJ-AA
          XMAP=XMA+1D0
          IF(XMAP.LT.1D-20)XMAP=1D-20
          XFRACT=(-XMA/XMAP)**AA
          ZX=XMAP*XFRACT*ZDIREC
          Z(J)=ZX/(BB-CC*ZX)
        ENDDO
C----COMPLEX ARITHMETIC FOR POINTS IN THE UPPER HALF PLANE-------------
        DO J=MEND2+2,MN
          ZMA=Z(J)-AA
          ZMAP=ZMA+1D0
          ZFRACT=(ZMA/ZMAP)**AA
          ZT=ZMAP*ZFRACT
          Z(J)=ZT/(BB-CC*ZT)
        ENDDO
      ENDDO
C-----MAP UPPER HALF PLANE TO COMPLEMENT OF CIRCULAR ARC---------------
      DO J=1,MN
        ZT=-Z(J)*Z(J)/ZROT1
        Z(J)=(Z3-Z1*ZT)/(1D0-ZT)
      ENDDO
C----ESTIMATE RELATIVE ERROR-------------------------------------------
      IF(M.GE.4)THEN
        XMAX=DREAL(Z(1))
        XMIN=DREAL(Z(1))
        YMAX=DIMAG(Z(1))
        YMIN=DIMAG(Z(1))
        DO J=2,MN
          X=DREAL(Z(J))
          Y=DIMAG(Z(J))
          IF(X.GT.XMAX)XMAX=X
          IF(X.LT.XMIN)XMIN=X
          IF(Y.GT.YMAX)YMAX=Y
          IF(Y.GT.YMIN)YMIN=Y
        ENDDO
        SCALE=DSQRT((XMAX-XMIN)*(XMAX-XMIN)+(YMAX-YMIN)*(YMAX-YMIN))
        Z(MN+1)=Z(1)
        ERROR=0D0
        DO K=1,N
          Z0=Z((K-1)*M+1)
          ZROT=Z(K*M+1)-Z0
          AZROT=CDABS(ZROT)
          IF(AZROT.GE.1D-20)THEN
            ZF=AZROT/(ZROT*SCALE)
            DO J=2,M-1
              ET=DABS(DIMAG((Z((K-1)*M+J)-Z0)*ZF))
              IF(ET.GT.ERROR)ERROR=ET
            ENDDO
          ENDIF
        ENDDO
        WRITE(*,*)'ESTIMATE OF RELATIVE ERROR=',ERROR
      ENDIF
      RETURN
      END
C
C COMPUTES MAP FROM OPEN DISK TO REGION AT VECTOR Z
C
      SUBROUTINE EVAL(MM)
      IMPLICIT DOUBLE PRECISION(A-H,O-Y),INTEGER*4(I-N),COMPLEX*16(Z)
      COMMON Z(120001),A(120001),B(120001),C(120001),Z1,Z2,Z3,ZROT1,
     & ZTO0,ZTO1,ANGLER,ZROT2,M,N
      PI=3.14159265358979324D0
      TPI=2D0*PI
C-------MAP TO SECTOR OF CIRCLE--------------------------------------
      ZI=DCMPLX(0D0,1D0)
      ZTO0C=DCONJG(ZTO0)
      ANGLE=1D0/ANGLER
      Z1ROT=ZI**ANGLE
      DO J=1,MM
        ZM=Z(J)-1D0
        IF(CDABS(ZM).LT.1D-14)THEN
          ZT=1D30
          ZT=ZT*Z1ROT
        ELSE
          ZT=ZI*(ZTO0-Z(J)*ZTO0C)/ZM
          ZT=Z1ROT*(ZT**ANGLE)
        ENDIF
        Z(J)=ZT/(ZROT2+ZT/ZTO1)
      ENDDO
C---PUSH UP CURVE-----------------------------------------------------
      DO K=N-2,4,-2
        AA=A(K)
        ZROTA=CDEXP(DCMPLX(0D0,TPI*AA))
        BB=1D0/B(K)
        CC=C(K)*BB
        DO J=1,MM
          ZMA=Z(J)-AA
          ZMAP=ZMA+1D0
C 9-13-2009 CHANGED 1D-14 TO 1D-28
          IF(CDABS(ZMA*ZMAP).LT.1D-28)THEN
            ZT=0D0
          ELSE
            ZR=ZMA/ZMAP
            ZFR=ZR**AA
C GET THE BRANCH RIGHT:
            IF(DIMAG(ZFR).LT.0D0)THEN
              IF(DREAL(ZR).LT.0D0)ZFR=ZFR*ZROTA
            ENDIF
            ZT=ZMAP*ZFR
          ENDIF
          Z(J)=ZT/(BB-CC*ZT)
        ENDDO
      ENDDO
C-----MAP UPPER HALF PLANE TO COMPLEMENT OF CIRCULAR ARC---------------
      DO J=1,MM
        ZT=-Z(J)*Z(J)/ZROT1
        Z(J)=(Z3-Z1*ZT)/(1D0-ZT)
      ENDDO
      RETURN
      END
C COMPUTES MAP FROM REGION TO DISK AND FINDS INVERSE IMAGE OF VERTICES.
C Z(N+1) MAPPED TO 0, Z(1) MAPPED TO 1
      SUBROUTINE INVERS
      IMPLICIT DOUBLE PRECISION(A-H,O-Y),INTEGER*4(I-N),COMPLEX*16(Z)
      COMMON Z(120001),A(120001),B(120001),C(120001),Z1,Z2,Z3,ZROT1,
     & ZTO0,ZTO1,ANGLER,ZROT2,N
      PI=3.14159265358979324D0
      ACC=1D-14
C ACC SHOULD BE AT LEAST MACHINE EPS **.75
      ACCR=1D14
      ZI=DCMPLX(0D0,1D0)
C-----MAP COMPLEMENT OF ARC OF CIRCLE THROUGH Z(1),Z(2),Z(3) TO THE
C-----UPPER HALF PLANE-------------------------------------------------
C-----------------------------------------------------------------------
      Z1=Z(1)
      Z2=Z(2)
      Z3=Z(3)
      ZROT1=(Z(1)-Z(2))/(Z(2)-Z(3))
      DO J=4,N+1
        Z(J)=ZI*CDSQRT(ZROT1*(Z(J)-Z(3))/(Z(J)-Z(1)))
      ENDDO
      Z(1)=DCMPLX(-1D20,0D0)
      Z(2)=DCMPLX(-1D0,0D0)
      Z(3)=DCMPLX(0D0,0D0)
C ABS(W) GT R1*LENGTH OF SLIT WILL BE OUTER REGION
      R1=1.125D0
C RADIUS OF REGION AROUND TIP=R2*YTIP
      R2=.25D0
C-------------PULL BACK CURVE----------------------------------
      DO J=4,N-2,2
        Z1RC=DCONJG(1D0/Z(J))
        Z2R=1D0/Z(J+1)
        B1=-DIMAG(Z1RC*Z2R)/DIMAG(Z1RC+Z2R)
        ZT=Z2R+B1
        PIA=-DATAN2(DIMAG(ZT),DREAL(ZT))
        A(J)=PIA/PI
        AA=A(J)
        OMA=1D0-AA
        OMAR=1D0/OMA
        AZT=CDABS(ZT)
        XL=(AA**AA)*(OMA**OMA)
        B(J)=1D0/(XL*AZT)
        C(J)=B1*B(J)
        AR=1D0/AA
        ZANGC=CDEXP(DCMPLX(0D0,-PIA))
        ZROTA=ZANGC*ZANGC
        X=XL*DREAL(ZANGC)
        Y=-XL*DIMAG(ZANGC)
        ZTIP=DCMPLX(X,Y)
        RR1=1D0/(R1*XL)
        RR2=R2*Y
        A0=AA-OMA
        C2=-2D0*A0/3D0
        A1=AA*OMA/2D0
        C1=4D0*A1
        A2=C2*A1
        ZC1=DCMPLX(0D0,DSQRT(C1))
        DO K=J+2,N+1
          ZWR=C(J)+B(J)/Z(K)
          XLZW=CDABS(ZWR)
          IF(XLZW.LT.RR1)THEN
            ZT=1D0+(A0+(A1+A2*ZWR)*ZWR)*ZWR
            CALL NEWTON(ZWR,AA,ZT,ZROTA)
          ELSE
            ZW=1D0/ZWR
            XZW=DREAL(ZW)
            YZW=DIMAG(ZW)
            IF(CDABS(ZW-ZTIP).LT.RR2)THEN
              ZWI=CDSQRT(ZW/ZTIP-1D0)
C TO BE SURE OF BRANCH:
              IF(DREAL(ZWI).LT.1D-4)THEN
                IF(DIMAG(ZWI).LT.0D0)THEN
                  ZWI=-ZWI
                ENDIF
              ENDIF
              ZT=(ZC1+C2*ZWI)*ZWI
              CALL NEWT1(ZWI,AA,C1,ZT,ZROTA)
            ELSEIF(XLZW.GT.ACCR)THEN
              ZT=-OMA
            ELSEIF(DATAN2(YZW,XZW).GE.PIA)THEN
              ZWT=(ZANGC*ZW)**OMAR
              ZT=-OMA+ZWT
              TEST=CDABS(ZWT)
              TEST=TEST*TEST
              IF(TEST.GE.ACC)THEN
                ZT=ZT*ZWR
                CALL NEWTON(ZWR,AA,ZT,ZROTA)
              ENDIF
            ELSE
              ZWT=ZW**AR
              ZT=AA+ZWT
              TEST=CDABS(ZWT)
              TEST=TEST*TEST
              IF(TEST.GE.ACC)THEN
                ZT=ZT*ZWR
                CALL NEWTON(ZWR,AA,ZT,ZROTA)
              ENDIF
            ENDIF
          ENDIF
          Z(K)=ZT
        ENDDO
        Z(J+1)=DCMPLX(0D0,0D0)
        Z(J-1)=DCMPLX(AA-1D0,0D0)
        ZWR=C(J)+B(J)/Z(J)
        ZW=1D0/ZWR
        IF(CDABS(ZW-ZTIP).LT.RR2)THEN
          ZWI=DCMPLX(0D0,DSQRT(DREAL(1D0-ZW/ZTIP)))
          ZT=(ZC1+C2*ZWI)*ZWI
          CALL NEWT1(ZWI,AA,C1,ZT,ZROTA)
        ELSEIF(CDABS(ZWR).GT.ACCR)THEN
          ZT=-OMA
        ELSE
          ZWT=(ZANGC*ZW)**OMAR
          ZT=-OMA+ZWT
          TEST=CDABS(ZWT)
          TEST=TEST*TEST
          IF(TEST.GE.ACC)THEN
            ZT=ZT*ZWR
            CALL NEWTON(ZWR,AA,ZT,ZROTA)
          ENDIF
        ENDIF
        Z(J)=ZT
        DO K=1,J-2
          XW=DREAL(Z(K))
          XWR=C(J)+B(J)/XW
          XLZW=DABS(XWR)
          IF(XLZW.LT.RR1)THEN
            XT=1D0+(A0+(A1+A2*XWR)*XWR)*XWR
            CALL RNEWT(XWR,AA,XT)
          ELSE
            XW=1D0/XWR
            IF(XLZW**OMAR.GT.ACCR)THEN
              XT=-OMA
            ELSEIF(XW.LE.0D0)THEN
              XWT=-(-XW)**OMAR
              XT=-OMA+XWT
              TEST=XT*XT
              IF(TEST.GE.ACC)THEN
                XT=XT*XWR
                CALL RNEWT(XWR,AA,XT)
              ENDIF
            ELSE
              XWT=XW**AR
              XT=AA+XWT
              TEST=XWT*XWT
              IF(TEST.GE.ACC)THEN
                XT=XT*XWR
                CALL RNEWT(XWR,AA,XT)
              ENDIF
            ENDIF
          ENDIF
          Z(K)=DCMPLX(XT,0D0)
        ENDDO
      ENDDO
      Z(N-1)=DCMPLX(0D0,0D0)
C------------- MAP CIRCULAR SECTOR TO DISK---------------------------
      ZROT2=1D0/Z(N)-1D0/Z(1)
      ZTO1=Z(1)
      ANGLER=PI/DATAN2(DIMAG(-ZROT2),DREAL(-ZROT2))
      ZTO0=(Z(N+1)*ZROT2/(1D0-Z(N+1)/Z(1)))**ANGLER
      ZTO0C=DCONJG(ZTO0)
      DO J=2,N-2
        ZT=(Z(J)*ZROT2/(1D0-Z(J)/Z(1)))**ANGLER
        Z(J)=(ZT-ZTO0)/(ZT-ZTO0C)
      ENDDO
      Z(N-1)=ZTO0/ZTO0C
      ZT=(Z(N)*ZROT2/(1D0-Z(N)/Z(1)))**ANGLER
      Z(N)=(ZT-ZTO0)/(ZT-ZTO0C)
      Z(1)=DCMPLX(1D0,0D0)
      Z(N+1)=DCMPLX(0D0,0D0)
      RETURN
      END
C VERSION OF NEWTON'S METHOD (UPPER-HALF PLANE) NEAR TIP
C ITERATING ON Z
      SUBROUTINE NEWT1(ZWI,AA,C1,Z,ZROTA)
      IMPLICIT DOUBLE PRECISION(A-H,O-Y),INTEGER*4(I-N),COMPLEX*16(Z)
      ACC=1D-14
C ACC SHOULD BE AT LEAST MACHINE EPS **.75
      OMA=1D0-AA
      DO I=1,20
        Z1=1D0-Z/AA
        Z2=1D0+Z/OMA
        ZR=Z1/Z2
        ZFR=ZR**AA
C ANALYTIC CONTINUATION ACROSS SLIT:
        IF(DIMAG(ZFR).GT.0D0)THEN
          IF(DREAL(ZR).LT.0D0)ZFR=ZFR*ZROTA
          Z3=CDSQRT(ZFR*Z2-1D0)
          IF(DREAL(ZR).GT.0D0)Z3=-Z3
        ELSE
          Z3=CDSQRT(ZFR*Z2-1D0)
        ENDIF
        ZFCN=Z3-ZWI
        ZQ=Z3/Z
        ZD=ZQ*C1*Z1*ZFCN/ZFR
        Z=Z+ZD
        TEST=CDABS(ZD)
        IF(TEST.LT.ACC)RETURN
      ENDDO
      WRITE(*,*)'MORE THAN 20 ITERATIONS REQUIRED IN NEWT1'
      WRITE(*,*)'ZWI=',ZWI,' Z=',Z,' TEST=',TEST,' A=',AA
      RETURN
      END
C VERSION OF NEWTON'S METHOD (UPPER-HALF PLANE)
C ITERATING ON Z/W
      SUBROUTINE NEWTON(ZWR,AA,Z,ZROTA)
      IMPLICIT DOUBLE PRECISION(A-H,O-Y),INTEGER*4(I-N),COMPLEX*16(Z)
      ACC=1D-14
C ACC SHOULD BE AT LEAST MACHINE EPS **.75
      ZB1=-AA*ZWR
      ZB2=ZB1+ZWR
      DO I=1,20
        ZMA=Z+ZB1
        ZMAP=Z+ZB2
        ZR=ZMAP/ZMA
        ZFR=ZR**AA
        IF(DIMAG(ZFR).GT.0D0)THEN
          IF(DREAL(ZR).LT.0D0)ZFR=ZFR*ZROTA
        ENDIF
        ZD=(ZFR-ZMAP)*ZMA/Z
        Z=Z+ZD
        TEST=CDABS(ZD)
        IF(TEST.LT.ACC)GOTO 100
      ENDDO
      WRITE(*,*)'MORE THAN 20 ITERATIONS REQUIRED IN NEWTON'
      ZW=1D0/ZWR
      WRITE(*,*)'ZW=',ZW
      WRITE(*,*)'Z =',Z
      WRITE(*,*)'TEST=',TEST
      WRITE(*,*)'A=',AA
  100 Z=Z/ZWR
      RETURN
      END
C VERSION OF NEWTON'S METHOD (UPPER-HALF PLANE)
C ITERATING ON X/W  (XWR=1/W) -- REAL ARITHMETIC
C X=OUTPUT AND INITIAL GUESS
      SUBROUTINE RNEWT(XWR,AA,X)
      IMPLICIT DOUBLE PRECISION(A-H,O-Y),INTEGER*4(I-N),COMPLEX*16(Z)
      ACC=1D-14
C ACC SHOULD BE AT LEAST MACHINE EPS **.75
      XB1=-AA*XWR
      XB2=XB1+XWR
      DO I=1,20
        XMA=X+XB1
        XMAP=X+XB2
        XFRACT=(XMAP/XMA)**AA
        XD=(XFRACT-XMAP)*XMA/X
        X=X+XD
        TEST=DABS(XD)
        IF(TEST.LT.ACC)GOTO 100
      ENDDO
      WRITE(*,*)'MORE THAN 20 ITERATIONS REQUIRED IN RNEWT'
      WRITE(*,*)'XWR=',XWR,' A=',AA,' X=',X,' TEST=',TEST
  100 X=X/XWR
      RETURN
      END
